"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const qwik = require("@builder.io/qwik");
const jsxRuntime = require("@builder.io/qwik/jsx-runtime");
const build = require("@builder.io/qwik/build");
const EMPTY_HTML_ELEMENTS = /* @__PURE__ */ new Set([
  "area",
  "base",
  "br",
  "col",
  "embed",
  "hr",
  "img",
  "input",
  "keygen",
  "link",
  "meta",
  "param",
  "source",
  "track",
  "wbr"
]);
const isEmptyElement = (tagName) => {
  return typeof tagName === "string" && EMPTY_HTML_ELEMENTS.has(tagName.toLowerCase());
};
const DynamicRenderer = /* @__PURE__ */ qwik.componentQrl(/* @__PURE__ */ qwik.inlinedQrl((props) => {
  qwik._jsxBranch();
  return /* @__PURE__ */ qwik._jsxC(jsxRuntime.Fragment, {
    children: !isEmptyElement(props.TagName) ? typeof props.TagName === "string" ? /* @__PURE__ */ qwik._jsxC(props.TagName, {
      ...props.attributes,
      ...props.actionAttributes,
      children: /* @__PURE__ */ qwik._jsxC(qwik.Slot, null, 3, "yW_0")
    }, 0, "yW_1") : /* @__PURE__ */ qwik._jsxC(props.TagName, {
      ...props.attributes,
      ...props.actionAttributes,
      children: /* @__PURE__ */ qwik._jsxC(qwik.Slot, null, 3, "yW_2")
    }, 0, "yW_3") : /* @__PURE__ */ qwik._jsxC(props.TagName, {
      ...props.attributes,
      ...props.actionAttributes
    }, 0, "yW_4")
  }, 1, "yW_5");
}, "DynamicRenderer_component_1Co0xkmyAfQ"));
const TARGET = "qwik";
const getClassPropName = () => {
  switch (TARGET) {
    case "react":
    case "reactNative":
    case "rsc":
      return "className";
    case "svelte":
    case "vue":
    case "solid":
    case "qwik":
    case "angular":
      return "class";
  }
};
const attrs = function attrs2(props, state) {
  return {
    ...props.attributes,
    [getClassPropName()]: `${props.link ? "" : "builder-button"} ${props.attributes[getClassPropName()] || ""}`,
    ...props.link ? {
      href: props.link,
      target: props.openLinkInNewTab ? "_blank" : void 0,
      role: "link"
    } : {
      role: "button"
    }
  };
};
const Button = /* @__PURE__ */ qwik.componentQrl(/* @__PURE__ */ qwik.inlinedQrl((props) => {
  return /* @__PURE__ */ qwik._jsxC(DynamicRenderer, {
    attributes: attrs(props),
    get TagName() {
      return props.link ? props.builderLinkComponent || "a" : "button";
    },
    actionAttributes: {},
    children: qwik._fnSignal((p0) => p0.text, [
      props
    ], "p0.text"),
    [qwik._IMMUTABLE]: {
      TagName: qwik._fnSignal((p0) => p0.link ? p0.builderLinkComponent || "a" : "button", [
        props
      ], 'p0.link?p0.builderLinkComponent||"a":"button"'),
      actionAttributes: qwik._IMMUTABLE
    }
  }, 3, "jc_0");
}, "Button_component_gJoMUICXoUQ"));
const builderContext = qwik.createContextId("Builder");
const ComponentsContext = qwik.createContextId("Components");
function getBlockComponentOptions(block) {
  var _a;
  return {
    ...(_a = block.component) == null ? void 0 : _a.options,
    ...block.options,
    /**
    * Our built-in components frequently make use of the block, so we provide all of it under `builderBlock`
    */
    builderBlock: block
  };
}
const MSG_PREFIX = "[Builder.io]: ";
const logger = {
  log: (...message) => console.log(MSG_PREFIX, ...message),
  error: (...message) => console.error(MSG_PREFIX, ...message),
  warn: (...message) => console.warn(MSG_PREFIX, ...message),
  debug: (...message) => console.debug(MSG_PREFIX, ...message)
};
function isBrowser() {
  return typeof window !== "undefined" && typeof document !== "undefined";
}
const convertSearchParamsToQueryObject = (searchParams) => {
  const options = {};
  searchParams.forEach((value, key) => {
    options[key] = value;
  });
  return options;
};
const normalizeSearchParams = (searchParams) => searchParams instanceof URLSearchParams ? convertSearchParamsToQueryObject(searchParams) : searchParams;
const getSearchString = (search) => {
  if (typeof search === "string")
    return search;
  else if (search instanceof URLSearchParams)
    return search.toString();
  return new URLSearchParams(search).toString();
};
function isIframe() {
  return isBrowser() && window.self !== window.top;
}
function isEditing(search) {
  return isIframe() && // accessing window.location.search is safe here because `isIframe()` is only `true` if we're in a browser.
  getSearchString(search || window.location.search).indexOf("builder.frameEditing=") !== -1;
}
const getLocation = () => {
  if (isBrowser()) {
    const parsedLocation = new URL(location.href);
    if (parsedLocation.pathname === "")
      parsedLocation.pathname = "/";
    return parsedLocation;
  } else {
    console.warn("Cannot get location for tracking in non-browser environment");
    return null;
  }
};
const getUserAgent = () => typeof navigator === "object" && navigator.userAgent || "";
const getUserAttributes = () => {
  const userAgent = getUserAgent();
  const isMobile = {
    Android() {
      return userAgent.match(/Android/i);
    },
    BlackBerry() {
      return userAgent.match(/BlackBerry/i);
    },
    iOS() {
      return userAgent.match(/iPhone|iPod/i);
    },
    Opera() {
      return userAgent.match(/Opera Mini/i);
    },
    Windows() {
      return userAgent.match(/IEMobile/i) || userAgent.match(/WPDesktop/i);
    },
    any() {
      return isMobile.Android() || isMobile.BlackBerry() || isMobile.iOS() || isMobile.Opera() || isMobile.Windows() || TARGET === "reactNative";
    }
  };
  const isTablet = userAgent.match(/Tablet|iPad/i);
  const url = getLocation();
  return {
    urlPath: url == null ? void 0 : url.pathname,
    host: (url == null ? void 0 : url.host) || (url == null ? void 0 : url.hostname),
    device: isTablet ? "tablet" : isMobile.any() ? "mobile" : "desktop"
  };
};
const getFunctionArguments = ({ builder, context, event, state }) => {
  return Object.entries({
    state,
    Builder: builder,
    // legacy
    builder,
    context,
    event
  });
};
const getBuilderGlobals = () => ({
  isEditing: isEditing(),
  isBrowser: isBrowser(),
  isServer: !isBrowser(),
  getUserAttributes: () => getUserAttributes()
});
const parseCode = (code, { isExpression = true }) => {
  const useReturn = (
    // we disable this for cases where we definitely don't want a return
    isExpression && !(code.includes(";") || code.includes(" return ") || code.trim().startsWith("return "))
  );
  const useCode = useReturn ? `return (${code});` : code;
  return useCode;
};
const runInBrowser = ({ code, builder, context, event, localState, rootSetState, rootState }) => {
  const functionArgs = getFunctionArguments({
    builder,
    context,
    event,
    state: flattenState({
      rootState,
      localState,
      rootSetState
    })
  });
  return new Function(...functionArgs.map(([name]) => name), code)(...functionArgs.map(([, value]) => value));
};
function flattenState({ rootState, localState, rootSetState }) {
  return new Proxy(rootState, {
    get: (target, prop) => {
      if (localState && prop in localState)
        return localState[prop];
      const val = target[prop];
      if (typeof val === "object" && val !== null)
        return flattenState({
          rootState: val,
          localState: void 0,
          rootSetState: rootSetState ? (subState) => {
            target[prop] = subState;
            rootSetState(target);
          } : void 0
        });
      return val;
    },
    set: (target, prop, value) => {
      if (localState && prop in localState)
        throw new Error("Writing to local state is not allowed as it is read-only.");
      target[prop] = value;
      rootSetState == null ? void 0 : rootSetState(target);
      return true;
    }
  });
}
const checkIsDefined = (maybeT) => maybeT !== null && maybeT !== void 0;
function isNodeRuntime() {
  var _a;
  return typeof process !== "undefined" && checkIsDefined((_a = process == null ? void 0 : process.versions) == null ? void 0 : _a.node);
}
const shouldForceBrowserRuntimeInNode = () => {
  var _a;
  if (!isNodeRuntime())
    return false;
  const isArm64 = process.arch === "arm64";
  const isNode20 = process.version.startsWith("v20");
  const hasNoNodeSnapshotNodeOption = (_a = process.env.NODE_OPTIONS) == null ? void 0 : _a.includes("--no-node-snapshot");
  if (isArm64 && isNode20 && !hasNoNodeSnapshotNodeOption) {
    logger.log(`Skipping usage of \`isolated-vm\` to avoid crashes in Node v20 on an arm64 machine.
    If you would like to use the \`isolated-vm\` package on this machine, please provide the \`NODE_OPTIONS=--no-node-snapshot\` config to your Node process.
    See https://github.com/BuilderIO/builder/blob/main/packages/sdks/README.md#node-v20--m1-macs-apple-silicon-support for more information.
    `);
    return true;
  }
  return false;
};
const chooseBrowserOrServerEval = (args) => build.isBrowser || shouldForceBrowserRuntimeInNode() ? runInBrowser(args) : runInBrowser(args);
const _EvalCache = class _EvalCache2 {
  static getCacheKey(args) {
    return JSON.stringify({
      ...args,
      // replace the event with a random number to break cache
      // thats because we can't serialize the event object due to circular refs in DOM node refs.
      event: args.event ? Math.random() : void 0
    });
  }
  static getCachedValue(key) {
    const cachedVal = _EvalCache2.cache.get(key);
    return cachedVal;
  }
  static setCachedValue(key, value) {
    if (_EvalCache2.cache.size > 20)
      _EvalCache2.cache.delete(_EvalCache2.cache.keys().next().value);
    _EvalCache2.cache.set(key, {
      value
    });
  }
};
_EvalCache.cacheLimit = 20;
_EvalCache.cache = /* @__PURE__ */ new Map();
let EvalCache = _EvalCache;
function evaluate({ code, context, localState, rootState, rootSetState, event, isExpression = true, enableCache }) {
  if (code === "")
    return void 0;
  const args = {
    code: parseCode(code, {
      isExpression
    }),
    builder: getBuilderGlobals(),
    context,
    event,
    rootSetState,
    rootState,
    localState
  };
  if (enableCache) {
    const cacheKey = EvalCache.getCacheKey(args);
    const cachedValue = EvalCache.getCachedValue(cacheKey);
    if (cachedValue)
      return cachedValue.value;
  }
  try {
    const newEval = chooseBrowserOrServerEval(args);
    if (enableCache) {
      const cacheKey = EvalCache.getCacheKey(args);
      EvalCache.setCachedValue(cacheKey, newEval);
    }
    return newEval;
  } catch (e) {
    logger.error("Failed code evaluation: " + e.message, {
      code
    });
    return void 0;
  }
}
const fastClone = (obj) => JSON.parse(JSON.stringify(obj));
const set = (obj, _path, value) => {
  if (Object(obj) !== obj)
    return obj;
  const path = Array.isArray(_path) ? _path : _path.toString().match(/[^.[\]]+/g);
  path.slice(0, -1).reduce((a, c, i) => Object(a[c]) === a[c] ? a[c] : a[c] = Math.abs(Number(path[i + 1])) >> 0 === +path[i + 1] ? [] : {}, obj)[path[path.length - 1]] = value;
  return obj;
};
function transformBlock(block) {
  return block;
}
const evaluateBindings = ({ block, context, localState, rootState, rootSetState }) => {
  if (!block.bindings)
    return block;
  const copy = fastClone(block);
  const copied = {
    ...copy,
    properties: {
      ...copy.properties
    },
    actions: {
      ...copy.actions
    }
  };
  for (const binding in block.bindings) {
    const expression = block.bindings[binding];
    const value = evaluate({
      code: expression,
      localState,
      rootState,
      rootSetState,
      context,
      enableCache: true
    });
    set(copied, binding, value);
  }
  return copied;
};
function getProcessedBlock({ block, context, shouldEvaluateBindings, localState, rootState, rootSetState }) {
  const transformedBlock = transformBlock(block);
  if (shouldEvaluateBindings)
    return evaluateBindings({
      block: transformedBlock,
      localState,
      rootState,
      rootSetState,
      context
    });
  else
    return transformedBlock;
}
const camelToKebabCase = (str) => str ? str.replace(/([a-z0-9]|(?=[A-Z]))([A-Z])/g, "$1-$2").toLowerCase() : "";
function throttle(func, wait, options = {}) {
  let context;
  let args;
  let result;
  let timeout = null;
  let previous = 0;
  const later = function() {
    previous = options.leading === false ? 0 : Date.now();
    timeout = null;
    result = func.apply(context, args);
    if (!timeout)
      context = args = null;
  };
  return function() {
    const now = Date.now();
    if (!previous && options.leading === false)
      previous = now;
    const remaining = wait - (now - previous);
    context = this;
    args = arguments;
    if (remaining <= 0 || remaining > wait) {
      if (timeout) {
        clearTimeout(timeout);
        timeout = null;
      }
      previous = now;
      result = func.apply(context, args);
      if (!timeout)
        context = args = null;
    } else if (!timeout && options.trailing !== false)
      timeout = setTimeout(later, remaining);
    return result;
  };
}
function assign(target, ..._args) {
  const to = Object(target);
  for (let index = 1; index < arguments.length; index++) {
    const nextSource = arguments[index];
    if (nextSource != null) {
      for (const nextKey in nextSource)
        if (Object.prototype.hasOwnProperty.call(nextSource, nextKey))
          to[nextKey] = nextSource[nextKey];
    }
  }
  return to;
}
function bindAnimations(animations) {
  for (const animation of animations)
    switch (animation.trigger) {
      case "pageLoad":
        triggerAnimation(animation);
        break;
      case "scrollInView":
        bindScrollInViewAnimation(animation);
        break;
    }
}
function warnElementNotPresent(id) {
  console.warn(`Cannot animate element: element with ID ${id} not found!`);
}
function augmentAnimation(animation, element) {
  const stylesUsed = getAllStylesUsed(animation);
  const computedStyle = getComputedStyle(element);
  const firstStyles = animation.steps[0].styles;
  const lastStyles = animation.steps[animation.steps.length - 1].styles;
  const bothStyles = [
    firstStyles,
    lastStyles
  ];
  for (const styles of bothStyles) {
    for (const style of stylesUsed)
      if (!(style in styles))
        styles[style] = computedStyle[style];
  }
}
function getAllStylesUsed(animation) {
  const properties = [];
  for (const step of animation.steps) {
    for (const key in step.styles)
      if (properties.indexOf(key) === -1)
        properties.push(key);
  }
  return properties;
}
function triggerAnimation(animation) {
  const elements = Array.prototype.slice.call(document.getElementsByClassName(animation.elementId || animation.id || ""));
  if (!elements.length) {
    warnElementNotPresent(animation.elementId || animation.id || "");
    return;
  }
  Array.from(elements).forEach((element) => {
    augmentAnimation(animation, element);
    element.style.transition = "none";
    element.style.transitionDelay = "0";
    assign(element.style, animation.steps[0].styles);
    setTimeout(() => {
      element.style.transition = `all ${animation.duration}s ${camelToKebabCase(animation.easing)}`;
      if (animation.delay)
        element.style.transitionDelay = animation.delay + "s";
      assign(element.style, animation.steps[1].styles);
      setTimeout(() => {
        element.style.transition = "";
        element.style.transitionDelay = "";
      }, (animation.delay || 0) * 1e3 + animation.duration * 1e3 + 100);
    });
  });
}
function bindScrollInViewAnimation(animation) {
  const elements = Array.prototype.slice.call(document.getElementsByClassName(animation.elementId || animation.id || ""));
  if (!elements.length) {
    warnElementNotPresent(animation.elementId || animation.id || "");
    return;
  }
  Array.from(elements).forEach((element) => {
    augmentAnimation(animation, element);
    let triggered = false;
    let pendingAnimation = false;
    function immediateOnScroll() {
      if (!triggered && isScrolledIntoView(element)) {
        triggered = true;
        pendingAnimation = true;
        setTimeout(() => {
          assign(element.style, animation.steps[1].styles);
          if (!animation.repeat)
            document.removeEventListener("scroll", onScroll);
          setTimeout(() => {
            pendingAnimation = false;
            if (!animation.repeat) {
              element.style.transition = "";
              element.style.transitionDelay = "";
            }
          }, (animation.duration + (animation.delay || 0)) * 1e3 + 100);
        });
      } else if (animation.repeat && triggered && !pendingAnimation && !isScrolledIntoView(element)) {
        triggered = false;
        assign(element.style, animation.steps[0].styles);
      }
    }
    const onScroll = throttle(immediateOnScroll, 200, {
      leading: false
    });
    function isScrolledIntoView(elem) {
      const rect = elem.getBoundingClientRect();
      const windowHeight = window.innerHeight;
      const thresholdPercent = (animation.thresholdPercent || 0) / 100;
      const threshold = thresholdPercent * windowHeight;
      return rect.bottom > threshold && rect.top < windowHeight - threshold;
    }
    const defaultState = animation.steps[0].styles;
    function attachDefaultState() {
      assign(element.style, defaultState);
    }
    attachDefaultState();
    setTimeout(() => {
      element.style.transition = `all ${animation.duration}s ${camelToKebabCase(animation.easing)}`;
      if (animation.delay)
        element.style.transitionDelay = animation.delay + "s";
    });
    document.addEventListener("scroll", onScroll, {
      capture: true,
      passive: true
    });
    immediateOnScroll();
  });
}
const convertStyleMapToCSSArray = (style) => {
  const cssProps = Object.entries(style).map(([key, value]) => {
    if (typeof value === "string")
      return `${camelToKebabCase(key)}: ${value};`;
    else
      return void 0;
  });
  return cssProps.filter(checkIsDefined);
};
const convertStyleMapToCSS = (style) => convertStyleMapToCSSArray(style).join("\n");
const createCssClass = ({ mediaQuery, className, styles }) => {
  const cssClass = `.${className} {
    ${convertStyleMapToCSS(styles)}
  }`;
  if (mediaQuery)
    return `${mediaQuery} {
      ${cssClass}
    }`;
  else
    return cssClass;
};
function transformStyleProperty({ style }) {
  return style;
}
const getStyle = ({ block, context }) => {
  return mapStyleObjToStrIfNeeded(transformStyleProperty({
    style: block.style || {},
    context,
    block
  }));
};
function mapStyleObjToStrIfNeeded(style) {
  switch (TARGET) {
    case "svelte":
    case "vue":
    case "solid":
    case "angular":
      return convertStyleMapToCSSArray(style).join(" ");
    case "qwik":
    case "reactNative":
    case "react":
    case "rsc":
      return style;
  }
}
const getComponent = ({ block, context, registeredComponents }) => {
  var _a;
  const componentName = (_a = getProcessedBlock({
    block,
    localState: context.localState,
    rootState: context.rootState,
    rootSetState: context.rootSetState,
    context: context.context,
    shouldEvaluateBindings: false
  }).component) == null ? void 0 : _a.name;
  if (!componentName)
    return null;
  const ref = registeredComponents[componentName];
  if (!ref) {
    console.warn(`
      Could not find a registered component named "${componentName}". 
      If you registered it, is the file that registered it imported by the file that needs to render it?`);
    return void 0;
  } else
    return ref;
};
const getRepeatItemData = ({ block, context }) => {
  const { repeat, ...blockWithoutRepeat } = block;
  if (!(repeat == null ? void 0 : repeat.collection))
    return void 0;
  const itemsArray = evaluate({
    code: repeat.collection,
    localState: context.localState,
    rootState: context.rootState,
    rootSetState: context.rootSetState,
    context: context.context,
    enableCache: true
  });
  if (!Array.isArray(itemsArray))
    return void 0;
  const collectionName = repeat.collection.split(".").pop();
  const itemNameToUse = repeat.itemName || (collectionName ? collectionName + "Item" : "item");
  const repeatArray = itemsArray.map((item, index) => ({
    context: {
      ...context,
      localState: {
        ...context.localState,
        $index: index,
        $item: item,
        [itemNameToUse]: item,
        [`$${itemNameToUse}Index`]: index
      }
    },
    block: blockWithoutRepeat
  }));
  return repeatArray;
};
const shouldPassLinkComponent = (block) => {
  return block && (block.isRSC || [
    "Core:Button",
    "Symbol",
    "Columns",
    "Form:Form",
    "Builder: Tabs",
    "Builder:Accordion"
  ].includes(block.name));
};
const shouldPassRegisteredComponents = (block) => {
  return block && (block.isRSC || [
    "Symbol",
    "Columns",
    "Form:Form",
    "Builder: Tabs",
    "Builder:Accordion"
  ].includes(block.name));
};
const SIZES = {
  small: {
    min: 320,
    default: 321,
    max: 640
  },
  medium: {
    min: 641,
    default: 642,
    max: 991
  },
  large: {
    min: 990,
    default: 991,
    max: 1200
  }
};
const getMaxWidthQueryForSize = (size, sizeValues = SIZES) => `@media (max-width: ${sizeValues[size].max}px)`;
const getSizesForBreakpoints = ({ small, medium }) => {
  const newSizes = fastClone(SIZES);
  if (!small || !medium)
    return newSizes;
  const smallMin = Math.floor(small / 2);
  newSizes.small = {
    max: small,
    min: smallMin,
    default: smallMin + 1
  };
  const mediumMin = newSizes.small.max + 1;
  newSizes.medium = {
    max: medium,
    min: mediumMin,
    default: mediumMin + 1
  };
  const largeMin = newSizes.medium.max + 1;
  newSizes.large = {
    max: 2e3,
    // TODO: decide upper limit
    min: largeMin,
    default: largeMin + 1
  };
  return newSizes;
};
const InlinedStyles = /* @__PURE__ */ qwik.componentQrl(/* @__PURE__ */ qwik.inlinedQrl((props) => {
  return /* @__PURE__ */ qwik._jsxQ("style", null, {
    dangerouslySetInnerHTML: qwik._fnSignal((p0) => p0.styles, [
      props
    ], "p0.styles"),
    "data-id": qwik._fnSignal((p0) => p0.id, [
      props
    ], "p0.id")
  }, null, 3, "NG_0");
}, "InlinedStyles_component_IOsg46hMexk"));
const BlockStyles = /* @__PURE__ */ qwik.componentQrl(/* @__PURE__ */ qwik.inlinedQrl((props) => {
  qwik._jsxBranch();
  const canShowBlock = qwik.useComputedQrl(/* @__PURE__ */ qwik.inlinedQrl(() => {
    const [props2] = qwik.useLexicalScope();
    const processedBlock = getProcessedBlock({
      block: props2.block,
      localState: props2.context.localState,
      rootState: props2.context.rootState,
      rootSetState: props2.context.rootSetState,
      context: props2.context.context,
      shouldEvaluateBindings: true
    });
    if (checkIsDefined(processedBlock.hide))
      return !processedBlock.hide;
    if (checkIsDefined(processedBlock.show))
      return processedBlock.show;
    return true;
  }, "BlockStyles_component_canShowBlock_useComputed_YHoS9Lak9z4", [
    props
  ]));
  const css = qwik.useComputedQrl(/* @__PURE__ */ qwik.inlinedQrl(() => {
    var _a, _b, _c;
    const [props2] = qwik.useLexicalScope();
    const processedBlock = getProcessedBlock({
      block: props2.block,
      localState: props2.context.localState,
      rootState: props2.context.rootState,
      rootSetState: props2.context.rootSetState,
      context: props2.context.context,
      shouldEvaluateBindings: true
    });
    const styles = processedBlock.responsiveStyles;
    const content = props2.context.content;
    const sizesWithUpdatedBreakpoints = getSizesForBreakpoints(((_a = content == null ? void 0 : content.meta) == null ? void 0 : _a.breakpoints) || {});
    const largeStyles = styles == null ? void 0 : styles.large;
    const mediumStyles = styles == null ? void 0 : styles.medium;
    const smallStyles = styles == null ? void 0 : styles.small;
    const className = processedBlock.id;
    if (!className)
      return "";
    const largeStylesClass = largeStyles ? createCssClass({
      className,
      styles: largeStyles
    }) : "";
    const mediumStylesClass = mediumStyles ? createCssClass({
      className,
      styles: mediumStyles,
      mediaQuery: getMaxWidthQueryForSize("medium", sizesWithUpdatedBreakpoints)
    }) : "";
    const smallStylesClass = smallStyles ? createCssClass({
      className,
      styles: smallStyles,
      mediaQuery: getMaxWidthQueryForSize("small", sizesWithUpdatedBreakpoints)
    }) : "";
    const hoverAnimation = processedBlock.animations && processedBlock.animations.find((item) => item.trigger === "hover");
    let hoverStylesClass = "";
    if (hoverAnimation) {
      const hoverStyles = ((_c = (_b = hoverAnimation.steps) == null ? void 0 : _b[1]) == null ? void 0 : _c.styles) || {};
      hoverStylesClass = createCssClass({
        className: `${className}:hover`,
        styles: {
          ...hoverStyles,
          transition: `all ${hoverAnimation.duration}s ${camelToKebabCase(hoverAnimation.easing)}`,
          transitionDelay: hoverAnimation.delay ? `${hoverAnimation.delay}s` : "0s"
        }
      }) || "";
    }
    return [
      largeStylesClass,
      mediumStylesClass,
      smallStylesClass,
      hoverStylesClass
    ].join(" ");
  }, "BlockStyles_component_css_useComputed_b9Ru8qTcNik", [
    props
  ]));
  return /* @__PURE__ */ qwik._jsxC(jsxRuntime.Fragment, {
    children: css.value && canShowBlock.value ? /* @__PURE__ */ qwik._jsxC(InlinedStyles, {
      id: "builderio-block",
      get styles() {
        return css.value;
      },
      [qwik._IMMUTABLE]: {
        id: qwik._IMMUTABLE,
        styles: qwik._fnSignal((p0) => p0.value, [
          css
        ], "p0.value")
      }
    }, 3, "8B_0") : null
  }, 1, "8B_1");
}, "BlockStyles_component_0lZeirBI638"));
function capitalizeFirstLetter(string) {
  return string.charAt(0).toUpperCase() + string.slice(1);
}
const getEventHandlerName = (key) => `on${capitalizeFirstLetter(key)}$`;
function createEventHandler(value, options) {
  return /* @__PURE__ */ qwik.inlinedQrl((event) => {
    const [options2, value2] = qwik.useLexicalScope();
    return evaluate({
      code: value2,
      context: options2.context,
      localState: options2.localState,
      rootState: options2.rootState,
      rootSetState: options2.rootSetState,
      event,
      enableCache: true
    });
  }, "createEventHandler_7wCAiJVliNE", [
    options,
    value
  ]);
}
function getBlockActions(options) {
  const obj = {};
  const optionActions = options.block.actions ?? {};
  for (const key in optionActions) {
    if (!optionActions.hasOwnProperty(key))
      continue;
    const value = optionActions[key];
    let eventHandlerName = getEventHandlerName(key);
    if (options.stripPrefix)
      switch (TARGET) {
        case "vue":
          eventHandlerName = eventHandlerName.replace("v-on:", "");
          break;
        case "svelte":
          eventHandlerName = eventHandlerName.replace("on:", "");
          break;
      }
    obj[eventHandlerName] = createEventHandler(value, options);
  }
  return obj;
}
function transformBlockProperties({ properties }) {
  return properties;
}
const extractRelevantRootBlockProperties = (block) => {
  return {
    href: block.href
  };
};
function getBlockProperties({ block, context }) {
  var _a;
  const properties = {
    ...extractRelevantRootBlockProperties(block),
    ...block.properties,
    "builder-id": block.id,
    style: getStyle({
      block,
      context
    }),
    [getClassPropName()]: [
      block.id,
      "builder-block",
      block.class,
      (_a = block.properties) == null ? void 0 : _a.class
    ].filter(Boolean).join(" ")
  };
  return transformBlockProperties({
    properties,
    context,
    block
  });
}
const BlockWrapper = /* @__PURE__ */ qwik.componentQrl(/* @__PURE__ */ qwik.inlinedQrl((props) => {
  return /* @__PURE__ */ qwik._jsxC(DynamicRenderer, {
    get TagName() {
      return props.Wrapper;
    },
    actionAttributes: getBlockActions({
      block: props.block,
      rootState: props.context.rootState,
      rootSetState: props.context.rootSetState,
      localState: props.context.localState,
      context: props.context.context,
      stripPrefix: true
    }),
    attributes: getBlockProperties({
      block: props.block,
      context: props.context
    }),
    children: /* @__PURE__ */ qwik._jsxC(qwik.Slot, null, 3, "87_0"),
    [qwik._IMMUTABLE]: {
      TagName: qwik._fnSignal((p0) => p0.Wrapper, [
        props
      ], "p0.Wrapper")
    }
  }, 1, "87_1");
}, "BlockWrapper_component_kOI0j0aW8Nw"));
const InteractiveElement = /* @__PURE__ */ qwik.componentQrl(/* @__PURE__ */ qwik.inlinedQrl((props) => {
  const attributes = qwik.useComputedQrl(/* @__PURE__ */ qwik.inlinedQrl(() => {
    const [props2] = qwik.useLexicalScope();
    return props2.includeBlockProps ? {
      ...getBlockProperties({
        block: props2.block,
        context: props2.context
      }),
      ...getBlockActions({
        block: props2.block,
        rootState: props2.context.rootState,
        rootSetState: props2.context.rootSetState,
        localState: props2.context.localState,
        context: props2.context.context
      })
    } : {};
  }, "InteractiveElement_component_attributes_useComputed_0kUhl8Qa4CE", [
    props
  ]));
  return /* @__PURE__ */ qwik._jsxC(props.Wrapper, {
    ...props.wrapperProps,
    get attributes() {
      return attributes.value;
    },
    children: /* @__PURE__ */ qwik._jsxC(qwik.Slot, null, 3, "q0_0"),
    [qwik._IMMUTABLE]: {
      attributes: qwik._fnSignal((p0) => p0.value, [
        attributes
      ], "p0.value")
    }
  }, 0, "q0_1");
}, "InteractiveElement_component_0UqfJpjhn0g"));
const getWrapperProps = ({ componentOptions, builderBlock, context, componentRef, includeBlockProps, isInteractive, contextValue }) => {
  const wrapperPropsWithAttributes = {
    ...componentOptions,
    /**
    * If `noWrap` is set to `true`, then the block's props/attributes are provided to the
    * component itself directly. Otherwise, they are provided to the wrapper element.
    */
    ...includeBlockProps ? {
      attributes: getBlockProperties({
        block: builderBlock,
        context: contextValue
      })
    } : {}
  };
  const interactiveElementProps = {
    Wrapper: componentRef,
    block: builderBlock,
    context,
    wrapperProps: componentOptions,
    includeBlockProps
  };
  return isInteractive ? interactiveElementProps : wrapperPropsWithAttributes;
};
const ComponentRef = /* @__PURE__ */ qwik.componentQrl(/* @__PURE__ */ qwik.inlinedQrl((props) => {
  const state = qwik.useStore({
    Wrapper: props.isInteractive ? InteractiveElement : props.componentRef
  });
  return /* @__PURE__ */ qwik._jsxC(jsxRuntime.Fragment, {
    children: props.componentRef ? /* @__PURE__ */ qwik._jsxC(state.Wrapper, {
      ...getWrapperProps({
        componentOptions: props.componentOptions,
        builderBlock: props.builderBlock,
        context: props.context,
        componentRef: props.componentRef,
        linkComponent: props.linkComponent,
        includeBlockProps: props.includeBlockProps,
        isInteractive: props.isInteractive,
        contextValue: props.context
      }),
      children: (props.blockChildren || []).map((child) => {
        return /* @__PURE__ */ qwik._jsxC(Block, {
          block: child,
          get context() {
            return props.context;
          },
          get registeredComponents() {
            return props.registeredComponents;
          },
          get linkComponent() {
            return props.linkComponent;
          },
          [qwik._IMMUTABLE]: {
            context: qwik._fnSignal((p0) => p0.context, [
              props
            ], "p0.context"),
            linkComponent: qwik._fnSignal((p0) => p0.linkComponent, [
              props
            ], "p0.linkComponent"),
            registeredComponents: qwik._fnSignal((p0) => p0.registeredComponents, [
              props
            ], "p0.registeredComponents")
          }
        }, 3, child.id);
      })
    }, 0, "z6_0") : null
  }, 1, "z6_1");
}, "ComponentRef_component_tFQoBV6UFdc"));
const RepeatedBlock = /* @__PURE__ */ qwik.componentQrl(/* @__PURE__ */ qwik.inlinedQrl((props) => {
  const state = qwik.useStore({
    store: props.repeatContext
  });
  qwik.useContextProvider(builderContext, state.store);
  return /* @__PURE__ */ qwik._jsxC(Block, {
    get block() {
      return props.block;
    },
    get context() {
      return state.store;
    },
    get registeredComponents() {
      return props.registeredComponents;
    },
    get linkComponent() {
      return props.linkComponent;
    },
    [qwik._IMMUTABLE]: {
      block: qwik._fnSignal((p0) => p0.block, [
        props
      ], "p0.block"),
      context: qwik._fnSignal((p0) => p0.store, [
        state
      ], "p0.store"),
      linkComponent: qwik._fnSignal((p0) => p0.linkComponent, [
        props
      ], "p0.linkComponent"),
      registeredComponents: qwik._fnSignal((p0) => p0.registeredComponents, [
        props
      ], "p0.registeredComponents")
    }
  }, 3, "GO_0");
}, "RepeatedBlock_component_JK1l2jKcfwA"));
const Block = /* @__PURE__ */ qwik.componentQrl(/* @__PURE__ */ qwik.inlinedQrl((props) => {
  var _a;
  qwik._jsxBranch();
  const blockComponent = qwik.useComputedQrl(/* @__PURE__ */ qwik.inlinedQrl(() => {
    const [props2] = qwik.useLexicalScope();
    return getComponent({
      block: props2.block,
      context: props2.context,
      registeredComponents: props2.registeredComponents
    });
  }, "Block_component_blockComponent_useComputed_83sGy9Xlsi0", [
    props
  ]));
  const repeatItem = qwik.useComputedQrl(/* @__PURE__ */ qwik.inlinedQrl(() => {
    const [props2] = qwik.useLexicalScope();
    return getRepeatItemData({
      block: props2.block,
      context: props2.context
    });
  }, "Block_component_repeatItem_useComputed_j31Y3wFqSCM", [
    props
  ]));
  const processedBlock = qwik.useComputedQrl(/* @__PURE__ */ qwik.inlinedQrl(() => {
    var _a2;
    const [props2] = qwik.useLexicalScope();
    return ((_a2 = props2.block.repeat) == null ? void 0 : _a2.collection) ? props2.block : getProcessedBlock({
      block: props2.block,
      localState: props2.context.localState,
      rootState: props2.context.rootState,
      rootSetState: props2.context.rootSetState,
      context: props2.context.context,
      shouldEvaluateBindings: true
    });
  }, "Block_component_processedBlock_useComputed_ESKw0l5FcBc", [
    props
  ]));
  const Tag = qwik.useComputedQrl(/* @__PURE__ */ qwik.inlinedQrl(() => {
    var _a2;
    const [processedBlock2, props2] = qwik.useLexicalScope();
    const shouldUseLink = props2.block.tagName === "a" || ((_a2 = processedBlock2.value.properties) == null ? void 0 : _a2.href) || processedBlock2.value.href;
    if (shouldUseLink)
      return props2.linkComponent || "a";
    return props2.block.tagName || "div";
  }, "Block_component_Tag_useComputed_eQnDgbcBW2A", [
    processedBlock,
    props
  ]));
  const canShowBlock = qwik.useComputedQrl(/* @__PURE__ */ qwik.inlinedQrl(() => {
    var _a2, _b;
    const [processedBlock2, props2, repeatItem2] = qwik.useLexicalScope();
    if ((_a2 = props2.block.repeat) == null ? void 0 : _a2.collection) {
      if ((_b = repeatItem2.value) == null ? void 0 : _b.length)
        return true;
      return false;
    }
    const shouldHide = "hide" in processedBlock2.value ? processedBlock2.value.hide : false;
    const shouldShow = "show" in processedBlock2.value ? processedBlock2.value.show : true;
    return shouldShow && !shouldHide;
  }, "Block_component_canShowBlock_useComputed_NJEFz8ICF08", [
    processedBlock,
    props,
    repeatItem
  ]));
  const childrenWithoutParentComponent = qwik.useComputedQrl(/* @__PURE__ */ qwik.inlinedQrl(() => {
    var _a2;
    const [blockComponent2, processedBlock2, repeatItem2] = qwik.useLexicalScope();
    const shouldRenderChildrenOutsideRef = !((_a2 = blockComponent2.value) == null ? void 0 : _a2.component) && !repeatItem2.value;
    return shouldRenderChildrenOutsideRef ? processedBlock2.value.children ?? [] : [];
  }, "Block_component_childrenWithoutParentComponent_useComputed_0WENYGElWnc", [
    blockComponent,
    processedBlock,
    repeatItem
  ]));
  const componentRefProps = qwik.useComputedQrl(/* @__PURE__ */ qwik.inlinedQrl(() => {
    var _a2, _b, _c;
    const [blockComponent2, processedBlock2, props2] = qwik.useLexicalScope();
    return {
      blockChildren: processedBlock2.value.children ?? [],
      componentRef: (_a2 = blockComponent2.value) == null ? void 0 : _a2.component,
      componentOptions: {
        ...getBlockComponentOptions(processedBlock2.value),
        builderContext: props2.context,
        ...shouldPassLinkComponent(blockComponent2.value) ? {
          builderLinkComponent: props2.linkComponent
        } : {},
        ...shouldPassRegisteredComponents(blockComponent2.value) ? {
          builderComponents: props2.registeredComponents
        } : {}
      },
      context: props2.context,
      linkComponent: props2.linkComponent,
      registeredComponents: props2.registeredComponents,
      builderBlock: processedBlock2.value,
      includeBlockProps: ((_b = blockComponent2.value) == null ? void 0 : _b.noWrap) === true,
      isInteractive: !((_c = blockComponent2.value) == null ? void 0 : _c.isRSC)
    };
  }, "Block_component_componentRefProps_useComputed_Ikbl8VO04ho", [
    blockComponent,
    processedBlock,
    props
  ]));
  qwik.useVisibleTaskQrl(/* @__PURE__ */ qwik.inlinedQrl(() => {
    const [processedBlock2] = qwik.useLexicalScope();
    const blockId = processedBlock2.value.id;
    const animations = processedBlock2.value.animations;
    if (animations && blockId)
      bindAnimations(animations.map((animation) => ({
        ...animation,
        elementId: blockId
      })));
  }, "Block_component_useVisibleTask_hrTYvqw0Tbs", [
    processedBlock
  ]));
  return /* @__PURE__ */ qwik._jsxC(jsxRuntime.Fragment, {
    children: canShowBlock.value ? /* @__PURE__ */ qwik._jsxC(jsxRuntime.Fragment, {
      children: [
        /* @__PURE__ */ qwik._jsxC(BlockStyles, {
          get block() {
            return props.block;
          },
          get context() {
            return props.context;
          },
          [qwik._IMMUTABLE]: {
            block: qwik._fnSignal((p0) => p0.block, [
              props
            ], "p0.block"),
            context: qwik._fnSignal((p0) => p0.context, [
              props
            ], "p0.context")
          }
        }, 3, "jN_0"),
        !((_a = blockComponent.value) == null ? void 0 : _a.noWrap) ? !repeatItem.value ? /* @__PURE__ */ qwik._jsxC(BlockWrapper, {
          get Wrapper() {
            return Tag.value;
          },
          get block() {
            return processedBlock.value;
          },
          get context() {
            return props.context;
          },
          get linkComponent() {
            return props.linkComponent;
          },
          children: [
            /* @__PURE__ */ qwik._jsxC(ComponentRef, {
              get componentRef() {
                return componentRefProps.value.componentRef;
              },
              get componentOptions() {
                return componentRefProps.value.componentOptions;
              },
              get blockChildren() {
                return componentRefProps.value.blockChildren;
              },
              get context() {
                return componentRefProps.value.context;
              },
              get registeredComponents() {
                return componentRefProps.value.registeredComponents;
              },
              get linkComponent() {
                return componentRefProps.value.linkComponent;
              },
              get builderBlock() {
                return componentRefProps.value.builderBlock;
              },
              get includeBlockProps() {
                return componentRefProps.value.includeBlockProps;
              },
              get isInteractive() {
                return componentRefProps.value.isInteractive;
              },
              [qwik._IMMUTABLE]: {
                blockChildren: qwik._fnSignal((p0) => p0.value.blockChildren, [
                  componentRefProps
                ], "p0.value.blockChildren"),
                builderBlock: qwik._fnSignal((p0) => p0.value.builderBlock, [
                  componentRefProps
                ], "p0.value.builderBlock"),
                componentOptions: qwik._fnSignal((p0) => p0.value.componentOptions, [
                  componentRefProps
                ], "p0.value.componentOptions"),
                componentRef: qwik._fnSignal((p0) => p0.value.componentRef, [
                  componentRefProps
                ], "p0.value.componentRef"),
                context: qwik._fnSignal((p0) => p0.value.context, [
                  componentRefProps
                ], "p0.value.context"),
                includeBlockProps: qwik._fnSignal((p0) => p0.value.includeBlockProps, [
                  componentRefProps
                ], "p0.value.includeBlockProps"),
                isInteractive: qwik._fnSignal((p0) => p0.value.isInteractive, [
                  componentRefProps
                ], "p0.value.isInteractive"),
                linkComponent: qwik._fnSignal((p0) => p0.value.linkComponent, [
                  componentRefProps
                ], "p0.value.linkComponent"),
                registeredComponents: qwik._fnSignal((p0) => p0.value.registeredComponents, [
                  componentRefProps
                ], "p0.value.registeredComponents")
              }
            }, 3, "jN_1"),
            (childrenWithoutParentComponent.value || []).map((child) => {
              return /* @__PURE__ */ qwik._jsxC(Block, {
                block: child,
                get registeredComponents() {
                  return props.registeredComponents;
                },
                get linkComponent() {
                  return props.linkComponent;
                },
                get context() {
                  return props.context;
                },
                [qwik._IMMUTABLE]: {
                  context: qwik._fnSignal((p0) => p0.context, [
                    props
                  ], "p0.context"),
                  linkComponent: qwik._fnSignal((p0) => p0.linkComponent, [
                    props
                  ], "p0.linkComponent"),
                  registeredComponents: qwik._fnSignal((p0) => p0.registeredComponents, [
                    props
                  ], "p0.registeredComponents")
                }
              }, 3, child.id);
            })
          ],
          [qwik._IMMUTABLE]: {
            Wrapper: qwik._fnSignal((p0) => p0.value, [
              Tag
            ], "p0.value"),
            block: qwik._fnSignal((p0) => p0.value, [
              processedBlock
            ], "p0.value"),
            context: qwik._fnSignal((p0) => p0.context, [
              props
            ], "p0.context"),
            linkComponent: qwik._fnSignal((p0) => p0.linkComponent, [
              props
            ], "p0.linkComponent")
          }
        }, 1, "jN_2") : (repeatItem.value || []).map((data, index) => {
          return /* @__PURE__ */ qwik._jsxC(RepeatedBlock, {
            get repeatContext() {
              return data.context;
            },
            get block() {
              return data.block;
            },
            get registeredComponents() {
              return props.registeredComponents;
            },
            get linkComponent() {
              return props.linkComponent;
            },
            [qwik._IMMUTABLE]: {
              block: qwik._wrapProp(data, "block"),
              linkComponent: qwik._fnSignal((p0) => p0.linkComponent, [
                props
              ], "p0.linkComponent"),
              registeredComponents: qwik._fnSignal((p0) => p0.registeredComponents, [
                props
              ], "p0.registeredComponents"),
              repeatContext: qwik._wrapProp(data, "context")
            }
          }, 3, index);
        }) : /* @__PURE__ */ qwik._jsxC(ComponentRef, {
          get componentRef() {
            return componentRefProps.value.componentRef;
          },
          get componentOptions() {
            return componentRefProps.value.componentOptions;
          },
          get blockChildren() {
            return componentRefProps.value.blockChildren;
          },
          get context() {
            return componentRefProps.value.context;
          },
          get registeredComponents() {
            return componentRefProps.value.registeredComponents;
          },
          get linkComponent() {
            return componentRefProps.value.linkComponent;
          },
          get builderBlock() {
            return componentRefProps.value.builderBlock;
          },
          get includeBlockProps() {
            return componentRefProps.value.includeBlockProps;
          },
          get isInteractive() {
            return componentRefProps.value.isInteractive;
          },
          [qwik._IMMUTABLE]: {
            blockChildren: qwik._fnSignal((p0) => p0.value.blockChildren, [
              componentRefProps
            ], "p0.value.blockChildren"),
            builderBlock: qwik._fnSignal((p0) => p0.value.builderBlock, [
              componentRefProps
            ], "p0.value.builderBlock"),
            componentOptions: qwik._fnSignal((p0) => p0.value.componentOptions, [
              componentRefProps
            ], "p0.value.componentOptions"),
            componentRef: qwik._fnSignal((p0) => p0.value.componentRef, [
              componentRefProps
            ], "p0.value.componentRef"),
            context: qwik._fnSignal((p0) => p0.value.context, [
              componentRefProps
            ], "p0.value.context"),
            includeBlockProps: qwik._fnSignal((p0) => p0.value.includeBlockProps, [
              componentRefProps
            ], "p0.value.includeBlockProps"),
            isInteractive: qwik._fnSignal((p0) => p0.value.isInteractive, [
              componentRefProps
            ], "p0.value.isInteractive"),
            linkComponent: qwik._fnSignal((p0) => p0.value.linkComponent, [
              componentRefProps
            ], "p0.value.linkComponent"),
            registeredComponents: qwik._fnSignal((p0) => p0.value.registeredComponents, [
              componentRefProps
            ], "p0.value.registeredComponents")
          }
        }, 3, "jN_3")
      ]
    }, 1, "jN_4") : null
  }, 1, "jN_5");
}, "Block_component_nnPv0RY0U0k"));
const onClick$3 = function onClick2(props, state, className) {
  var _a, _b;
  if (isEditing() && !((_a = props.blocks) == null ? void 0 : _a.length))
    (_b = window.parent) == null ? void 0 : _b.postMessage({
      type: "builder.clickEmptyBlocks",
      data: {
        parentElementId: props.parent,
        dataPath: props.path
      }
    }, "*");
};
const onMouseEnter = function onMouseEnter2(props, state, className) {
  var _a, _b;
  if (isEditing() && !((_a = props.blocks) == null ? void 0 : _a.length))
    (_b = window.parent) == null ? void 0 : _b.postMessage({
      type: "builder.hoverEmptyBlocks",
      data: {
        parentElementId: props.parent,
        dataPath: props.path
      }
    }, "*");
};
const BlocksWrapper = /* @__PURE__ */ qwik.componentQrl(/* @__PURE__ */ qwik.inlinedQrl((props) => {
  qwik.useStylesScopedQrl(/* @__PURE__ */ qwik.inlinedQrl(STYLES$3, "BlocksWrapper_component_useStylesScoped_Kj0S9AOXQ0o"));
  const className = qwik.useComputedQrl(/* @__PURE__ */ qwik.inlinedQrl(() => {
    var _a;
    const [props2] = qwik.useLexicalScope();
    return "builder-blocks" + (!((_a = props2.blocks) == null ? void 0 : _a.length) ? " no-blocks" : "");
  }, "BlocksWrapper_component_className_useComputed_J5SSSH2Xf08", [
    props
  ]));
  const state = {};
  return /* @__PURE__ */ qwik._jsxC(props.BlocksWrapper, {
    get class() {
      return className.value + " props-blocks-wrapper-BlocksWrapper";
    },
    get "builder-path"() {
      return props.path;
    },
    get "builder-parent-id"() {
      return props.parent;
    },
    get style() {
      return props.styleProp;
    },
    onClick$: /* @__PURE__ */ qwik.inlinedQrl((event) => {
      const [className2, props2, state2] = qwik.useLexicalScope();
      return onClick$3(props2);
    }, "BlocksWrapper_component_onClick_ufezvOupQrM", [
      className,
      props,
      state
    ]),
    onKeyPress$: /* @__PURE__ */ qwik.inlinedQrl((event) => {
      const [className2, props2, state2] = qwik.useLexicalScope();
      return onClick$3(props2);
    }, "BlocksWrapper_component_onKeyPress_9bz8vCQc3kg", [
      className,
      props,
      state
    ]),
    onMouseEnter$: /* @__PURE__ */ qwik.inlinedQrl((event) => {
      const [className2, props2, state2] = qwik.useLexicalScope();
      return onMouseEnter(props2);
    }, "BlocksWrapper_component_onMouseEnter_j4FJjnLtraQ", [
      className,
      props,
      state
    ]),
    ...props.BlocksWrapperProps,
    children: /* @__PURE__ */ qwik._jsxC(qwik.Slot, null, 3, "3u_0"),
    [qwik._IMMUTABLE]: {
      "builder-parent-id": qwik._fnSignal((p0) => p0.parent, [
        props
      ], "p0.parent"),
      "builder-path": qwik._fnSignal((p0) => p0.path, [
        props
      ], "p0.path"),
      class: qwik._fnSignal((p0) => p0.value + " props-blocks-wrapper-BlocksWrapper", [
        className
      ], 'p0.value+" props-blocks-wrapper-BlocksWrapper"'),
      style: qwik._fnSignal((p0) => p0.styleProp, [
        props
      ], "p0.styleProp")
    }
  }, 0, "3u_1");
}, "BlocksWrapper_component_45hR0o6abzg"));
const STYLES$3 = `
.props-blocks-wrapper-BlocksWrapper {
  display: flex;
  flex-direction: column;
  align-items: stretch;
}
`;
const Blocks = /* @__PURE__ */ qwik.componentQrl(/* @__PURE__ */ qwik.inlinedQrl((props) => {
  const builderContext$1 = qwik.useContext(builderContext);
  const componentsContext = qwik.useContext(ComponentsContext);
  return /* @__PURE__ */ qwik._jsxC(BlocksWrapper, {
    get blocks() {
      return props.blocks;
    },
    get parent() {
      return props.parent;
    },
    get path() {
      return props.path;
    },
    get styleProp() {
      return props.styleProp;
    },
    get BlocksWrapper() {
      var _a;
      return ((_a = props.context) == null ? void 0 : _a.BlocksWrapper) || builderContext$1.BlocksWrapper;
    },
    get BlocksWrapperProps() {
      var _a;
      return ((_a = props.context) == null ? void 0 : _a.BlocksWrapperProps) || builderContext$1.BlocksWrapperProps;
    },
    children: props.blocks ? (props.blocks || []).map((block) => {
      return /* @__PURE__ */ qwik._jsxC(Block, {
        block,
        get linkComponent() {
          return props.linkComponent;
        },
        get context() {
          return props.context || builderContext$1;
        },
        get registeredComponents() {
          return props.registeredComponents || componentsContext.registeredComponents;
        },
        [qwik._IMMUTABLE]: {
          context: qwik._fnSignal((p0, p1) => p1.context || p0, [
            builderContext$1,
            props
          ], "p1.context||p0"),
          linkComponent: qwik._fnSignal((p0) => p0.linkComponent, [
            props
          ], "p0.linkComponent"),
          registeredComponents: qwik._fnSignal((p0, p1) => p1.registeredComponents || p0.registeredComponents, [
            componentsContext,
            props
          ], "p1.registeredComponents||p0.registeredComponents")
        }
      }, 3, block.id);
    }) : null,
    [qwik._IMMUTABLE]: {
      BlocksWrapper: qwik._fnSignal((p0, p1) => {
        var _a;
        return ((_a = p1.context) == null ? void 0 : _a.BlocksWrapper) || p0.BlocksWrapper;
      }, [
        builderContext$1,
        props
      ], "p1.context?.BlocksWrapper||p0.BlocksWrapper"),
      BlocksWrapperProps: qwik._fnSignal((p0, p1) => {
        var _a;
        return ((_a = p1.context) == null ? void 0 : _a.BlocksWrapperProps) || p0.BlocksWrapperProps;
      }, [
        builderContext$1,
        props
      ], "p1.context?.BlocksWrapperProps||p0.BlocksWrapperProps"),
      blocks: qwik._fnSignal((p0) => p0.blocks, [
        props
      ], "p0.blocks"),
      parent: qwik._fnSignal((p0) => p0.parent, [
        props
      ], "p0.parent"),
      path: qwik._fnSignal((p0) => p0.path, [
        props
      ], "p0.path"),
      styleProp: qwik._fnSignal((p0) => p0.styleProp, [
        props
      ], "p0.styleProp")
    }
  }, 1, "0n_0");
}, "Blocks_component_PI1ErWPzPEg"));
function deoptSignal(value) {
  return value;
}
const getColumnsClass = (id) => {
  return `builder-columns ${id}-breakpoints`;
};
const getTagName = function getTagName2(props, state, column) {
  return column.link ? props.builderLinkComponent || "a" : "div";
};
const getWidth = function getWidth2(props, state, index) {
  var _a;
  return ((_a = state.cols[index]) == null ? void 0 : _a.width) || 100 / state.cols.length;
};
const getColumnCssWidth = function getColumnCssWidth2(props, state, index) {
  const subtractWidth = state.gutterSize * (state.cols.length - 1) / state.cols.length;
  return `calc(${getWidth(props, state, index)}% - ${subtractWidth}px)`;
};
const getTabletStyle = function getTabletStyle2(props, state, { stackedStyle, desktopStyle }) {
  return state.stackAt === "tablet" ? stackedStyle : desktopStyle;
};
const getMobileStyle = function getMobileStyle2(props, state, { stackedStyle, desktopStyle }) {
  return state.stackAt === "never" ? desktopStyle : stackedStyle;
};
const columnsCssVars = function columnsCssVars2(props, state) {
  return {
    "--flex-dir": state.flexDir,
    "--flex-dir-tablet": getTabletStyle(props, state, {
      stackedStyle: state.flexDir,
      desktopStyle: "row"
    })
  };
};
const columnCssVars = function columnCssVars2(props, state, index) {
  const gutter = index === 0 ? 0 : state.gutterSize;
  const width = getColumnCssWidth(props, state, index);
  const gutterPixels = `${gutter}px`;
  const mobileWidth = "100%";
  const mobileMarginLeft = 0;
  const marginLeftKey = "margin-left";
  const sharedStyles = {
    display: "flex",
    flexDirection: "column",
    alignItems: "stretch"
  };
  return {
    ...sharedStyles,
    width,
    [marginLeftKey]: gutterPixels,
    "--column-width-mobile": getMobileStyle(props, state, {
      stackedStyle: mobileWidth,
      desktopStyle: width
    }),
    "--column-margin-left-mobile": getMobileStyle(props, state, {
      stackedStyle: mobileMarginLeft,
      desktopStyle: gutterPixels
    }),
    "--column-width-tablet": getTabletStyle(props, state, {
      stackedStyle: mobileWidth,
      desktopStyle: width
    }),
    "--column-margin-left-tablet": getTabletStyle(props, state, {
      stackedStyle: mobileMarginLeft,
      desktopStyle: gutterPixels
    })
  };
};
const getWidthForBreakpointSize = function getWidthForBreakpointSize2(props, state, size) {
  var _a, _b;
  const breakpointSizes = getSizesForBreakpoints(((_b = (_a = props.builderContext.content) == null ? void 0 : _a.meta) == null ? void 0 : _b.breakpoints) || {});
  return breakpointSizes[size].max;
};
const columnsStyles = function columnsStyles2(props, state) {
  return `
        @media (max-width: ${getWidthForBreakpointSize(props, state, "medium")}px) {
          .${props.builderBlock.id}-breakpoints {
            flex-direction: var(--flex-dir-tablet);
            align-items: stretch;
          }

          .${props.builderBlock.id}-breakpoints > .builder-column {
            width: var(--column-width-tablet) !important;
            margin-left: var(--column-margin-left-tablet) !important;
          }
        }

        @media (max-width: ${getWidthForBreakpointSize(props, state, "small")}px) {
          .${props.builderBlock.id}-breakpoints {
            flex-direction: var(--flex-dir);
            align-items: stretch;
          }

          .${props.builderBlock.id}-breakpoints > .builder-column {
            width: var(--column-width-mobile) !important;
            margin-left: var(--column-margin-left-mobile) !important;
          }
        },
      `;
};
const getAttributes = function getAttributes2(props, state, column, index) {
  return {
    ...column.link ? {
      href: column.link
    } : {},
    [getClassPropName()]: "builder-column",
    style: mapStyleObjToStrIfNeeded(columnCssVars(props, state, index))
  };
};
const Columns = /* @__PURE__ */ qwik.componentQrl(/* @__PURE__ */ qwik.inlinedQrl((props) => {
  var _a;
  qwik._jsxBranch();
  const state = qwik.useStore({
    cols: props.columns || [],
    flexDir: props.stackColumnsAt === "never" ? "row" : props.reverseColumnsWhenStacked ? "column-reverse" : "column",
    gutterSize: typeof props.space === "number" ? props.space || 0 : 20,
    stackAt: props.stackColumnsAt || "tablet"
  });
  qwik.useStylesScopedQrl(/* @__PURE__ */ qwik.inlinedQrl(STYLES$2, "Columns_component_useStylesScoped_s7JLZz7MCCQ"));
  return /* @__PURE__ */ qwik._jsxQ("div", {
    class: getColumnsClass((_a = props.builderBlock) == null ? void 0 : _a.id) + " div-Columns",
    style: columnsCssVars(props, state)
  }, null, [
    /* @__PURE__ */ qwik._jsxC(InlinedStyles, {
      id: "builderio-columns",
      styles: columnsStyles(props, state),
      [qwik._IMMUTABLE]: {
        id: qwik._IMMUTABLE
      }
    }, 3, "c0_0"),
    (props.columns || []).map((column, index) => {
      return /* @__PURE__ */ qwik._jsxC(DynamicRenderer, {
        TagName: getTagName(props, state, column),
        actionAttributes: {},
        attributes: getAttributes(props, state, column, index),
        children: /* @__PURE__ */ qwik._jsxC(Blocks, {
          path: `component.options.columns.${index}.blocks`,
          get parent() {
            return props.builderBlock.id;
          },
          get styleProp() {
            return {
              flexGrow: "1"
            };
          },
          get context() {
            return props.builderContext;
          },
          get registeredComponents() {
            return props.builderComponents;
          },
          get linkComponent() {
            return props.builderLinkComponent;
          },
          blocks: deoptSignal(column.blocks),
          [qwik._IMMUTABLE]: {
            context: qwik._fnSignal((p0) => p0.builderContext, [
              props
            ], "p0.builderContext"),
            linkComponent: qwik._fnSignal((p0) => p0.builderLinkComponent, [
              props
            ], "p0.builderLinkComponent"),
            parent: qwik._fnSignal((p0) => p0.builderBlock.id, [
              props
            ], "p0.builderBlock.id"),
            registeredComponents: qwik._fnSignal((p0) => p0.builderComponents, [
              props
            ], "p0.builderComponents"),
            styleProp: qwik._IMMUTABLE
          }
        }, 3, "c0_1"),
        [qwik._IMMUTABLE]: {
          actionAttributes: qwik._IMMUTABLE
        }
      }, 1, index);
    })
  ], 1, "c0_2");
}, "Columns_component_7yLj4bxdI6c"));
const STYLES$2 = `
.div-Columns {
  display: flex;
  line-height: normal;
}
`;
const FragmentComponent = /* @__PURE__ */ qwik.componentQrl(/* @__PURE__ */ qwik.inlinedQrl((props) => {
  return /* @__PURE__ */ qwik._jsxQ("span", null, null, /* @__PURE__ */ qwik._jsxC(qwik.Slot, null, 3, "oj_0"), 1, "oj_1");
}, "FragmentComponent_component_T0AypnadAK0"));
function removeProtocol(path) {
  return path.replace(/http(s)?:/, "");
}
function updateQueryParam(uri = "", key, value) {
  const re = new RegExp("([?&])" + key + "=.*?(&|$)", "i");
  const separator = uri.indexOf("?") !== -1 ? "&" : "?";
  if (uri.match(re))
    return uri.replace(re, "$1" + key + "=" + encodeURIComponent(value) + "$2");
  return uri + separator + key + "=" + encodeURIComponent(value);
}
function getShopifyImageUrl(src, size) {
  if (!src || !(src == null ? void 0 : src.match(/cdn\.shopify\.com/)) || !size)
    return src;
  if (size === "master")
    return removeProtocol(src);
  const match = src.match(/(_\d+x(\d+)?)?(\.(jpg|jpeg|gif|png|bmp|bitmap|tiff|tif)(\?v=\d+)?)/i);
  if (match) {
    const prefix = src.split(match[0]);
    const suffix = match[3];
    const useSize = size.match("x") ? size : `${size}x`;
    return removeProtocol(`${prefix[0]}_${useSize}${suffix}`);
  }
  return null;
}
function getSrcSet(url) {
  if (!url)
    return url;
  const sizes = [
    100,
    200,
    400,
    800,
    1200,
    1600,
    2e3
  ];
  if (url.match(/builder\.io/)) {
    let srcUrl = url;
    const widthInSrc = Number(url.split("?width=")[1]);
    if (!isNaN(widthInSrc))
      srcUrl = `${srcUrl} ${widthInSrc}w`;
    return sizes.filter((size) => size !== widthInSrc).map((size) => `${updateQueryParam(url, "width", size)} ${size}w`).concat([
      srcUrl
    ]).join(", ");
  }
  if (url.match(/cdn\.shopify\.com/))
    return sizes.map((size) => [
      getShopifyImageUrl(url, `${size}x${size}`),
      size
    ]).filter(([sizeUrl]) => !!sizeUrl).map(([sizeUrl, size]) => `${sizeUrl} ${size}w`).concat([
      url
    ]).join(", ");
  return url;
}
const Image = /* @__PURE__ */ qwik.componentQrl(/* @__PURE__ */ qwik.inlinedQrl((props) => {
  var _a, _b, _c, _d, _e, _f;
  qwik._jsxBranch();
  qwik.useStylesScopedQrl(/* @__PURE__ */ qwik.inlinedQrl(STYLES$1, "Image_component_useStylesScoped_fBMYiVf9fuU"));
  const srcSetToUse = qwik.useComputedQrl(/* @__PURE__ */ qwik.inlinedQrl(() => {
    var _a2;
    const [props2] = qwik.useLexicalScope();
    const imageToUse = props2.image || props2.src;
    const url = imageToUse;
    if (!url || // We can auto add srcset for cdn.builder.io and shopify
    // images, otherwise you can supply this prop manually
    !(url.match(/builder\.io/) || url.match(/cdn\.shopify\.com/)))
      return props2.srcset;
    if (props2.srcset && ((_a2 = props2.image) == null ? void 0 : _a2.includes("builder.io/api/v1/image"))) {
      if (!props2.srcset.includes(props2.image.split("?")[0])) {
        console.debug("Removed given srcset");
        return getSrcSet(url);
      }
    } else if (props2.image && !props2.srcset)
      return getSrcSet(url);
    return getSrcSet(url);
  }, "Image_component_srcSetToUse_useComputed_TZMibf9Gpvw", [
    props
  ]));
  const webpSrcSet = qwik.useComputedQrl(/* @__PURE__ */ qwik.inlinedQrl(() => {
    var _a2;
    const [props2, srcSetToUse2] = qwik.useLexicalScope();
    if (((_a2 = srcSetToUse2.value) == null ? void 0 : _a2.match(/builder\.io/)) && !props2.noWebp)
      return srcSetToUse2.value.replace(/\?/g, "?format=webp&");
    else
      return "";
  }, "Image_component_webpSrcSet_useComputed_01YCu72BBtA", [
    props,
    srcSetToUse
  ]));
  const aspectRatioCss = qwik.useComputedQrl(/* @__PURE__ */ qwik.inlinedQrl(() => {
    const [props2] = qwik.useLexicalScope();
    const aspectRatioStyles = {
      position: "absolute",
      height: "100%",
      width: "100%",
      left: "0px",
      top: "0px"
    };
    const out = props2.aspectRatio ? aspectRatioStyles : void 0;
    return out;
  }, "Image_component_aspectRatioCss_useComputed_yJ1jG0g5fbw", [
    props
  ]));
  return /* @__PURE__ */ qwik._jsxC(qwik.Fragment, {
    children: [
      /* @__PURE__ */ qwik._jsxQ("picture", null, null, [
        webpSrcSet.value ? /* @__PURE__ */ qwik._jsxQ("source", null, {
          srcset: qwik._fnSignal((p0) => p0.value, [
            webpSrcSet
          ], "p0.value"),
          type: "image/webp"
        }, null, 3, "0A_0") : null,
        /* @__PURE__ */ qwik._jsxQ("img", null, {
          alt: qwik._fnSignal((p0) => p0.altText, [
            props
          ], "p0.altText"),
          class: qwik._fnSignal((p0) => "builder-image" + (p0.className ? " " + p0.className : "") + " img-Image", [
            props
          ], '"builder-image"+(p0.className?" "+p0.className:"")+" img-Image"'),
          loading: "lazy",
          role: qwik._fnSignal((p0) => p0.altText ? void 0 : "presentation", [
            props
          ], 'p0.altText?undefined:"presentation"'),
          sizes: qwik._fnSignal((p0) => p0.sizes, [
            props
          ], "p0.sizes"),
          src: qwik._fnSignal((p0) => p0.image, [
            props
          ], "p0.image"),
          srcset: qwik._fnSignal((p0) => p0.value, [
            srcSetToUse
          ], "p0.value"),
          style: qwik._fnSignal((p0, p1) => ({
            objectPosition: p1.backgroundPosition || "center",
            objectFit: p1.backgroundSize || "cover",
            ...p0.value
          }), [
            aspectRatioCss,
            props
          ], '{objectPosition:p1.backgroundPosition||"center",objectFit:p1.backgroundSize||"cover",...p0.value}')
        }, null, 3, null)
      ], 1, null),
      props.aspectRatio && !(((_b = (_a = props.builderBlock) == null ? void 0 : _a.children) == null ? void 0 : _b.length) && props.fitContent) ? /* @__PURE__ */ qwik._jsxQ("div", null, {
        class: "builder-image-sizer div-Image",
        style: qwik._fnSignal((p0) => ({
          paddingTop: p0.aspectRatio * 100 + "%"
        }), [
          props
        ], '{paddingTop:p0.aspectRatio*100+"%"}')
      }, null, 3, "0A_1") : null,
      ((_d = (_c = props.builderBlock) == null ? void 0 : _c.children) == null ? void 0 : _d.length) && props.fitContent ? /* @__PURE__ */ qwik._jsxC(qwik.Slot, null, 3, "0A_2") : null,
      !props.fitContent && ((_f = (_e = props.builderBlock) == null ? void 0 : _e.children) == null ? void 0 : _f.length) ? /* @__PURE__ */ qwik._jsxQ("div", null, {
        class: "div-Image-2"
      }, /* @__PURE__ */ qwik._jsxC(qwik.Slot, null, 3, "0A_3"), 1, "0A_4") : null
    ]
  }, 1, "0A_5");
}, "Image_component_LRxDkFa1EfU"));
const STYLES$1 = `
.img-Image {
  opacity: 1;
  transition: opacity 0.2s ease-in-out;
}
.div-Image {
  width: 100%;
  pointer-events: none;
  font-size: 0;
}
.div-Image-2 {
  display: flex;
  flex-direction: column;
  align-items: stretch;
  position: absolute;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
}
`;
const SectionComponent = /* @__PURE__ */ qwik.componentQrl(/* @__PURE__ */ qwik.inlinedQrl((props) => {
  return /* @__PURE__ */ qwik._jsxS("section", {
    ...props.attributes,
    children: /* @__PURE__ */ qwik._jsxC(qwik.Slot, null, 3, "2Y_0"),
    style: {
      width: "100%",
      alignSelf: "stretch",
      flexGrow: 1,
      boxSizing: "border-box",
      maxWidth: props.maxWidth || 1200,
      display: "flex",
      flexDirection: "column",
      alignItems: "stretch",
      marginLeft: "auto",
      marginRight: "auto"
    }
  }, null, 0, "2Y_1");
}, "SectionComponent_component_ZWF9iD5WeLg"));
const getTopLevelDomain = (host) => {
  if (host === "localhost" || host === "127.0.0.1")
    return host;
  const parts = host.split(".");
  if (parts.length > 2)
    return parts.slice(1).join(".");
  return host;
};
const getCookieSync = ({ name, canTrack }) => {
  var _a;
  try {
    if (!canTrack)
      return void 0;
    return (_a = document.cookie.split("; ").find((row) => row.startsWith(`${name}=`))) == null ? void 0 : _a.split("=")[1];
  } catch (err) {
    logger.warn("[COOKIE] GET error: ", (err == null ? void 0 : err.message) || err);
    return void 0;
  }
};
const getCookie = async (args) => getCookieSync(args);
const stringifyCookie = (cookie) => cookie.map(([key, value]) => value ? `${key}=${value}` : key).filter(checkIsDefined).join("; ");
const SECURE_CONFIG = [
  [
    "secure",
    ""
  ],
  [
    "SameSite",
    "None"
  ]
];
const createCookieString = ({ name, value, expires }) => {
  const secure = isBrowser() ? location.protocol === "https:" : true;
  const secureObj = secure ? SECURE_CONFIG : [
    []
  ];
  const expiresObj = expires ? [
    [
      "expires",
      expires.toUTCString()
    ]
  ] : [
    []
  ];
  const cookieValue = [
    [
      name,
      value
    ],
    ...expiresObj,
    [
      "path",
      "/"
    ],
    [
      "domain",
      getTopLevelDomain(window.location.hostname)
    ],
    ...secureObj
  ];
  const cookie = stringifyCookie(cookieValue);
  return cookie;
};
const setCookie = async ({ name, value, expires, canTrack }) => {
  try {
    if (!canTrack)
      return;
    const cookie = createCookieString({
      name,
      value,
      expires
    });
    document.cookie = cookie;
  } catch (err) {
    logger.warn("[COOKIE] SET error: ", (err == null ? void 0 : err.message) || err);
  }
};
const BUILDER_STORE_PREFIX = "builder.tests";
const getContentTestKey = (id) => `${BUILDER_STORE_PREFIX}.${id}`;
const getContentVariationCookie = ({ contentId }) => getCookie({
  name: getContentTestKey(contentId),
  canTrack: true
});
const getContentVariationCookieSync = ({ contentId }) => getCookieSync({
  name: getContentTestKey(contentId),
  canTrack: true
});
const setContentVariationCookie = ({ contentId, value }) => setCookie({
  name: getContentTestKey(contentId),
  value,
  canTrack: true
});
const checkIsBuilderContentWithVariations = (item) => checkIsDefined(item.id) && checkIsDefined(item.variations) && Object.keys(item.variations).length > 0;
const getRandomVariationId = ({ id, variations }) => {
  var _a;
  let n = 0;
  const random = Math.random();
  for (const id2 in variations) {
    const testRatio = (_a = variations[id2]) == null ? void 0 : _a.testRatio;
    n += testRatio;
    if (random < n)
      return id2;
  }
  return id;
};
const getAndSetVariantId = (args) => {
  const randomVariationId = getRandomVariationId(args);
  setContentVariationCookie({
    contentId: args.id,
    value: randomVariationId
  }).catch((err) => {
    logger.error("could not store A/B test variation: ", err);
  });
  return randomVariationId;
};
const getTestFields = ({ item, testGroupId }) => {
  const variationValue = item.variations[testGroupId];
  if (testGroupId === item.id || // handle edge-case where `testGroupId` points to non-existing variation
  !variationValue)
    return {
      testVariationId: item.id,
      testVariationName: "Default"
    };
  else
    return {
      data: variationValue.data,
      testVariationId: variationValue.id,
      testVariationName: variationValue.name || (variationValue.id === item.id ? "Default" : "")
    };
};
const handleABTestingSync = ({ item, canTrack }) => {
  if (!canTrack)
    return item;
  if (!item)
    return void 0;
  if (!checkIsBuilderContentWithVariations(item))
    return item;
  const testGroupId = getContentVariationCookieSync({
    contentId: item.id
  }) || getAndSetVariantId({
    variations: item.variations,
    id: item.id
  });
  const variationValue = getTestFields({
    item,
    testGroupId
  });
  return {
    ...item,
    ...variationValue
  };
};
const handleABTesting = async ({ item, canTrack }) => {
  if (!canTrack)
    return item;
  if (!checkIsBuilderContentWithVariations(item))
    return item;
  const cookieValue = await getContentVariationCookie({
    contentId: item.id
  });
  const testGroupId = cookieValue || getAndSetVariantId({
    variations: item.variations,
    id: item.id
  });
  const variationValue = getTestFields({
    item,
    testGroupId
  });
  return {
    ...item,
    ...variationValue
  };
};
const getDefaultCanTrack = (canTrack) => checkIsDefined(canTrack) ? canTrack : true;
const defaultTitle = {
  "@type": "@builder.io/sdk:Element",
  layerName: "Accordion item title",
  responsiveStyles: {
    large: {
      marginTop: "10px",
      position: "relative",
      display: "flex",
      alignItems: "stretch",
      flexDirection: "column",
      paddingBottom: "10px"
    }
  },
  children: [
    {
      "@type": "@builder.io/sdk:Element",
      responsiveStyles: {
        large: {
          textAlign: "left",
          display: "flex",
          flexDirection: "column"
        }
      },
      component: {
        name: "Text",
        options: {
          text: "I am an accordion title. Click me!"
        }
      }
    }
  ]
};
const defaultDetail = {
  "@type": "@builder.io/sdk:Element",
  layerName: "Accordion item detail",
  responsiveStyles: {
    large: {
      position: "relative",
      display: "flex",
      alignItems: "stretch",
      flexDirection: "column",
      marginTop: "10px",
      paddingBottom: "10px"
    }
  },
  children: [
    {
      "@type": "@builder.io/sdk:Element",
      responsiveStyles: {
        large: {
          paddingTop: "50px",
          textAlign: "left",
          display: "flex",
          flexDirection: "column",
          paddingBottom: "50px"
        }
      },
      component: {
        name: "Text",
        options: {
          text: "I am an accordion detail, hello!"
        }
      }
    }
  ]
};
const componentInfo$h = {
  name: "Builder:Accordion",
  canHaveChildren: true,
  image: "https://cdn.builder.io/api/v1/image/assets%2FagZ9n5CUKRfbL9t6CaJOyVSK4Es2%2Ffab6c1fd3fe542408cbdec078bca7f35",
  defaultStyles: {
    display: "flex",
    flexDirection: "column",
    alignItems: "stretch"
  },
  inputs: [
    {
      name: "items",
      type: "list",
      broadcast: true,
      subFields: [
        {
          name: "title",
          type: "uiBlocks",
          hideFromUI: true,
          defaultValue: [
            defaultTitle
          ]
        },
        {
          name: "detail",
          type: "uiBlocks",
          hideFromUI: true,
          defaultValue: [
            defaultDetail
          ]
        }
      ],
      defaultValue: [
        {
          title: [
            defaultTitle
          ],
          detail: [
            defaultDetail
          ]
        },
        {
          title: [
            defaultTitle
          ],
          detail: [
            defaultDetail
          ]
        }
      ],
      showIf: (options) => !options.get("useChildrenForItems")
    },
    {
      name: "oneAtATime",
      helperText: "Only allow opening one at a time (collapse all others when new item openned)",
      type: "boolean",
      defaultValue: false
    },
    {
      name: "grid",
      helperText: "Display as a grid",
      type: "boolean",
      defaultValue: false
    },
    {
      name: "gridRowWidth",
      helperText: "Display as a grid",
      type: "string",
      showIf: (options) => options.get("grid"),
      defaultValue: "25%"
    },
    {
      name: "useChildrenForItems",
      type: "boolean",
      helperText: "Use child elements for each slide, instead of the array. Useful for dynamically repeating items",
      advanced: true,
      defaultValue: false,
      onChange: (options) => {
        if (options.get("useChildrenForItems") === true)
          options.set("items", []);
      }
    }
  ]
};
const convertOrderNumberToString = (order) => {
  return order.toString();
};
const getAccordionTitleClassName = function getAccordionTitleClassName2(props, state, onlyOneAtATime, accordionStyles, accordionTitleStyles, openGridItemOrder, accordionDetailStyles, index) {
  return `builder-accordion-title builder-accordion-title-${state.open.includes(index) ? "open" : "closed"}`;
};
const getAccordionDetailClassName = function getAccordionDetailClassName2(props, state, onlyOneAtATime, accordionStyles, accordionTitleStyles, openGridItemOrder, accordionDetailStyles, index) {
  return `builder-accordion-detail builder-accordion-detail-${state.open.includes(index) ? "open" : "closed"}`;
};
const onClick$2 = function onClick22(props, state, onlyOneAtATime, accordionStyles, accordionTitleStyles, openGridItemOrder, accordionDetailStyles, index) {
  if (state.open.includes(index))
    state.open = onlyOneAtATime.value ? [] : state.open.filter((item) => item !== index);
  else
    state.open = onlyOneAtATime.value ? [
      index
    ] : state.open.concat(index);
};
const Accordion = /* @__PURE__ */ qwik.componentQrl(/* @__PURE__ */ qwik.inlinedQrl((props) => {
  const state = qwik.useStore({
    open: []
  });
  const onlyOneAtATime = qwik.useComputedQrl(/* @__PURE__ */ qwik.inlinedQrl(() => {
    const [props2] = qwik.useLexicalScope();
    return Boolean(props2.grid || props2.oneAtATime);
  }, "Accordion_component_onlyOneAtATime_useComputed_QYD7IoPU2HY", [
    props
  ]));
  const accordionStyles = qwik.useComputedQrl(/* @__PURE__ */ qwik.inlinedQrl(() => {
    const [props2] = qwik.useLexicalScope();
    const styles = {
      display: "flex",
      alignItems: "stretch",
      flexDirection: "column",
      ...props2.grid && {
        flexDirection: "row",
        alignItems: "flex-start",
        flexWrap: "wrap"
      }
    };
    return styles;
  }, "Accordion_component_accordionStyles_useComputed_Jrd0cwGn25U", [
    props
  ]));
  const accordionTitleStyles = qwik.useComputedQrl(/* @__PURE__ */ qwik.inlinedQrl(() => {
    const shared = {
      display: "flex",
      flexDirection: "column"
    };
    const styles = {
      ...shared,
      alignItems: "stretch",
      cursor: "pointer"
    };
    return Object.fromEntries(Object.entries(styles).filter(([_, value]) => value !== void 0));
  }, "Accordion_component_accordionTitleStyles_useComputed_FopdBMH0V6U"));
  const openGridItemOrder = qwik.useComputedQrl(/* @__PURE__ */ qwik.inlinedQrl(() => {
    const [props2, state2] = qwik.useLexicalScope();
    let itemOrder = null;
    const getOpenGridItemPosition = props2.grid && state2.open.length;
    if (getOpenGridItemPosition && document) {
      const openItemIndex = state2.open[0];
      const openItem = document.querySelector(`.builder-accordion-title[data-index="${openItemIndex}"]`);
      let subjectItem = openItem;
      itemOrder = openItemIndex;
      if (subjectItem) {
        let prevItemRect = subjectItem.getBoundingClientRect();
        while (subjectItem = subjectItem && subjectItem.nextElementSibling)
          if (subjectItem) {
            if (subjectItem.classList.contains("builder-accordion-detail"))
              continue;
            const subjectItemRect = subjectItem.getBoundingClientRect();
            if (subjectItemRect.left > prevItemRect.left) {
              const index = parseInt(subjectItem.getAttribute("data-index") || "", 10);
              if (!isNaN(index)) {
                prevItemRect = subjectItemRect;
                itemOrder = index;
              }
            } else
              break;
          }
      }
    }
    if (typeof itemOrder === "number")
      itemOrder = itemOrder + 1;
    return itemOrder;
  }, "Accordion_component_openGridItemOrder_useComputed_cCQY1Vnxll0", [
    props,
    state
  ]));
  const accordionDetailStyles = qwik.useComputedQrl(/* @__PURE__ */ qwik.inlinedQrl(() => {
    const [openGridItemOrder2, props2] = qwik.useLexicalScope();
    const styles = {
      order: typeof openGridItemOrder2.value === "number" ? openGridItemOrder2.value : void 0,
      ...props2.grid && {
        width: "100%"
      }
    };
    return Object.fromEntries(Object.entries(styles).filter(([_, value]) => value !== void 0));
  }, "Accordion_component_accordionDetailStyles_useComputed_S0QmQzGJoRo", [
    openGridItemOrder,
    props
  ]));
  return /* @__PURE__ */ qwik._jsxQ("div", null, {
    class: "builder-accordion",
    style: qwik._fnSignal((p0) => p0.value, [
      accordionStyles
    ], "p0.value")
  }, (props.items || []).map((item, index) => {
    qwik._jsxBranch();
    return /* @__PURE__ */ qwik._jsxC(qwik.Fragment, {
      children: [
        /* @__PURE__ */ qwik._jsxQ("div", {
          class: getAccordionTitleClassName(props, state, onlyOneAtATime, accordionStyles, accordionTitleStyles, openGridItemOrder, accordionDetailStyles, index),
          "data-index": index,
          onClick$: /* @__PURE__ */ qwik.inlinedQrl((event) => {
            const [accordionDetailStyles2, accordionStyles2, accordionTitleStyles2, index2, onlyOneAtATime2, openGridItemOrder2, props2, state2] = qwik.useLexicalScope();
            return onClick$2(props2, state2, onlyOneAtATime2, accordionStyles2, accordionTitleStyles2, openGridItemOrder2, accordionDetailStyles2, index2);
          }, "Accordion_component_div_Fragment_div_onClick_VtzhhJnK0XI", [
            accordionDetailStyles,
            accordionStyles,
            accordionTitleStyles,
            index,
            onlyOneAtATime,
            openGridItemOrder,
            props,
            state
          ]),
          style: {
            ...accordionTitleStyles.value,
            width: props.grid ? props.gridRowWidth : void 0,
            order: openGridItemOrder.value !== null ? convertOrderNumberToString(index) : convertOrderNumberToString(index + 1)
          }
        }, null, /* @__PURE__ */ qwik._jsxC(Blocks, {
          get blocks() {
            return item.title;
          },
          path: `items.${index}.title`,
          get parent() {
            return props.builderBlock.id;
          },
          get context() {
            return props.builderContext;
          },
          get registeredComponents() {
            return props.builderComponents;
          },
          get linkComponent() {
            return props.builderLinkComponent;
          },
          [qwik._IMMUTABLE]: {
            blocks: qwik._wrapProp(item, "title"),
            context: qwik._fnSignal((p0) => p0.builderContext, [
              props
            ], "p0.builderContext"),
            linkComponent: qwik._fnSignal((p0) => p0.builderLinkComponent, [
              props
            ], "p0.builderLinkComponent"),
            parent: qwik._fnSignal((p0) => p0.builderBlock.id, [
              props
            ], "p0.builderBlock.id"),
            registeredComponents: qwik._fnSignal((p0) => p0.builderComponents, [
              props
            ], "p0.builderComponents")
          }
        }, 3, "hf_0"), 0, null),
        state.open.includes(index) ? /* @__PURE__ */ qwik._jsxQ("div", {
          class: getAccordionDetailClassName(props, state, onlyOneAtATime, accordionStyles, accordionTitleStyles, openGridItemOrder, accordionDetailStyles, index)
        }, {
          style: qwik._fnSignal((p0) => p0.value, [
            accordionDetailStyles
          ], "p0.value")
        }, /* @__PURE__ */ qwik._jsxC(Blocks, {
          get blocks() {
            return item.detail;
          },
          path: `items.${index}.detail`,
          get parent() {
            return props.builderBlock.id;
          },
          get context() {
            return props.builderContext;
          },
          get registeredComponents() {
            return props.builderComponents;
          },
          get linkComponent() {
            return props.builderLinkComponent;
          },
          [qwik._IMMUTABLE]: {
            blocks: qwik._wrapProp(item, "detail"),
            context: qwik._fnSignal((p0) => p0.builderContext, [
              props
            ], "p0.builderContext"),
            linkComponent: qwik._fnSignal((p0) => p0.builderLinkComponent, [
              props
            ], "p0.builderLinkComponent"),
            parent: qwik._fnSignal((p0) => p0.builderBlock.id, [
              props
            ], "p0.builderBlock.id"),
            registeredComponents: qwik._fnSignal((p0) => p0.builderComponents, [
              props
            ], "p0.builderComponents")
          }
        }, 3, "hf_1"), 1, "hf_2") : null
      ]
    }, 1, "hf_3");
  }), 1, "hf_4");
}, "Accordion_component_jkuUCHm0nt0"));
const componentInfo$g = {
  name: "Core:Button",
  image: "https://cdn.builder.io/api/v1/image/assets%2FIsxPKMo2gPRRKeakUztj1D6uqed2%2F81a15681c3e74df09677dfc57a615b13",
  defaultStyles: {
    // TODO: make min width more intuitive and set one
    appearance: "none",
    paddingTop: "15px",
    paddingBottom: "15px",
    paddingLeft: "25px",
    paddingRight: "25px",
    backgroundColor: "#000000",
    color: "white",
    borderRadius: "4px",
    textAlign: "center",
    cursor: "pointer"
  },
  inputs: [
    {
      name: "text",
      type: "text",
      defaultValue: "Click me!",
      bubble: true
    },
    {
      name: "link",
      type: "url",
      bubble: true
    },
    {
      name: "openLinkInNewTab",
      type: "boolean",
      defaultValue: false,
      friendlyName: "Open link in new tab"
    }
  ],
  static: true,
  noWrap: true
};
const componentInfo$f = {
  // TODO: ways to statically preprocess JSON for references, functions, etc
  name: "Columns",
  isRSC: true,
  inputs: [
    {
      name: "columns",
      type: "array",
      broadcast: true,
      subFields: [
        {
          name: "blocks",
          type: "array",
          hideFromUI: true,
          defaultValue: [
            {
              "@type": "@builder.io/sdk:Element",
              responsiveStyles: {
                large: {
                  display: "flex",
                  flexDirection: "column",
                  alignItems: "stretch",
                  flexShrink: "0",
                  position: "relative",
                  marginTop: "30px",
                  textAlign: "center",
                  lineHeight: "normal",
                  height: "auto",
                  minHeight: "20px",
                  minWidth: "20px",
                  overflow: "hidden"
                }
              },
              component: {
                name: "Image",
                options: {
                  image: "https://builder.io/api/v1/image/assets%2Fpwgjf0RoYWbdnJSbpBAjXNRMe9F2%2Ffb27a7c790324294af8be1c35fe30f4d",
                  backgroundPosition: "center",
                  backgroundSize: "cover",
                  aspectRatio: 0.7004048582995948
                }
              }
            },
            {
              "@type": "@builder.io/sdk:Element",
              responsiveStyles: {
                large: {
                  display: "flex",
                  flexDirection: "column",
                  alignItems: "stretch",
                  flexShrink: "0",
                  position: "relative",
                  marginTop: "30px",
                  textAlign: "center",
                  lineHeight: "normal",
                  height: "auto"
                }
              },
              component: {
                name: "Text",
                options: {
                  text: "<p>Enter some text...</p>"
                }
              }
            }
          ]
        },
        {
          name: "width",
          type: "number",
          hideFromUI: true,
          helperText: "Width %, e.g. set to 50 to fill half of the space"
        },
        {
          name: "link",
          type: "url",
          helperText: "Optionally set a url that clicking this column will link to"
        }
      ],
      defaultValue: [
        {
          blocks: [
            {
              "@type": "@builder.io/sdk:Element",
              responsiveStyles: {
                large: {
                  display: "flex",
                  flexDirection: "column",
                  alignItems: "stretch",
                  flexShrink: "0",
                  position: "relative",
                  marginTop: "30px",
                  textAlign: "center",
                  lineHeight: "normal",
                  height: "auto",
                  minHeight: "20px",
                  minWidth: "20px",
                  overflow: "hidden"
                }
              },
              component: {
                name: "Image",
                options: {
                  image: "https://builder.io/api/v1/image/assets%2Fpwgjf0RoYWbdnJSbpBAjXNRMe9F2%2Ffb27a7c790324294af8be1c35fe30f4d",
                  backgroundPosition: "center",
                  backgroundSize: "cover",
                  aspectRatio: 0.7004048582995948
                }
              }
            },
            {
              "@type": "@builder.io/sdk:Element",
              responsiveStyles: {
                large: {
                  display: "flex",
                  flexDirection: "column",
                  alignItems: "stretch",
                  flexShrink: "0",
                  position: "relative",
                  marginTop: "30px",
                  textAlign: "center",
                  lineHeight: "normal",
                  height: "auto"
                }
              },
              component: {
                name: "Text",
                options: {
                  text: "<p>Enter some text...</p>"
                }
              }
            }
          ]
        },
        {
          blocks: [
            {
              "@type": "@builder.io/sdk:Element",
              responsiveStyles: {
                large: {
                  display: "flex",
                  flexDirection: "column",
                  alignItems: "stretch",
                  flexShrink: "0",
                  position: "relative",
                  marginTop: "30px",
                  textAlign: "center",
                  lineHeight: "normal",
                  height: "auto",
                  minHeight: "20px",
                  minWidth: "20px",
                  overflow: "hidden"
                }
              },
              component: {
                name: "Image",
                options: {
                  image: "https://builder.io/api/v1/image/assets%2Fpwgjf0RoYWbdnJSbpBAjXNRMe9F2%2Ffb27a7c790324294af8be1c35fe30f4d",
                  backgroundPosition: "center",
                  backgroundSize: "cover",
                  aspectRatio: 0.7004048582995948
                }
              }
            },
            {
              "@type": "@builder.io/sdk:Element",
              responsiveStyles: {
                large: {
                  display: "flex",
                  flexDirection: "column",
                  alignItems: "stretch",
                  flexShrink: "0",
                  position: "relative",
                  marginTop: "30px",
                  textAlign: "center",
                  lineHeight: "normal",
                  height: "auto"
                }
              },
              component: {
                name: "Text",
                options: {
                  text: "<p>Enter some text...</p>"
                }
              }
            }
          ]
        }
      ],
      onChange: (options) => {
        function clearWidths() {
          columns.forEach((col) => {
            col.delete("width");
          });
        }
        const columns = options.get("columns");
        if (Array.isArray(columns)) {
          const containsColumnWithWidth = !!columns.find((col) => col.get("width"));
          if (containsColumnWithWidth) {
            const containsColumnWithoutWidth = !!columns.find((col) => !col.get("width"));
            if (containsColumnWithoutWidth)
              clearWidths();
            else {
              const sumWidths = columns.reduce((memo, col) => {
                return memo + col.get("width");
              }, 0);
              const widthsDontAddUp = sumWidths !== 100;
              if (widthsDontAddUp)
                clearWidths();
            }
          }
        }
      }
    },
    {
      name: "space",
      type: "number",
      defaultValue: 20,
      helperText: "Size of gap between columns",
      advanced: true
    },
    {
      name: "stackColumnsAt",
      type: "string",
      defaultValue: "tablet",
      helperText: "Convert horizontal columns to vertical at what device size",
      enum: [
        "tablet",
        "mobile",
        "never"
      ],
      advanced: true
    },
    {
      name: "reverseColumnsWhenStacked",
      type: "boolean",
      defaultValue: false,
      helperText: "When stacking columns for mobile devices, reverse the ordering",
      advanced: true
    }
  ]
};
const componentInfo$e = {
  name: "Fragment",
  static: true,
  hidden: true,
  canHaveChildren: true,
  noWrap: true
};
const componentInfo$d = {
  name: "Image",
  static: true,
  image: "https://firebasestorage.googleapis.com/v0/b/builder-3b0a2.appspot.com/o/images%2Fbaseline-insert_photo-24px.svg?alt=media&token=4e5d0ef4-f5e8-4e57-b3a9-38d63a9b9dc4",
  defaultStyles: {
    position: "relative",
    minHeight: "20px",
    minWidth: "20px",
    overflow: "hidden"
  },
  canHaveChildren: true,
  inputs: [
    {
      name: "image",
      type: "file",
      bubble: true,
      allowedFileTypes: [
        "jpeg",
        "jpg",
        "png",
        "svg"
      ],
      required: true,
      defaultValue: "https://cdn.builder.io/api/v1/image/assets%2FYJIGb4i01jvw0SRdL5Bt%2F72c80f114dc149019051b6852a9e3b7a",
      onChange: (options) => {
        const DEFAULT_ASPECT_RATIO = 0.7041;
        options.delete("srcset");
        options.delete("noWebp");
        function loadImage(url, timeout = 6e4) {
          return new Promise((resolve, reject) => {
            const img = document.createElement("img");
            let loaded = false;
            img.onload = () => {
              loaded = true;
              resolve(img);
            };
            img.addEventListener("error", (event) => {
              console.warn("Image load failed", event.error);
              reject(event.error);
            });
            img.src = url;
            setTimeout(() => {
              if (!loaded)
                reject(new Error("Image load timed out"));
            }, timeout);
          });
        }
        function round2(num) {
          return Math.round(num * 1e3) / 1e3;
        }
        const value = options.get("image");
        const aspectRatio = options.get("aspectRatio");
        fetch(value).then((res) => res.blob()).then((blob) => {
          if (blob.type.includes("svg"))
            options.set("noWebp", true);
        });
        if (value && (!aspectRatio || aspectRatio === DEFAULT_ASPECT_RATIO))
          return loadImage(value).then((img) => {
            const possiblyUpdatedAspectRatio = options.get("aspectRatio");
            if (options.get("image") === value && (!possiblyUpdatedAspectRatio || possiblyUpdatedAspectRatio === DEFAULT_ASPECT_RATIO)) {
              if (img.width && img.height) {
                options.set("aspectRatio", round2(img.height / img.width));
                options.set("height", img.height);
                options.set("width", img.width);
              }
            }
          });
      }
    },
    {
      name: "backgroundSize",
      type: "text",
      defaultValue: "cover",
      enum: [
        {
          label: "contain",
          value: "contain",
          helperText: "The image should never get cropped"
        },
        {
          label: "cover",
          value: "cover",
          helperText: "The image should fill it's box, cropping when needed"
        }
      ]
    },
    {
      name: "backgroundPosition",
      type: "text",
      defaultValue: "center",
      enum: [
        "center",
        "top",
        "left",
        "right",
        "bottom",
        "top left",
        "top right",
        "bottom left",
        "bottom right"
      ]
    },
    {
      name: "altText",
      type: "string",
      helperText: "Text to display when the user has images off"
    },
    {
      name: "height",
      type: "number",
      hideFromUI: true
    },
    {
      name: "width",
      type: "number",
      hideFromUI: true
    },
    {
      name: "sizes",
      type: "string",
      hideFromUI: true
    },
    {
      name: "srcset",
      type: "string",
      hideFromUI: true
    },
    {
      name: "lazy",
      type: "boolean",
      defaultValue: true,
      hideFromUI: true
    },
    {
      name: "fitContent",
      type: "boolean",
      helperText: "When child blocks are provided, fit to them instead of using the image's aspect ratio",
      defaultValue: true
    },
    {
      name: "aspectRatio",
      type: "number",
      helperText: "This is the ratio of height/width, e.g. set to 1.5 for a 300px wide and 200px tall photo. Set to 0 to not force the image to maintain it's aspect ratio",
      advanced: true,
      defaultValue: 0.7041
    }
  ]
};
const componentInfo$c = {
  name: "Core:Section",
  static: true,
  image: "https://cdn.builder.io/api/v1/image/assets%2FIsxPKMo2gPRRKeakUztj1D6uqed2%2F682efef23ace49afac61748dd305c70a",
  inputs: [
    {
      name: "maxWidth",
      type: "number",
      defaultValue: 1200
    },
    {
      name: "lazyLoad",
      type: "boolean",
      defaultValue: false,
      advanced: true,
      description: "Only render this section when in view"
    }
  ],
  defaultStyles: {
    paddingLeft: "20px",
    paddingRight: "20px",
    paddingTop: "50px",
    paddingBottom: "50px",
    marginTop: "0px",
    width: "100vw",
    marginLeft: "calc(50% - 50vw)"
  },
  canHaveChildren: true,
  defaultChildren: [
    {
      "@type": "@builder.io/sdk:Element",
      responsiveStyles: {
        large: {
          textAlign: "center"
        }
      },
      component: {
        name: "Text",
        options: {
          text: "<p><b>I am a section! My content keeps from getting too wide, so that it's easy to read even on big screens.</b></p><p>Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur</p>"
        }
      }
    }
  ]
};
const componentInfo$b = {
  name: "Slot",
  isRSC: true,
  description: "Allow child blocks to be inserted into this content when used as a Symbol",
  docsLink: "https://www.builder.io/c/docs/symbols-with-blocks",
  image: "https://cdn.builder.io/api/v1/image/assets%2FYJIGb4i01jvw0SRdL5Bt%2F3aad6de36eae43b59b52c85190fdef56",
  // Maybe wrap this for canHaveChildren so bind children to this hm
  inputs: [
    {
      name: "name",
      type: "string",
      required: true,
      defaultValue: "children"
    }
  ]
};
const Slot = /* @__PURE__ */ qwik.componentQrl(/* @__PURE__ */ qwik.inlinedQrl((props) => {
  var _a, _b;
  return /* @__PURE__ */ qwik._jsxS("div", {
    ...!((_a = props.builderContext.context) == null ? void 0 : _a.symbolId) && {
      "builder-slot": props.name
    },
    children: /* @__PURE__ */ qwik._jsxC(Blocks, {
      get parent() {
        var _a2;
        return (_a2 = props.builderContext.context) == null ? void 0 : _a2.symbolId;
      },
      get path() {
        return `symbol.data.${props.name}`;
      },
      get context() {
        return props.builderContext;
      },
      blocks: deoptSignal((_b = props.builderContext.rootState) == null ? void 0 : _b[props.name]),
      [qwik._IMMUTABLE]: {
        context: qwik._fnSignal((p0) => p0.builderContext, [
          props
        ], "p0.builderContext"),
        parent: qwik._fnSignal((p0) => {
          var _a2;
          return (_a2 = p0.builderContext.context) == null ? void 0 : _a2.symbolId;
        }, [
          props
        ], "p0.builderContext.context?.symbolId"),
        path: qwik._fnSignal((p0) => `symbol.data.${p0.name}`, [
          props
        ], "`symbol.data.${p0.name}`")
      }
    }, 3, "B1_0")
  }, {
    style: {
      pointerEvents: "auto"
    }
  }, 0, "B1_1");
}, "Slot_component_WWgWgfV0bb0"));
const componentInfo$a = {
  name: "Symbol",
  noWrap: true,
  static: true,
  isRSC: true,
  inputs: [
    {
      name: "symbol",
      type: "uiSymbol"
    },
    {
      name: "dataOnly",
      helperText: "Make this a data symbol that doesn't display any UI",
      type: "boolean",
      defaultValue: false,
      advanced: true,
      hideFromUI: true
    },
    {
      name: "inheritState",
      helperText: "Inherit the parent component state and data",
      type: "boolean",
      defaultValue: false,
      advanced: true
    },
    {
      name: "renderToLiquid",
      helperText: "Render this symbols contents to liquid. Turn off to fetch with javascript and use custom targeting",
      type: "boolean",
      defaultValue: false,
      advanced: true,
      hideFromUI: true
    },
    {
      name: "useChildren",
      hideFromUI: true,
      type: "boolean"
    }
  ]
};
const defaultTab = {
  "@type": "@builder.io/sdk:Element",
  responsiveStyles: {
    large: {
      paddingLeft: "20px",
      paddingRight: "20px",
      paddingTop: "10px",
      paddingBottom: "10px",
      minWidth: "100px",
      textAlign: "center",
      display: "flex",
      flexDirection: "column",
      cursor: "pointer",
      userSelect: "none"
    }
  },
  component: {
    name: "Text",
    options: {
      text: "New tab"
    }
  }
};
const defaultElement = {
  "@type": "@builder.io/sdk:Element",
  responsiveStyles: {
    large: {
      height: "200px",
      display: "flex",
      marginTop: "20px",
      flexDirection: "column"
    }
  },
  component: {
    name: "Text",
    options: {
      text: "New tab content "
    }
  }
};
const componentInfo$9 = {
  name: "Builder: Tabs",
  inputs: [
    {
      name: "tabs",
      type: "list",
      broadcast: true,
      subFields: [
        {
          name: "label",
          type: "uiBlocks",
          hideFromUI: true,
          defaultValue: [
            defaultTab
          ]
        },
        {
          name: "content",
          type: "uiBlocks",
          hideFromUI: true,
          defaultValue: [
            defaultElement
          ]
        }
      ],
      defaultValue: [
        {
          label: [
            {
              ...defaultTab,
              component: {
                name: "Text",
                options: {
                  text: "Tab 1"
                }
              }
            }
          ],
          content: [
            {
              ...defaultElement,
              component: {
                name: "Text",
                options: {
                  text: "Tab 1 content"
                }
              }
            }
          ]
        },
        {
          label: [
            {
              ...defaultTab,
              component: {
                name: "Text",
                options: {
                  text: "Tab 2"
                }
              }
            }
          ],
          content: [
            {
              ...defaultElement,
              component: {
                name: "Text",
                options: {
                  text: "Tab 2 content"
                }
              }
            }
          ]
        }
      ]
    },
    {
      name: "activeTabStyle",
      type: "uiStyle",
      helperText: "CSS styles for the active tab",
      defaultValue: {
        backgroundColor: "rgba(0, 0, 0, 0.1)"
      }
    },
    {
      name: "defaultActiveTab",
      type: "number",
      helperText: 'Default tab to open to. Set to "1" for the first tab, "2" for the second, or choose "0" for none',
      defaultValue: 1,
      advanced: true
    },
    {
      name: "collapsible",
      type: "boolean",
      helperText: "If on, clicking an open tab closes it so no tabs are active",
      defaultValue: false,
      advanced: true
    },
    {
      name: "tabHeaderLayout",
      type: "enum",
      helperText: "Change the layout of the tab headers (uses justify-content)",
      defaultValue: "flex-start",
      enum: [
        {
          label: "Center",
          value: "center"
        },
        {
          label: "Space between",
          value: "space-between"
        },
        {
          label: "Space around",
          value: "space-around"
        },
        {
          label: "Left",
          value: "flex-start"
        },
        {
          label: "Right",
          value: "flex-end"
        }
      ]
    }
  ]
};
const activeTabContent = function activeTabContent2(props, state, active) {
  return props.tabs && props.tabs[active].content;
};
const onClick$1 = function onClick23(props, state, index) {
  if (index === state.activeTab && props.collapsible)
    state.activeTab = -1;
  else
    state.activeTab = index;
};
const Tabs = /* @__PURE__ */ qwik.componentQrl(/* @__PURE__ */ qwik.inlinedQrl((props) => {
  qwik._jsxBranch();
  const state = qwik.useStore({
    activeTab: props.defaultActiveTab ? props.defaultActiveTab - 1 : 0
  });
  return /* @__PURE__ */ qwik._jsxQ("div", null, null, [
    /* @__PURE__ */ qwik._jsxQ("div", null, {
      class: "builder-tabs-wrap",
      style: qwik._fnSignal((p0) => ({
        display: "flex",
        flexDirection: "row",
        justifyContent: p0.tabHeaderLayout || "flex-start",
        overflow: "auto"
      }), [
        props
      ], '{display:"flex",flexDirection:"row",justifyContent:p0.tabHeaderLayout||"flex-start",overflow:"auto"}')
    }, (props.tabs || []).map((tab, index) => {
      return /* @__PURE__ */ qwik._jsxQ("span", {
        class: `builder-tab-wrap ${state.activeTab === index ? "builder-tab-active" : ""}`,
        onClick$: /* @__PURE__ */ qwik.inlinedQrl((event) => {
          const [index2, props2, state2] = qwik.useLexicalScope();
          return onClick$1(props2, state2, index2);
        }, "Tabs_component_div_div_span_onClick_hSTBabAHGks", [
          index,
          props,
          state
        ]),
        style: {
          ...state.activeTab === index ? props.activeTabStyle : {}
        }
      }, null, /* @__PURE__ */ qwik._jsxC(Blocks, {
        get parent() {
          return props.builderBlock.id;
        },
        path: `component.options.tabs.${index}.label`,
        get blocks() {
          return tab.label;
        },
        get context() {
          return props.builderContext;
        },
        get registeredComponents() {
          return props.builderComponents;
        },
        get linkComponent() {
          return props.builderLinkComponent;
        },
        [qwik._IMMUTABLE]: {
          blocks: qwik._wrapProp(tab, "label"),
          context: qwik._fnSignal((p0) => p0.builderContext, [
            props
          ], "p0.builderContext"),
          linkComponent: qwik._fnSignal((p0) => p0.builderLinkComponent, [
            props
          ], "p0.builderLinkComponent"),
          parent: qwik._fnSignal((p0) => p0.builderBlock.id, [
            props
          ], "p0.builderBlock.id"),
          registeredComponents: qwik._fnSignal((p0) => p0.builderComponents, [
            props
          ], "p0.builderComponents")
        }
      }, 3, "6k_0"), 0, index);
    }), 1, null),
    activeTabContent(props, state, state.activeTab) ? /* @__PURE__ */ qwik._jsxQ("div", null, null, /* @__PURE__ */ qwik._jsxC(Blocks, {
      get parent() {
        return props.builderBlock.id;
      },
      get path() {
        return `component.options.tabs.${state.activeTab}.content`;
      },
      blocks: activeTabContent(props, state, state.activeTab),
      get context() {
        return props.builderContext;
      },
      get registeredComponents() {
        return props.builderComponents;
      },
      get linkComponent() {
        return props.builderLinkComponent;
      },
      [qwik._IMMUTABLE]: {
        context: qwik._fnSignal((p0) => p0.builderContext, [
          props
        ], "p0.builderContext"),
        linkComponent: qwik._fnSignal((p0) => p0.builderLinkComponent, [
          props
        ], "p0.builderLinkComponent"),
        parent: qwik._fnSignal((p0) => p0.builderBlock.id, [
          props
        ], "p0.builderBlock.id"),
        path: qwik._fnSignal((p0) => `component.options.tabs.${p0.activeTab}.content`, [
          state
        ], "`component.options.tabs.${p0.activeTab}.content`"),
        registeredComponents: qwik._fnSignal((p0) => p0.builderComponents, [
          props
        ], "p0.builderComponents")
      }
    }, 3, "6k_1"), 1, "6k_2") : null
  ], 1, "6k_3");
}, "Tabs_component_MhWcxXy0lMY"));
const componentInfo$8 = {
  name: "Text",
  static: true,
  isRSC: true,
  image: "https://firebasestorage.googleapis.com/v0/b/builder-3b0a2.appspot.com/o/images%2Fbaseline-text_fields-24px%20(1).svg?alt=media&token=12177b73-0ee3-42ca-98c6-0dd003de1929",
  inputs: [
    {
      name: "text",
      type: "html",
      required: true,
      autoFocus: true,
      bubble: true,
      defaultValue: "Enter some text..."
    }
  ],
  defaultStyles: {
    lineHeight: "normal",
    height: "auto",
    textAlign: "center"
  }
};
const Text = /* @__PURE__ */ qwik.componentQrl(/* @__PURE__ */ qwik.inlinedQrl((props) => {
  return /* @__PURE__ */ qwik._jsxQ("div", null, {
    class: "builder-text",
    dangerouslySetInnerHTML: qwik._fnSignal((p0) => {
      var _a;
      return ((_a = p0.text) == null ? void 0 : _a.toString()) || "";
    }, [
      props
    ], 'p0.text?.toString()||""'),
    style: {
      outline: "none"
    }
  }, null, 3, "yO_0");
}, "Text_component_15p0cKUxgIE"));
const componentInfo$7 = {
  name: "Custom Code",
  static: true,
  requiredPermissions: [
    "editCode"
  ],
  inputs: [
    {
      name: "code",
      type: "html",
      required: true,
      defaultValue: "<p>Hello there, I am custom HTML code!</p>",
      code: true
    },
    {
      name: "replaceNodes",
      type: "boolean",
      helperText: "Preserve server rendered dom nodes",
      advanced: true
    },
    {
      name: "scriptsClientOnly",
      type: "boolean",
      defaultValue: false,
      helperText: "Only print and run scripts on the client. Important when scripts influence DOM that could be replaced when client loads",
      advanced: true
    }
  ]
};
const CustomCode = /* @__PURE__ */ qwik.componentQrl(/* @__PURE__ */ qwik.inlinedQrl((props) => {
  const elementRef = qwik.useSignal();
  const state = qwik.useStore({
    scriptsInserted: [],
    scriptsRun: []
  });
  qwik.useOn("qvisible", /* @__PURE__ */ qwik.inlinedQrl((event, element) => {
    const [state2] = qwik.useLexicalScope();
    if (!(element == null ? void 0 : element.getElementsByTagName) || typeof window === "undefined")
      return;
    const scripts = element.getElementsByTagName("script");
    for (let i = 0; i < scripts.length; i++) {
      const script = scripts[i];
      if (script.src) {
        if (state2.scriptsInserted.includes(script.src))
          continue;
        state2.scriptsInserted.push(script.src);
        const newScript = document.createElement("script");
        newScript.async = true;
        newScript.src = script.src;
        document.head.appendChild(newScript);
      } else if (!script.type || [
        "text/javascript",
        "application/javascript",
        "application/ecmascript"
      ].includes(script.type)) {
        if (state2.scriptsRun.includes(script.innerText))
          continue;
        try {
          state2.scriptsRun.push(script.innerText);
          new Function(script.innerText)();
        } catch (error) {
          console.warn("`CustomCode`: Error running script:", error);
        }
      }
    }
  }, "CustomCode_component_useOn_zjAgBhFOiCs", [
    state
  ]));
  return /* @__PURE__ */ qwik._jsxQ("div", {
    ref: elementRef
  }, {
    class: qwik._fnSignal((p0) => "builder-custom-code" + (p0.replaceNodes ? " replace-nodes" : ""), [
      props
    ], '"builder-custom-code"+(p0.replaceNodes?" replace-nodes":"")'),
    dangerouslySetInnerHTML: qwik._fnSignal((p0) => p0.code, [
      props
    ], "p0.code")
  }, null, 3, "bY_0");
}, "CustomCode_component_uYOSy7w7Zqw"));
const componentInfo$6 = {
  name: "Embed",
  static: true,
  inputs: [
    {
      name: "url",
      type: "url",
      required: true,
      defaultValue: "",
      helperText: "e.g. enter a youtube url, google map, etc",
      onChange: (options) => {
        const url = options.get("url");
        if (url) {
          options.set("content", "Loading...");
          const apiKey = "ae0e60e78201a3f2b0de4b";
          return fetch(`https://iframe.ly/api/iframely?url=${url}&api_key=${apiKey}`).then((res) => res.json()).then((data) => {
            if (options.get("url") === url) {
              if (data.html)
                options.set("content", data.html);
              else
                options.set("content", "Invalid url, please try another");
            }
          }).catch((_err) => {
            options.set("content", "There was an error embedding this URL, please try again or another URL");
          });
        } else
          options.delete("content");
      }
    },
    {
      name: "content",
      type: "html",
      defaultValue: '<div style="padding: 20px; text-align: center">(Choose an embed URL)<div>',
      hideFromUI: true
    }
  ]
};
const SCRIPT_MIME_TYPES = [
  "text/javascript",
  "application/javascript",
  "application/ecmascript"
];
const isJsScript = (script) => SCRIPT_MIME_TYPES.includes(script.type);
const findAndRunScripts = function findAndRunScripts2(props, state, elem) {
  if (!elem.value || !elem.value.getElementsByTagName)
    return;
  const scripts = elem.value.getElementsByTagName("script");
  for (let i = 0; i < scripts.length; i++) {
    const script = scripts[i];
    if (script.src && !state.scriptsInserted.includes(script.src)) {
      state.scriptsInserted.push(script.src);
      const newScript = document.createElement("script");
      newScript.async = true;
      newScript.src = script.src;
      document.head.appendChild(newScript);
    } else if (isJsScript(script) && !state.scriptsRun.includes(script.innerText))
      try {
        state.scriptsRun.push(script.innerText);
        new Function(script.innerText)();
      } catch (error) {
        console.warn("`Embed`: Error running script:", error);
      }
  }
};
const Embed = /* @__PURE__ */ qwik.componentQrl(/* @__PURE__ */ qwik.inlinedQrl((props) => {
  const elem = qwik.useSignal();
  const state = qwik.useStore({
    ranInitFn: false,
    scriptsInserted: [],
    scriptsRun: []
  });
  qwik.useTaskQrl(/* @__PURE__ */ qwik.inlinedQrl(({ track: track2 }) => {
    const [elem2, props2, state2] = qwik.useLexicalScope();
    track2(() => elem2.value);
    track2(() => state2.ranInitFn);
    if (elem2.value && !state2.ranInitFn) {
      state2.ranInitFn = true;
      findAndRunScripts(props2, state2, elem2);
    }
  }, "Embed_component_useTask_bg7ez0XUtiM", [
    elem,
    props,
    state
  ]));
  return /* @__PURE__ */ qwik._jsxQ("div", {
    ref: elem
  }, {
    class: "builder-embed",
    dangerouslySetInnerHTML: qwik._fnSignal((p0) => p0.content, [
      props
    ], "p0.content")
  }, null, 3, "9r_0");
}, "Embed_component_Uji08ORjXbE"));
const componentInfo$5 = {
  name: "Form:Form",
  // editableTags: ['builder-form-error']
  defaults: {
    responsiveStyles: {
      large: {
        marginTop: "15px",
        paddingBottom: "15px"
      }
    }
  },
  image: "https://cdn.builder.io/api/v1/image/assets%2FIsxPKMo2gPRRKeakUztj1D6uqed2%2Fef36d2a846134910b64b88e6d18c5ca5",
  inputs: [
    {
      name: "sendSubmissionsTo",
      type: "string",
      // TODO: save to builder data and user can download as csv
      // TODO: easy for mode too or computed add/remove fields form mode
      // so you can edit details and high level mode at same time...
      // Later - more integrations like mailchimp
      // /api/v1/form-submit?to=mailchimp
      enum: [
        {
          label: "Send to email",
          value: "email",
          helperText: "Send form submissions to the email address of your choosing"
        },
        {
          label: "Custom",
          value: "custom",
          helperText: "Handle where the form requests go manually with a little code, e.g. to your own custom backend"
        }
      ],
      defaultValue: "email"
    },
    {
      name: "sendSubmissionsToEmail",
      type: "string",
      required: true,
      // TODO: required: () => options.get("sendSubmissionsTo") === "email"
      defaultValue: "your@email.com",
      showIf: 'options.get("sendSubmissionsTo") === "email"'
    },
    {
      name: "sendWithJs",
      type: "boolean",
      helperText: "Set to false to use basic html form action",
      defaultValue: true,
      showIf: 'options.get("sendSubmissionsTo") === "custom"'
    },
    {
      name: "name",
      type: "string",
      defaultValue: "My form"
    },
    {
      name: "action",
      type: "string",
      helperText: "URL to send the form data to",
      showIf: 'options.get("sendSubmissionsTo") === "custom"'
    },
    {
      name: "contentType",
      type: "string",
      defaultValue: "application/json",
      advanced: true,
      // TODO: do automatically if file input
      enum: [
        "application/json",
        "multipart/form-data",
        "application/x-www-form-urlencoded"
      ],
      showIf: 'options.get("sendSubmissionsTo") === "custom" && options.get("sendWithJs") === true'
    },
    {
      name: "method",
      type: "string",
      showIf: 'options.get("sendSubmissionsTo") === "custom"',
      defaultValue: "POST",
      advanced: true
    },
    {
      name: "previewState",
      type: "string",
      // TODO: persist: false flag
      enum: [
        "unsubmitted",
        "sending",
        "success",
        "error"
      ],
      defaultValue: "unsubmitted",
      helperText: 'Choose a state to edit, e.g. choose "success" to show what users see on success and edit the message',
      showIf: 'options.get("sendSubmissionsTo") !== "zapier" && options.get("sendWithJs") === true'
    },
    {
      name: "successUrl",
      type: "url",
      helperText: "Optional URL to redirect the user to on form submission success",
      showIf: 'options.get("sendSubmissionsTo") !== "zapier" && options.get("sendWithJs") === true'
    },
    {
      name: "resetFormOnSubmit",
      type: "boolean",
      showIf: "options.get('sendSubmissionsTo') === 'custom' && options.get('sendWithJs') === true",
      advanced: true
    },
    {
      name: "successMessage",
      type: "uiBlocks",
      hideFromUI: true,
      defaultValue: [
        {
          "@type": "@builder.io/sdk:Element",
          responsiveStyles: {
            large: {
              marginTop: "10px"
            }
          },
          component: {
            name: "Text",
            options: {
              text: "<span>Thanks!</span>"
            }
          }
        }
      ]
    },
    {
      name: "validate",
      type: "boolean",
      defaultValue: true,
      advanced: true
    },
    {
      name: "errorMessagePath",
      type: "text",
      advanced: true,
      helperText: 'Path to where to get the error message from in a JSON response to display to the user, e.g. "error.message" for a response like { "error": { "message": "this username is taken" }}'
    },
    {
      name: "errorMessage",
      type: "uiBlocks",
      hideFromUI: true,
      defaultValue: [
        {
          "@type": "@builder.io/sdk:Element",
          responsiveStyles: {
            large: {
              marginTop: "10px"
            }
          },
          bindings: {
            "component.options.text": "state.formErrorMessage || block.component.options.text"
          },
          component: {
            name: "Text",
            options: {
              text: "<span>Form submission error :( Please check your answers and try again</span>"
            }
          }
        }
      ]
    },
    {
      name: "sendingMessage",
      type: "uiBlocks",
      hideFromUI: true,
      defaultValue: [
        {
          "@type": "@builder.io/sdk:Element",
          responsiveStyles: {
            large: {
              marginTop: "10px"
            }
          },
          component: {
            name: "Text",
            options: {
              text: "<span>Sending...</span>"
            }
          }
        }
      ]
    },
    {
      name: "customHeaders",
      type: "map",
      valueType: {
        type: "string"
      },
      advanced: true,
      showIf: 'options.get("sendSubmissionsTo") === "custom" && options.get("sendWithJs") === true'
    }
  ],
  noWrap: true,
  canHaveChildren: true,
  defaultChildren: [
    {
      "@type": "@builder.io/sdk:Element",
      responsiveStyles: {
        large: {
          marginTop: "10px"
        }
      },
      component: {
        name: "Text",
        options: {
          text: "<span>Enter your name</span>"
        }
      }
    },
    {
      "@type": "@builder.io/sdk:Element",
      responsiveStyles: {
        large: {
          marginTop: "10px"
        }
      },
      component: {
        name: "Form:Input",
        options: {
          name: "name",
          placeholder: "Jane Doe"
        }
      }
    },
    {
      "@type": "@builder.io/sdk:Element",
      responsiveStyles: {
        large: {
          marginTop: "10px"
        }
      },
      component: {
        name: "Text",
        options: {
          text: "<span>Enter your email</span>"
        }
      }
    },
    {
      "@type": "@builder.io/sdk:Element",
      responsiveStyles: {
        large: {
          marginTop: "10px"
        }
      },
      component: {
        name: "Form:Input",
        options: {
          name: "email",
          placeholder: "jane@doe.com"
        }
      }
    },
    {
      "@type": "@builder.io/sdk:Element",
      responsiveStyles: {
        large: {
          marginTop: "10px"
        }
      },
      component: {
        name: "Form:SubmitButton",
        options: {
          text: "Submit"
        }
      }
    }
  ]
};
const validEnvList = [
  "production",
  "qa",
  "test",
  "development",
  "dev",
  "cdn-qa",
  "cloud",
  "fast",
  "cdn2",
  "cdn-prod"
];
const getEnv = () => {
  const env = process.env.NODE_ENV || "production";
  return validEnvList.includes(env) ? env : "production";
};
const get = (obj, path, defaultValue) => {
  const result = String.prototype.split.call(path, /[,[\].]+?/).filter(Boolean).reduce((res, key) => res !== null && res !== void 0 ? res[key] : res, obj);
  return result === void 0 || result === obj ? defaultValue : result;
};
const mergeNewRootState$1 = function mergeNewRootState2(props, state, formRef, newData) {
  var _a, _b;
  const combinedState = {
    ...props.builderContext.rootState,
    ...newData
  };
  if (props.builderContext.rootSetState)
    (_b = (_a = props.builderContext).rootSetState) == null ? void 0 : _b.call(_a, combinedState);
  else
    props.builderContext.rootState = combinedState;
};
const submissionState = function submissionState2(props, state, formRef) {
  return isEditing() && props.previewState || state.formState;
};
const onSubmit = function onSubmit2(props, state, formRef, event) {
  var _a;
  const sendWithJsProp = props.sendWithJs || props.sendSubmissionsTo === "email";
  if (props.sendSubmissionsTo === "zapier")
    event.preventDefault();
  else if (sendWithJsProp) {
    if (!(props.action || props.sendSubmissionsTo === "email")) {
      event.preventDefault();
      return;
    }
    event.preventDefault();
    const el = event.currentTarget || event.target;
    const headers = props.customHeaders || {};
    let body;
    const formData = new FormData(el);
    const formPairs = Array.from(el.querySelectorAll("input,select,textarea")).filter((el2) => !!el2.name).map((el2) => {
      let value;
      const key = el2.name;
      if (el2 instanceof HTMLInputElement) {
        if (el2.type === "radio") {
          if (el2.checked) {
            value = el2.name;
            return {
              key,
              value
            };
          }
        } else if (el2.type === "checkbox")
          value = el2.checked;
        else if (el2.type === "number" || el2.type === "range") {
          const num = el2.valueAsNumber;
          if (!isNaN(num))
            value = num;
        } else if (el2.type === "file")
          value = el2.files;
        else
          value = el2.value;
      } else
        value = el2.value;
      return {
        key,
        value
      };
    });
    let formContentType = props.contentType;
    if (props.sendSubmissionsTo === "email")
      formContentType = "multipart/form-data";
    Array.from(formPairs).forEach(({ value }) => {
      if (value instanceof File || Array.isArray(value) && value[0] instanceof File || value instanceof FileList)
        formContentType = "multipart/form-data";
    });
    if (formContentType !== "application/json")
      body = formData;
    else {
      const json = {};
      Array.from(formPairs).forEach(({ value, key }) => {
        set(json, key, value);
      });
      body = JSON.stringify(json);
    }
    if (formContentType && formContentType !== "multipart/form-data") {
      if (
        /* Zapier doesn't allow content-type header to be sent from browsers */
        !(sendWithJsProp && ((_a = props.action) == null ? void 0 : _a.includes("zapier.com")))
      )
        headers["content-type"] = formContentType;
    }
    const presubmitEvent = new CustomEvent("presubmit", {
      detail: {
        body
      }
    });
    if (formRef.value) {
      formRef.value.dispatchEvent(presubmitEvent);
      if (presubmitEvent.defaultPrevented)
        return;
    }
    state.formState = "sending";
    const formUrl = `${getEnv() === "dev" ? "http://localhost:5000" : "https://builder.io"}/api/v1/form-submit?apiKey=${props.builderContext.apiKey}&to=${btoa(props.sendSubmissionsToEmail || "")}&name=${encodeURIComponent(props.name || "")}`;
    fetch(props.sendSubmissionsTo === "email" ? formUrl : props.action, {
      body,
      headers,
      method: props.method || "post"
    }).then(async (res) => {
      let body2;
      const contentType = res.headers.get("content-type");
      if (contentType && contentType.indexOf("application/json") !== -1)
        body2 = await res.json();
      else
        body2 = await res.text();
      if (!res.ok && props.errorMessagePath) {
        let message = get(body2, props.errorMessagePath);
        if (message) {
          if (typeof message !== "string")
            message = JSON.stringify(message);
          state.formErrorMessage = message;
          mergeNewRootState$1(props, state, formRef, {
            formErrorMessage: message
          });
        }
      }
      state.responseData = body2;
      state.formState = res.ok ? "success" : "error";
      if (res.ok) {
        const submitSuccessEvent = new CustomEvent("submit:success", {
          detail: {
            res,
            body: body2
          }
        });
        if (formRef.value) {
          formRef.value.dispatchEvent(submitSuccessEvent);
          if (submitSuccessEvent.defaultPrevented)
            return;
          if (props.resetFormOnSubmit !== false)
            formRef.value.reset();
        }
        if (props.successUrl) {
          if (formRef.value) {
            const event2 = new CustomEvent("route", {
              detail: {
                url: props.successUrl
              }
            });
            formRef.value.dispatchEvent(event2);
            if (!event2.defaultPrevented)
              location.href = props.successUrl;
          } else
            location.href = props.successUrl;
        }
      }
    }, (err) => {
      const submitErrorEvent = new CustomEvent("submit:error", {
        detail: {
          error: err
        }
      });
      if (formRef.value) {
        formRef.value.dispatchEvent(submitErrorEvent);
        if (submitErrorEvent.defaultPrevented)
          return;
      }
      state.responseData = err;
      state.formState = "error";
    });
  }
};
const FormComponent = /* @__PURE__ */ qwik.componentQrl(/* @__PURE__ */ qwik.inlinedQrl((props) => {
  var _a;
  qwik._jsxBranch();
  qwik.useStylesScopedQrl(/* @__PURE__ */ qwik.inlinedQrl(STYLES, "FormComponent_component_useStylesScoped_SVdPvm0do3s"));
  const formRef = qwik.useSignal();
  const state = qwik.useStore({
    formErrorMessage: "",
    formState: "unsubmitted",
    responseData: null
  });
  return /* @__PURE__ */ qwik._jsxS("form", {
    action: (() => {
      !props.sendWithJs && props.action;
    })(),
    ref: formRef,
    ...props.attributes,
    children: [
      props.builderBlock && props.builderBlock.children ? (((_a = props.builderBlock) == null ? void 0 : _a.children) || []).map((block, idx) => {
        return /* @__PURE__ */ qwik._jsxC(Block, {
          block,
          get context() {
            return props.builderContext;
          },
          get registeredComponents() {
            return props.builderComponents;
          },
          get linkComponent() {
            return props.builderLinkComponent;
          },
          [qwik._IMMUTABLE]: {
            context: qwik._fnSignal((p0) => p0.builderContext, [
              props
            ], "p0.builderContext"),
            linkComponent: qwik._fnSignal((p0) => p0.builderLinkComponent, [
              props
            ], "p0.builderLinkComponent"),
            registeredComponents: qwik._fnSignal((p0) => p0.builderComponents, [
              props
            ], "p0.builderComponents")
          }
        }, 3, `form-block-${idx}`);
      }) : null,
      submissionState(props, state) === "error" ? /* @__PURE__ */ qwik._jsxC(Blocks, {
        path: "errorMessage",
        get blocks() {
          return props.errorMessage;
        },
        get context() {
          return props.builderContext;
        },
        [qwik._IMMUTABLE]: {
          blocks: qwik._fnSignal((p0) => p0.errorMessage, [
            props
          ], "p0.errorMessage"),
          context: qwik._fnSignal((p0) => p0.builderContext, [
            props
          ], "p0.builderContext"),
          path: qwik._IMMUTABLE
        }
      }, 3, "0n_0") : null,
      submissionState(props, state) === "sending" ? /* @__PURE__ */ qwik._jsxC(Blocks, {
        path: "sendingMessage",
        get blocks() {
          return props.sendingMessage;
        },
        get context() {
          return props.builderContext;
        },
        [qwik._IMMUTABLE]: {
          blocks: qwik._fnSignal((p0) => p0.sendingMessage, [
            props
          ], "p0.sendingMessage"),
          context: qwik._fnSignal((p0) => p0.builderContext, [
            props
          ], "p0.builderContext"),
          path: qwik._IMMUTABLE
        }
      }, 3, "0n_1") : null,
      submissionState(props, state) === "error" && state.responseData ? /* @__PURE__ */ qwik._jsxQ("pre", null, {
        class: "builder-form-error-text pre-FormComponent"
      }, JSON.stringify(state.responseData, null, 2), 1, "0n_2") : null,
      submissionState(props, state) === "success" ? /* @__PURE__ */ qwik._jsxC(Blocks, {
        path: "successMessage",
        get blocks() {
          return props.successMessage;
        },
        get context() {
          return props.builderContext;
        },
        [qwik._IMMUTABLE]: {
          blocks: qwik._fnSignal((p0) => p0.successMessage, [
            props
          ], "p0.successMessage"),
          context: qwik._fnSignal((p0) => p0.builderContext, [
            props
          ], "p0.builderContext"),
          path: qwik._IMMUTABLE
        }
      }, 3, "0n_3") : null
    ],
    onSubmit$: /* @__PURE__ */ qwik.inlinedQrl((event) => {
      const [formRef2, props2, state2] = qwik.useLexicalScope();
      return onSubmit(props2, state2, formRef2, event);
    }, "FormComponent_component_form_onSubmit_F3ZFTlkNAQk", [
      formRef,
      props,
      state
    ])
  }, {
    method: qwik._fnSignal((p0) => p0.method, [
      props
    ], "p0.method"),
    name: qwik._fnSignal((p0) => p0.name, [
      props
    ], "p0.name"),
    "preventdefault:submit": true,
    validate: qwik._fnSignal((p0) => p0.validate, [
      props
    ], "p0.validate")
  }, 0, "0n_4");
}, "FormComponent_component_dk5c15Rvsfg"));
const STYLES = `
.pre-FormComponent {
  padding: 10px;
  color: red;
  text-align: center;
}
`;
const componentInfo$4 = {
  name: "Form:Input",
  image: "https://cdn.builder.io/api/v1/image/assets%2FIsxPKMo2gPRRKeakUztj1D6uqed2%2Fad6f37889d9e40bbbbc72cdb5875d6ca",
  inputs: [
    {
      name: "type",
      type: "text",
      enum: [
        "text",
        "number",
        "email",
        "url",
        "checkbox",
        "radio",
        "range",
        "date",
        "datetime-local",
        "search",
        "tel",
        "time",
        "file",
        "month",
        "week",
        "password",
        "color",
        "hidden"
      ],
      defaultValue: "text"
    },
    {
      name: "name",
      type: "string",
      required: true,
      helperText: 'Every input in a form needs a unique name describing what it takes, e.g. "email"'
    },
    {
      name: "placeholder",
      type: "string",
      defaultValue: "Hello there",
      helperText: "Text to display when there is no value"
    },
    // TODO: handle value vs default value automatically like ng-model
    {
      name: "defaultValue",
      type: "string"
    },
    {
      name: "value",
      type: "string",
      advanced: true
    },
    {
      name: "required",
      type: "boolean",
      helperText: "Is this input required to be filled out to submit a form",
      defaultValue: false
    }
  ],
  noWrap: true,
  static: true,
  defaultStyles: {
    paddingTop: "10px",
    paddingBottom: "10px",
    paddingLeft: "10px",
    paddingRight: "10px",
    borderRadius: "3px",
    borderWidth: "1px",
    borderStyle: "solid",
    borderColor: "#ccc"
  }
};
const FormInputComponent = /* @__PURE__ */ qwik.componentQrl(/* @__PURE__ */ qwik.inlinedQrl((props) => {
  return /* @__PURE__ */ qwik.createElement("input", {
    ...props.attributes,
    key: isEditing() && props.defaultValue ? props.defaultValue : "default-key",
    placeholder: props.placeholder,
    type: props.type,
    name: props.name,
    value: props.value,
    defaultValue: props.defaultValue,
    required: props.required
  });
}, "FormInputComponent_component_AUUjdN0ueMs"));
const componentInfo$3 = {
  name: "Form:Select",
  image: "https://cdn.builder.io/api/v1/image/assets%2FIsxPKMo2gPRRKeakUztj1D6uqed2%2F83acca093fb24aaf94dee136e9a4b045",
  defaultStyles: {
    alignSelf: "flex-start"
  },
  inputs: [
    {
      name: "options",
      type: "list",
      required: true,
      subFields: [
        {
          name: "value",
          type: "text",
          required: true
        },
        {
          name: "name",
          type: "text"
        }
      ],
      defaultValue: [
        {
          value: "option 1"
        },
        {
          value: "option 2"
        }
      ]
    },
    {
      name: "name",
      type: "string",
      required: true,
      helperText: 'Every select in a form needs a unique name describing what it gets, e.g. "email"'
    },
    {
      name: "defaultValue",
      type: "string"
    },
    {
      name: "value",
      type: "string",
      advanced: true
    },
    {
      name: "required",
      type: "boolean",
      defaultValue: false
    }
  ],
  static: true,
  noWrap: true
};
const SelectComponent = /* @__PURE__ */ qwik.componentQrl(/* @__PURE__ */ qwik.inlinedQrl((props) => {
  return /* @__PURE__ */ qwik.createElement("select", {
    ...props.attributes,
    value: props.value,
    key: isEditing() && props.defaultValue ? props.defaultValue : "default-key",
    defaultValue: props.defaultValue,
    name: props.name
  }, (props.options || []).map((option, index) => {
    return /* @__PURE__ */ qwik._jsxQ("option", {
      value: qwik._wrapSignal(option, "value")
    }, null, option.name || option.value, 1, `${option.name}-${index}`);
  }));
}, "SelectComponent_component_SPKbsFLikZU"));
const componentInfo$2 = {
  name: "Form:SubmitButton",
  image: "https://cdn.builder.io/api/v1/image/assets%2FIsxPKMo2gPRRKeakUztj1D6uqed2%2Fdf2820ffed1f4349a94c40b3221f5b98",
  defaultStyles: {
    appearance: "none",
    paddingTop: "15px",
    paddingBottom: "15px",
    paddingLeft: "25px",
    paddingRight: "25px",
    backgroundColor: "#3898EC",
    color: "white",
    borderRadius: "4px",
    cursor: "pointer"
  },
  inputs: [
    {
      name: "text",
      type: "text",
      defaultValue: "Click me"
    }
  ],
  static: true,
  noWrap: true
};
const SubmitButton = /* @__PURE__ */ qwik.componentQrl(/* @__PURE__ */ qwik.inlinedQrl((props) => {
  return /* @__PURE__ */ qwik._jsxS("button", {
    ...props.attributes,
    children: qwik._fnSignal((p0) => p0.text, [
      props
    ], "p0.text")
  }, {
    type: "submit"
  }, 0, "6z_0");
}, "SubmitButton_component_NXvMBMCDhwc"));
const componentInfo$1 = {
  // friendlyName?
  name: "Raw:Img",
  hideFromInsertMenu: true,
  image: "https://firebasestorage.googleapis.com/v0/b/builder-3b0a2.appspot.com/o/images%2Fbaseline-insert_photo-24px.svg?alt=media&token=4e5d0ef4-f5e8-4e57-b3a9-38d63a9b9dc4",
  inputs: [
    {
      name: "image",
      bubble: true,
      type: "file",
      allowedFileTypes: [
        "jpeg",
        "jpg",
        "png",
        "svg",
        "gif",
        "webp"
      ],
      required: true
    }
  ],
  noWrap: true,
  static: true
};
const ImgComponent = /* @__PURE__ */ qwik.componentQrl(/* @__PURE__ */ qwik.inlinedQrl((props) => {
  return /* @__PURE__ */ qwik._jsxS("img", {
    ...props.attributes
  }, {
    alt: qwik._fnSignal((p0) => p0.altText, [
      props
    ], "p0.altText"),
    src: qwik._fnSignal((p0) => p0.imgSrc || p0.image, [
      props
    ], "p0.imgSrc||p0.image"),
    style: qwik._fnSignal((p0) => ({
      objectFit: p0.backgroundSize || "cover",
      objectPosition: p0.backgroundPosition || "center"
    }), [
      props
    ], '{objectFit:p0.backgroundSize||"cover",objectPosition:p0.backgroundPosition||"center"}')
  }, 0, isEditing() && props.imgSrc || "default-key");
}, "ImgComponent_component_FXvIDBSffO8"));
const componentInfo = {
  name: "Video",
  canHaveChildren: true,
  defaultStyles: {
    minHeight: "20px",
    minWidth: "20px"
  },
  image: "https://firebasestorage.googleapis.com/v0/b/builder-3b0a2.appspot.com/o/images%2Fbaseline-videocam-24px%20(1).svg?alt=media&token=49a84e4a-b20e-4977-a650-047f986874bb",
  inputs: [
    {
      name: "video",
      type: "file",
      allowedFileTypes: [
        "mp4"
      ],
      bubble: true,
      defaultValue: "https://cdn.builder.io/o/assets%2FYJIGb4i01jvw0SRdL5Bt%2Fd27731a526464deba0016216f5f9e570%2Fcompressed?apiKey=YJIGb4i01jvw0SRdL5Bt&token=d27731a526464deba0016216f5f9e570&alt=media&optimized=true",
      required: true
    },
    {
      name: "posterImage",
      type: "file",
      allowedFileTypes: [
        "jpeg",
        "png"
      ],
      helperText: "Image to show before the video plays"
    },
    {
      name: "autoPlay",
      type: "boolean",
      defaultValue: true
    },
    {
      name: "controls",
      type: "boolean",
      defaultValue: false
    },
    {
      name: "muted",
      type: "boolean",
      defaultValue: true
    },
    {
      name: "loop",
      type: "boolean",
      defaultValue: true
    },
    {
      name: "playsInline",
      type: "boolean",
      defaultValue: true
    },
    {
      name: "fit",
      type: "text",
      defaultValue: "cover",
      enum: [
        "contain",
        "cover",
        "fill",
        "auto"
      ]
    },
    {
      name: "preload",
      type: "text",
      defaultValue: "metadata",
      enum: [
        "auto",
        "metadata",
        "none"
      ]
    },
    {
      name: "fitContent",
      type: "boolean",
      helperText: "When child blocks are provided, fit to them instead of using the aspect ratio",
      defaultValue: true,
      advanced: true
    },
    {
      name: "position",
      type: "text",
      defaultValue: "center",
      enum: [
        "center",
        "top",
        "left",
        "right",
        "bottom",
        "top left",
        "top right",
        "bottom left",
        "bottom right"
      ]
    },
    {
      name: "height",
      type: "number",
      advanced: true
    },
    {
      name: "width",
      type: "number",
      advanced: true
    },
    {
      name: "aspectRatio",
      type: "number",
      advanced: true,
      defaultValue: 0.7004048582995948
    },
    {
      name: "lazyLoad",
      type: "boolean",
      helperText: 'Load this video "lazily" - as in only when a user scrolls near the video. Recommended for optmized performance and bandwidth consumption',
      defaultValue: true,
      advanced: true
    }
  ]
};
const Video = /* @__PURE__ */ qwik.componentQrl(/* @__PURE__ */ qwik.inlinedQrl((props) => {
  var _a, _b, _c, _d, _e, _f, _g;
  qwik._jsxBranch();
  const videoProps = qwik.useComputedQrl(/* @__PURE__ */ qwik.inlinedQrl(() => {
    const [props2] = qwik.useLexicalScope();
    return {
      ...props2.autoPlay === true ? {
        autoPlay: true
      } : {},
      ...props2.muted === true ? {
        muted: true
      } : {},
      ...props2.controls === true ? {
        controls: true
      } : {},
      ...props2.loop === true ? {
        loop: true
      } : {},
      ...props2.playsInline === true ? {
        playsInline: true
      } : {}
    };
  }, "Video_component_videoProps_useComputed_60AadUGY06E", [
    props
  ]));
  const spreadProps = qwik.useComputedQrl(/* @__PURE__ */ qwik.inlinedQrl(() => {
    const [videoProps2] = qwik.useLexicalScope();
    return {
      ...videoProps2.value
    };
  }, "Video_component_spreadProps_useComputed_ZdLsx18NYH4", [
    videoProps
  ]));
  return /* @__PURE__ */ qwik._jsxQ("div", null, {
    style: {
      position: "relative"
    }
  }, [
    /* @__PURE__ */ qwik._jsxS("video", {
      ...spreadProps.value,
      children: !props.lazyLoad ? /* @__PURE__ */ qwik._jsxQ("source", null, {
        src: qwik._fnSignal((p0) => p0.video, [
          props
        ], "p0.video"),
        type: "video/mp4"
      }, null, 3, "j7_0") : null,
      style: {
        width: "100%",
        height: "100%",
        ...(_a = props.attributes) == null ? void 0 : _a.style,
        objectFit: props.fit,
        objectPosition: props.position,
        // Hack to get object fit to work as expected and
        // not have the video overflow
        zIndex: 2,
        borderRadius: "1px",
        ...props.aspectRatio ? {
          position: "absolute"
        } : null
      }
    }, {
      class: "builder-video",
      poster: qwik._fnSignal((p0) => p0.posterImage, [
        props
      ], "p0.posterImage"),
      preload: qwik._fnSignal((p0) => p0.preload || "metadata", [
        props
      ], 'p0.preload||"metadata"'),
      src: qwik._fnSignal((p0) => p0.video || "no-src", [
        props
      ], 'p0.video||"no-src"')
    }, 0, null),
    props.aspectRatio && !(props.fitContent && ((_c = (_b = props.builderBlock) == null ? void 0 : _b.children) == null ? void 0 : _c.length)) ? /* @__PURE__ */ qwik._jsxQ("div", null, {
      style: qwik._fnSignal((p0) => ({
        width: "100%",
        paddingTop: p0.aspectRatio * 100 + "%",
        pointerEvents: "none",
        fontSize: "0px"
      }), [
        props
      ], '{width:"100%",paddingTop:p0.aspectRatio*100+"%",pointerEvents:"none",fontSize:"0px"}')
    }, null, 3, "j7_1") : null,
    ((_e = (_d = props.builderBlock) == null ? void 0 : _d.children) == null ? void 0 : _e.length) && props.fitContent ? /* @__PURE__ */ qwik._jsxQ("div", null, {
      style: {
        display: "flex",
        flexDirection: "column",
        alignItems: "stretch"
      }
    }, /* @__PURE__ */ qwik._jsxC(qwik.Slot, null, 3, "j7_2"), 1, "j7_3") : null,
    ((_g = (_f = props.builderBlock) == null ? void 0 : _f.children) == null ? void 0 : _g.length) && !props.fitContent ? /* @__PURE__ */ qwik._jsxQ("div", null, {
      style: {
        pointerEvents: "none",
        display: "flex",
        flexDirection: "column",
        alignItems: "stretch",
        position: "absolute",
        top: "0",
        left: "0",
        width: "100%",
        height: "100%"
      }
    }, /* @__PURE__ */ qwik._jsxC(qwik.Slot, null, 3, "j7_4"), 1, "j7_5") : null
  ], 1, "j7_6");
}, "Video_component_qdcTZflYyoQ"));
const getExtraComponents = () => [
  {
    component: CustomCode,
    ...componentInfo$7
  },
  {
    component: Embed,
    ...componentInfo$6
  },
  ...[
    {
      component: FormComponent,
      ...componentInfo$5
    },
    {
      component: FormInputComponent,
      ...componentInfo$4
    },
    {
      component: SubmitButton,
      ...componentInfo$2
    },
    {
      component: SelectComponent,
      ...componentInfo$3
    }
  ],
  {
    component: ImgComponent,
    ...componentInfo$1
  },
  {
    component: Video,
    ...componentInfo
  }
];
const getDefaultRegisteredComponents = () => [
  {
    component: Button,
    ...componentInfo$g
  },
  {
    component: Columns,
    ...componentInfo$f
  },
  {
    component: FragmentComponent,
    ...componentInfo$e
  },
  {
    component: Image,
    ...componentInfo$d
  },
  {
    component: SectionComponent,
    ...componentInfo$c
  },
  {
    component: Slot,
    ...componentInfo$b
  },
  {
    component: Symbol$1,
    ...componentInfo$a
  },
  {
    component: Text,
    ...componentInfo$8
  },
  ...[
    {
      component: Tabs,
      ...componentInfo$9
    },
    {
      component: Accordion,
      ...componentInfo$h
    }
  ],
  ...getExtraComponents()
];
const createRegisterComponentMessage = (info) => ({
  type: "builder.registerComponent",
  data: serializeComponentInfo(info)
});
const serializeFn = (fnValue) => {
  const fnStr = fnValue.toString().trim();
  const appendFunction = !fnStr.startsWith("function") && !fnStr.startsWith("(");
  return `return (${appendFunction ? "function " : ""}${fnStr}).apply(this, arguments)`;
};
const serializeValue = (value) => typeof value === "function" ? serializeFn(value) : fastClone(value);
const serializeComponentInfo = ({ inputs, ...info }) => ({
  ...fastClone(info),
  inputs: inputs == null ? void 0 : inputs.map((input) => Object.entries(input).reduce((acc, [key, value]) => ({
    ...acc,
    [key]: serializeValue(value)
  }), {}))
});
const UPDATE_COOKIES_AND_STYLES_SCRIPT = "function updateCookiesAndStyles(contentId, variants, isHydrationTarget) {\n  function getAndSetVariantId() {\n    function setCookie(name, value, days) {\n      let expires = '';\n      if (days) {\n        const date = new Date();\n        date.setTime(date.getTime() + days * 24 * 60 * 60 * 1000);\n        expires = '; expires=' + date.toUTCString();\n      }\n      document.cookie = name + '=' + (value || '') + expires + '; path=/' + '; Secure; SameSite=None';\n    }\n    function getCookie(name) {\n      const nameEQ = name + '=';\n      const ca = document.cookie.split(';');\n      for (let i = 0; i < ca.length; i++) {\n        let c = ca[i];\n        while (c.charAt(0) === ' ') c = c.substring(1, c.length);\n        if (c.indexOf(nameEQ) === 0) return c.substring(nameEQ.length, c.length);\n      }\n      return null;\n    }\n    const cookieName = `builder.tests.${contentId}`;\n    const variantInCookie = getCookie(cookieName);\n    const availableIDs = variants.map(vr => vr.id).concat(contentId);\n    if (variantInCookie && availableIDs.includes(variantInCookie)) {\n      return variantInCookie;\n    }\n    let n = 0;\n    const random = Math.random();\n    for (let i = 0; i < variants.length; i++) {\n      const variant = variants[i];\n      const testRatio = variant.testRatio;\n      n += testRatio;\n      if (random < n) {\n        setCookie(cookieName, variant.id);\n        return variant.id;\n      }\n    }\n    setCookie(cookieName, contentId);\n    return contentId;\n  }\n  const winningVariantId = getAndSetVariantId();\n  const styleEl = document.currentScript?.previousElementSibling;\n  if (isHydrationTarget) {\n    styleEl.remove();\n    const thisScriptEl = document.currentScript;\n    thisScriptEl?.remove();\n  } else {\n    const newStyleStr = variants.concat({\n      id: contentId\n    }).filter(variant => variant.id !== winningVariantId).map(value => {\n      return `.variant-${value.id} {  display: none; }\n        `;\n    }).join('');\n    styleEl.innerHTML = newStyleStr;\n  }\n}";
const UPDATE_VARIANT_VISIBILITY_SCRIPT = "function updateVariantVisibility(variantContentId, defaultContentId, isHydrationTarget) {\n  if (!navigator.cookieEnabled) {\n    return;\n  }\n  function getCookie(name) {\n    const nameEQ = name + '=';\n    const ca = document.cookie.split(';');\n    for (let i = 0; i < ca.length; i++) {\n      let c = ca[i];\n      while (c.charAt(0) === ' ') c = c.substring(1, c.length);\n      if (c.indexOf(nameEQ) === 0) return c.substring(nameEQ.length, c.length);\n    }\n    return null;\n  }\n  const cookieName = `builder.tests.${defaultContentId}`;\n  const winningVariant = getCookie(cookieName);\n  const parentDiv = document.currentScript?.parentElement;\n  const isDefaultContent = variantContentId === defaultContentId;\n  const isWinningVariant = winningVariant === variantContentId;\n  if (isWinningVariant && !isDefaultContent) {\n    parentDiv?.removeAttribute('hidden');\n    parentDiv?.removeAttribute('aria-hidden');\n  } else if (!isWinningVariant && isDefaultContent) {\n    parentDiv?.setAttribute('hidden', 'true');\n    parentDiv?.setAttribute('aria-hidden', 'true');\n  }\n  if (isHydrationTarget) {\n    if (!isWinningVariant) {\n      parentDiv?.remove();\n    }\n    const thisScriptEl = document.currentScript;\n    thisScriptEl?.remove();\n  }\n  return;\n}";
const UPDATE_COOKIES_AND_STYLES_SCRIPT_NAME = "builderIoAbTest";
const UPDATE_VARIANT_VISIBILITY_SCRIPT_FN_NAME = "builderIoRenderContent";
const getVariants = (content) => Object.values((content == null ? void 0 : content.variations) || {}).map((variant) => ({
  ...variant,
  testVariationId: variant.id,
  id: content == null ? void 0 : content.id
}));
const checkShouldRenderVariants = ({ canTrack, content }) => {
  const hasVariants = getVariants(content).length > 0;
  if (!hasVariants)
    return false;
  if (!canTrack)
    return false;
  if (isBrowser())
    return false;
  return true;
};
const getIsHydrationTarget = (target) => target === "react" || target === "reactNative";
const isHydrationTarget = getIsHydrationTarget(TARGET);
const getInitVariantsFnsScriptString = () => `
  window.${UPDATE_COOKIES_AND_STYLES_SCRIPT_NAME} = ${UPDATE_COOKIES_AND_STYLES_SCRIPT}
  window.${UPDATE_VARIANT_VISIBILITY_SCRIPT_FN_NAME} = ${UPDATE_VARIANT_VISIBILITY_SCRIPT}
  `;
const getUpdateCookieAndStylesScript = (variants, contentId) => `
  window.${UPDATE_COOKIES_AND_STYLES_SCRIPT_NAME}(
    "${contentId}",${JSON.stringify(variants)}, ${isHydrationTarget}
  )`;
const getUpdateVariantVisibilityScript = ({ contentId, variationId }) => `window.${UPDATE_VARIANT_VISIBILITY_SCRIPT_FN_NAME}(
    "${variationId}", "${contentId}", ${isHydrationTarget}
  )`;
const InlinedScript = /* @__PURE__ */ qwik.componentQrl(/* @__PURE__ */ qwik.inlinedQrl((props) => {
  return /* @__PURE__ */ qwik._jsxQ("script", null, {
    dangerouslySetInnerHTML: qwik._fnSignal((p0) => p0.scriptStr, [
      props
    ], "p0.scriptStr"),
    "data-id": qwik._fnSignal((p0) => p0.id, [
      props
    ], "p0.id")
  }, null, 3, "WO_0");
}, "InlinedScript_component_hwThBdhA8rw"));
function getGlobalThis() {
  if (typeof globalThis !== "undefined")
    return globalThis;
  if (typeof window !== "undefined")
    return window;
  if (typeof global !== "undefined")
    return global;
  if (typeof self !== "undefined")
    return self;
  return globalThis;
}
function getFetch() {
  const globalFetch = getGlobalThis().fetch;
  if (typeof globalFetch === "undefined") {
    console.warn(`Builder SDK could not find a global fetch function. Make sure you have a polyfill for fetch in your project. 
      For more information, read https://github.com/BuilderIO/this-package-uses-fetch`);
    throw new Error("Builder SDK could not find a global `fetch` function");
  }
  return globalFetch;
}
const fetch$1 = getFetch();
function flatten(object, path = null, separator = ".") {
  return Object.keys(object).reduce((acc, key) => {
    const value = object[key];
    const newPath = [
      path,
      key
    ].filter(Boolean).join(separator);
    const isObject = [
      typeof value === "object",
      value !== null,
      !(Array.isArray(value) && value.length === 0)
    ].every(Boolean);
    return isObject ? {
      ...acc,
      ...flatten(value, newPath, separator)
    } : {
      ...acc,
      [newPath]: value
    };
  }, {});
}
function flattenMongoQuery(obj, _current, _res = {}) {
  for (const key in obj) {
    const value = obj[key];
    const newKey = _current ? _current + "." + key : key;
    if (value && typeof value === "object" && !Array.isArray(value) && !Object.keys(value).find((item) => item.startsWith("$")))
      flattenMongoQuery(value, newKey, _res);
    else
      _res[newKey] = value;
  }
  return _res;
}
const DEFAULT_API_VERSION = "v3";
const BUILDER_SEARCHPARAMS_PREFIX = "builder.";
const BUILDER_OPTIONS_PREFIX = "options.";
const getBuilderSearchParams = (_options) => {
  if (!_options)
    return {};
  const options = normalizeSearchParams(_options);
  const newOptions = {};
  Object.keys(options).forEach((key) => {
    if (key.startsWith(BUILDER_SEARCHPARAMS_PREFIX)) {
      const trimmedKey = key.replace(BUILDER_SEARCHPARAMS_PREFIX, "").replace(BUILDER_OPTIONS_PREFIX, "");
      newOptions[trimmedKey] = options[key];
    }
  });
  return newOptions;
};
const getBuilderSearchParamsFromWindow = () => {
  if (!isBrowser())
    return {};
  const searchParams = new URLSearchParams(window.location.search);
  return getBuilderSearchParams(searchParams);
};
const isPositiveNumber = (thing) => typeof thing === "number" && !isNaN(thing) && thing >= 0;
const generateContentUrl = (options) => {
  const { limit = 30, userAttributes, query, model, apiKey, enrich, locale, apiVersion = DEFAULT_API_VERSION, fields, omit, offset, cacheSeconds, staleCacheSeconds, sort, includeUnpublished } = options;
  if (!apiKey)
    throw new Error("Missing API key");
  if (![
    "v3"
  ].includes(apiVersion))
    throw new Error(`Invalid apiVersion: expected 'v3', received '${apiVersion}'`);
  const noTraverse = limit !== 1;
  const url = new URL(`https://cdn.builder.io/api/${apiVersion}/content/${model}`);
  url.searchParams.set("apiKey", apiKey);
  url.searchParams.set("limit", String(limit));
  url.searchParams.set("noTraverse", String(noTraverse));
  url.searchParams.set("includeRefs", String(true));
  if (locale)
    url.searchParams.set("locale", locale);
  if (enrich)
    url.searchParams.set("enrich", String(enrich));
  url.searchParams.set("omit", omit || "meta.componentsUsed");
  if (fields)
    url.searchParams.set("fields", fields);
  if (Number.isFinite(offset) && offset > -1)
    url.searchParams.set("offset", String(Math.floor(offset)));
  if (typeof includeUnpublished === "boolean")
    url.searchParams.set("includeUnpublished", String(includeUnpublished));
  if (cacheSeconds && isPositiveNumber(cacheSeconds))
    url.searchParams.set("cacheSeconds", String(cacheSeconds));
  if (staleCacheSeconds && isPositiveNumber(staleCacheSeconds))
    url.searchParams.set("staleCacheSeconds", String(staleCacheSeconds));
  if (sort) {
    const flattened2 = flatten({
      sort
    });
    for (const key in flattened2)
      url.searchParams.set(key, JSON.stringify(flattened2[key]));
  }
  const queryOptions = {
    ...getBuilderSearchParamsFromWindow(),
    ...normalizeSearchParams(options.options || {})
  };
  const flattened = flatten(queryOptions);
  for (const key in flattened)
    url.searchParams.set(key, String(flattened[key]));
  if (userAttributes)
    url.searchParams.set("userAttributes", JSON.stringify(userAttributes));
  if (query) {
    const flattened2 = flattenMongoQuery({
      query
    });
    for (const key in flattened2)
      url.searchParams.set(key, JSON.stringify(flattened2[key]));
  }
  return url;
};
const checkContentHasResults = (content) => "results" in content;
async function fetchOneEntry(options) {
  const allContent = await fetchEntries({
    ...options,
    limit: 1
  });
  if (allContent)
    return allContent[0] || null;
  return null;
}
const _fetchContent = async (options) => {
  const url = generateContentUrl(options);
  const _fetch = options.fetch ?? fetch$1;
  const res = await _fetch(url.href, options.fetchOptions);
  const content = await res.json();
  return content;
};
const _processContentResult = async (options, content, url = generateContentUrl(options)) => {
  const canTrack = getDefaultCanTrack(options.canTrack);
  url.search.includes(`preview=`);
  if (!canTrack)
    return content.results;
  if (!(isBrowser() || TARGET === "reactNative"))
    return content.results;
  try {
    const newResults = [];
    for (const item of content.results)
      newResults.push(await handleABTesting({
        item,
        canTrack
      }));
    content.results = newResults;
  } catch (e) {
    logger.error("Could not process A/B tests. ", e);
  }
  return content.results;
};
async function fetchEntries(options) {
  try {
    const url = generateContentUrl(options);
    const content = await _fetchContent(options);
    if (!checkContentHasResults(content)) {
      logger.error("Error fetching data. ", {
        url,
        content,
        options
      });
      return null;
    }
    return _processContentResult(options, content);
  } catch (error) {
    logger.error("Error fetching data. ", error);
    return null;
  }
}
function isPreviewing(_search) {
  const search = _search || (isBrowser() ? window.location.search : void 0);
  if (!search)
    return false;
  const normalizedSearch = getSearchString(search);
  return Boolean(normalizedSearch.indexOf("builder.preview=") !== -1);
}
function uuidv4() {
  return "xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx".replace(/[xy]/g, function(c) {
    const r = Math.random() * 16 | 0, v = c == "x" ? r : r & 3 | 8;
    return v.toString(16);
  });
}
function uuid() {
  return uuidv4().replace(/-/g, "");
}
const SESSION_LOCAL_STORAGE_KEY = "builderSessionId";
const getSessionId = async ({ canTrack }) => {
  if (!canTrack)
    return void 0;
  const sessionId = await getCookie({
    name: SESSION_LOCAL_STORAGE_KEY,
    canTrack
  });
  if (checkIsDefined(sessionId))
    return sessionId;
  else {
    const newSessionId = createSessionId();
    setSessionId({
      id: newSessionId,
      canTrack
    });
    return newSessionId;
  }
};
const createSessionId = () => uuid();
const setSessionId = ({ id, canTrack }) => setCookie({
  name: SESSION_LOCAL_STORAGE_KEY,
  value: id,
  canTrack
});
const getLocalStorage = () => isBrowser() && typeof localStorage !== "undefined" ? localStorage : void 0;
const getLocalStorageItem = ({ key, canTrack }) => {
  var _a;
  try {
    if (canTrack)
      return (_a = getLocalStorage()) == null ? void 0 : _a.getItem(key);
    return void 0;
  } catch (err) {
    console.debug("[LocalStorage] GET error: ", err);
    return void 0;
  }
};
const setLocalStorageItem = ({ key, canTrack, value }) => {
  var _a;
  try {
    if (canTrack)
      (_a = getLocalStorage()) == null ? void 0 : _a.setItem(key, value);
  } catch (err) {
    console.debug("[LocalStorage] SET error: ", err);
  }
};
const VISITOR_LOCAL_STORAGE_KEY = "builderVisitorId";
const getVisitorId = ({ canTrack }) => {
  if (!canTrack)
    return void 0;
  const visitorId = getLocalStorageItem({
    key: VISITOR_LOCAL_STORAGE_KEY,
    canTrack
  });
  if (checkIsDefined(visitorId))
    return visitorId;
  else {
    const newVisitorId = createVisitorId();
    setVisitorId({
      id: newVisitorId,
      canTrack
    });
    return newVisitorId;
  }
};
const createVisitorId = () => uuid();
const setVisitorId = ({ id, canTrack }) => setLocalStorageItem({
  key: VISITOR_LOCAL_STORAGE_KEY,
  value: id,
  canTrack
});
const getTrackingEventData = async ({ canTrack }) => {
  if (!canTrack)
    return {
      visitorId: void 0,
      sessionId: void 0
    };
  const sessionId = await getSessionId({
    canTrack
  });
  const visitorId = getVisitorId({
    canTrack
  });
  return {
    sessionId,
    visitorId
  };
};
const createEvent = async ({ type: eventType, canTrack, apiKey, metadata, ...properties }) => ({
  type: eventType,
  data: {
    ...properties,
    metadata: {
      url: location.href,
      ...metadata
    },
    ...await getTrackingEventData({
      canTrack
    }),
    userAttributes: getUserAttributes(),
    ownerId: apiKey
  }
});
async function _track(eventProps) {
  if (!eventProps.apiKey) {
    logger.error("Missing API key for track call. Please provide your API key.");
    return;
  }
  if (!eventProps.canTrack)
    return;
  if (isEditing())
    return;
  if (!(isBrowser() || TARGET === "reactNative"))
    return;
  return fetch(`https://cdn.builder.io/api/v1/track`, {
    method: "POST",
    body: JSON.stringify({
      events: [
        await createEvent(eventProps)
      ]
    }),
    headers: {
      "content-type": "application/json"
    },
    mode: "cors"
  }).catch((err) => {
    console.error("Failed to track: ", err);
  });
}
const track = (args) => _track({
  ...args,
  canTrack: true
});
function round(num) {
  return Math.round(num * 1e3) / 1e3;
}
const findParentElement = (target, callback, checkElement = true) => {
  if (!(target instanceof HTMLElement))
    return null;
  let parent2 = checkElement ? target : target.parentElement;
  do {
    if (!parent2)
      return null;
    const matches = callback(parent2);
    if (matches)
      return parent2;
  } while (parent2 = parent2.parentElement);
  return null;
};
const findBuilderParent = (target) => findParentElement(target, (el) => {
  const id = el.getAttribute("builder-id") || el.id;
  return Boolean((id == null ? void 0 : id.indexOf("builder-")) === 0);
});
const computeOffset = ({ event, target }) => {
  const targetRect = target.getBoundingClientRect();
  const xOffset = event.clientX - targetRect.left;
  const yOffset = event.clientY - targetRect.top;
  const xRatio = round(xOffset / targetRect.width);
  const yRatio = round(yOffset / targetRect.height);
  return {
    x: xRatio,
    y: yRatio
  };
};
const getInteractionPropertiesForEvent = (event) => {
  const target = event.target;
  const targetBuilderElement = target && findBuilderParent(target);
  const builderId = (targetBuilderElement == null ? void 0 : targetBuilderElement.getAttribute("builder-id")) || (targetBuilderElement == null ? void 0 : targetBuilderElement.id);
  return {
    targetBuilderElement: builderId || void 0,
    metadata: {
      targetOffset: target ? computeOffset({
        event,
        target
      }) : void 0,
      builderTargetOffset: targetBuilderElement ? computeOffset({
        event,
        target: targetBuilderElement
      }) : void 0,
      builderElementIndex: targetBuilderElement && builderId ? [].slice.call(document.getElementsByClassName(builderId)).indexOf(targetBuilderElement) : void 0
    }
  };
};
const DEFAULT_TRUSTED_HOSTS = [
  "*.beta.builder.io",
  "beta.builder.io",
  "builder.io",
  "localhost",
  "qa.builder.io"
];
function isFromTrustedHost(trustedHosts, e) {
  const url = new URL(e.origin), hostname = url.hostname;
  return (trustedHosts || DEFAULT_TRUSTED_HOSTS).findIndex((trustedHost) => trustedHost.startsWith("*.") ? hostname.endsWith(trustedHost.slice(1)) : trustedHost === hostname) > -1;
}
const SDK_VERSION = "0.14.25";
const registry = {};
function register(type, info) {
  let typeList = registry[type];
  if (!typeList)
    typeList = registry[type] = [];
  typeList.push(info);
  if (isBrowser()) {
    const message = {
      type: "builder.register",
      data: {
        type,
        info
      }
    };
    try {
      parent.postMessage(message, "*");
      if (parent !== window)
        window.postMessage(message, "*");
    } catch (err) {
      console.debug("Could not postmessage", err);
    }
  }
}
const registerInsertMenu = () => {
  register("insertMenu", {
    name: "_default",
    default: true,
    items: [
      {
        name: "Box"
      },
      {
        name: "Text"
      },
      {
        name: "Image"
      },
      {
        name: "Columns"
      },
      ...[
        {
          name: "Core:Section"
        },
        {
          name: "Core:Button"
        },
        {
          name: "Embed"
        },
        {
          name: "Custom Code"
        }
      ]
    ]
  });
};
let isSetupForEditing = false;
const setupBrowserForEditing = (options = {}) => {
  var _a, _b;
  if (isSetupForEditing)
    return;
  isSetupForEditing = true;
  if (isBrowser()) {
    (_a = window.parent) == null ? void 0 : _a.postMessage({
      type: "builder.sdkInfo",
      data: {
        target: TARGET,
        version: SDK_VERSION,
        supportsPatchUpdates: false,
        // Supports builder-model="..." attribute which is needed to
        // scope our '+ add block' button styling
        supportsAddBlockScoping: true,
        supportsCustomBreakpoints: true
      }
    }, "*");
    (_b = window.parent) == null ? void 0 : _b.postMessage({
      type: "builder.updateContent",
      data: {
        options
      }
    }, "*");
    window.addEventListener("message", (event) => {
      var _a2, _b2;
      if (!isFromTrustedHost(options.trustedHosts, event))
        return;
      const { data } = event;
      if (!(data == null ? void 0 : data.type))
        return;
      switch (data.type) {
        case "builder.evaluate": {
          const text = data.data.text;
          const args = data.data.arguments || [];
          const id = data.data.id;
          const fn = new Function(text);
          let result;
          let error = null;
          try {
            result = fn.apply(null, args);
          } catch (err) {
            error = err;
          }
          if (error)
            (_a2 = window.parent) == null ? void 0 : _a2.postMessage({
              type: "builder.evaluateError",
              data: {
                id,
                error: error.message
              }
            }, "*");
          else if (result && typeof result.then === "function")
            result.then((finalResult) => {
              var _a3;
              (_a3 = window.parent) == null ? void 0 : _a3.postMessage({
                type: "builder.evaluateResult",
                data: {
                  id,
                  result: finalResult
                }
              }, "*");
            }).catch(console.error);
          else
            (_b2 = window.parent) == null ? void 0 : _b2.postMessage({
              type: "builder.evaluateResult",
              data: {
                result,
                id
              }
            }, "*");
          break;
        }
      }
    });
  }
};
const createEditorListener = ({ model, trustedHosts, callbacks }) => {
  return (event) => {
    if (!isFromTrustedHost(trustedHosts, event))
      return;
    const { data } = event;
    if (data)
      switch (data.type) {
        case "builder.configureSdk":
          callbacks.configureSdk(data.data);
          break;
        case "builder.triggerAnimation":
          callbacks.animation(data.data);
          break;
        case "builder.contentUpdate": {
          const messageContent = data.data;
          const key = messageContent.key || messageContent.alias || messageContent.entry || messageContent.modelName;
          const contentData = messageContent.data;
          if (key === model)
            callbacks.contentUpdate(contentData);
          break;
        }
      }
  };
};
const subscribeToEditor = (model, callback, options) => {
  if (!isBrowser) {
    logger.warn("`subscribeToEditor` only works in the browser. It currently seems to be running on the server.");
    return () => {
    };
  }
  setupBrowserForEditing();
  const listener = createEditorListener({
    callbacks: {
      contentUpdate: callback,
      animation: () => {
      },
      configureSdk: () => {
      }
    },
    model,
    trustedHosts: options == null ? void 0 : options.trustedHosts
  });
  window.addEventListener("message", listener);
  return () => {
    window.removeEventListener("message", listener);
  };
};
const getCssFromFont = (font) => {
  var _a;
  const family = font.family + (font.kind && !font.kind.includes("#") ? ", " + font.kind : "");
  const name = family.split(",")[0];
  const url = font.fileUrl ?? ((_a = font == null ? void 0 : font.files) == null ? void 0 : _a.regular);
  let str = "";
  if (url && family && name)
    str += `
@font-face {
font-family: "${family}";
src: local("${name}"), url('${url}') format('woff2');
font-display: fallback;
font-weight: 400;
}
      `.trim();
  if (font.files)
    for (const weight in font.files) {
      const isNumber = String(Number(weight)) === weight;
      if (!isNumber)
        continue;
      const weightUrl = font.files[weight];
      if (weightUrl && weightUrl !== url)
        str += `
@font-face {
font-family: "${family}";
src: url('${weightUrl}') format('woff2');
font-display: fallback;
font-weight: ${weight};
}
        `.trim();
    }
  return str;
};
const getFontCss = ({ customFonts }) => {
  var _a;
  return ((_a = customFonts == null ? void 0 : customFonts.map((font) => getCssFromFont(font))) == null ? void 0 : _a.join(" ")) || "";
};
const getCss = ({ cssCode, contentId }) => {
  if (!cssCode)
    return "";
  if (!contentId)
    return cssCode;
  return (cssCode == null ? void 0 : cssCode.replace(/&/g, `div[builder-content-id="${contentId}"]`)) || "";
};
const DEFAULT_STYLES = `
.builder-button {
  all: unset;
}

.builder-text > p:first-of-type, .builder-text > .builder-paragraph:first-of-type {
  margin: 0;
}
.builder-text > p, .builder-text > .builder-paragraph {
  color: inherit;
  line-height: inherit;
  letter-spacing: inherit;
  font-weight: inherit;
  font-size: inherit;
  text-align: inherit;
  font-family: inherit;
}
`;
const getDefaultStyles = (isNested) => {
  return !isNested ? DEFAULT_STYLES : "";
};
const getWrapperClassName = (variationId) => {
  return `variant-${variationId}`;
};
const mergeNewRootState = function mergeNewRootState22(props, state, showContentProps, elementRef, newData) {
  var _a, _b;
  const combinedState = {
    ...props.builderContextSignal.rootState,
    ...newData
  };
  if (props.builderContextSignal.rootSetState)
    (_b = (_a = props.builderContextSignal).rootSetState) == null ? void 0 : _b.call(_a, combinedState);
  else
    props.builderContextSignal.rootState = combinedState;
};
const mergeNewContent = function mergeNewContent2(props, state, showContentProps, elementRef, newContent) {
  var _a, _b, _c, _d, _e;
  const newContentValue = {
    ...props.builderContextSignal.content,
    ...newContent,
    data: {
      ...(_a = props.builderContextSignal.content) == null ? void 0 : _a.data,
      ...newContent == null ? void 0 : newContent.data
    },
    meta: {
      ...(_b = props.builderContextSignal.content) == null ? void 0 : _b.meta,
      ...newContent == null ? void 0 : newContent.meta,
      breakpoints: ((_c = newContent == null ? void 0 : newContent.meta) == null ? void 0 : _c.breakpoints) || ((_e = (_d = props.builderContextSignal.content) == null ? void 0 : _d.meta) == null ? void 0 : _e.breakpoints)
    }
  };
  props.builderContextSignal.content = newContentValue;
};
const processMessage = function processMessage2(props, state, showContentProps, elementRef, event) {
  return createEditorListener({
    model: props.model,
    trustedHosts: props.trustedHosts,
    callbacks: {
      configureSdk: (messageContent) => {
        var _a;
        const { breakpoints, contentId } = messageContent;
        if (!contentId || contentId !== ((_a = props.builderContextSignal.content) == null ? void 0 : _a.id))
          return;
        if (breakpoints)
          mergeNewContent(props, state, showContentProps, elementRef, {
            meta: {
              breakpoints
            }
          });
      },
      animation: (animation) => {
        triggerAnimation(animation);
      },
      contentUpdate: (newContent) => {
        mergeNewContent(props, state, showContentProps, elementRef, newContent);
      }
    }
  })(event);
};
const evaluateJsCode = function evaluateJsCode2(props, state, showContentProps, elementRef) {
  var _a, _b;
  const jsCode = (_b = (_a = props.builderContextSignal.content) == null ? void 0 : _a.data) == null ? void 0 : _b.jsCode;
  if (jsCode)
    evaluate({
      code: jsCode,
      context: props.context || {},
      localState: void 0,
      rootState: props.builderContextSignal.rootState,
      rootSetState: props.builderContextSignal.rootSetState,
      /**
      * We don't want to cache the result of the JS code, since it's arbitrary side effect code.
      */
      enableCache: false
    });
};
const onClick = function onClick24(props, state, showContentProps, elementRef, event) {
  var _a, _b;
  if (props.builderContextSignal.content) {
    const variationId = (_a = props.builderContextSignal.content) == null ? void 0 : _a.testVariationId;
    const contentId = (_b = props.builderContextSignal.content) == null ? void 0 : _b.id;
    _track({
      type: "click",
      canTrack: getDefaultCanTrack(props.canTrack),
      contentId,
      apiKey: props.apiKey,
      variationId: variationId !== contentId ? variationId : void 0,
      ...getInteractionPropertiesForEvent(event),
      unique: !state.clicked
    });
  }
  if (!state.clicked)
    state.clicked = true;
};
const runHttpRequests = function runHttpRequests2(props, state, showContentProps, elementRef) {
  var _a, _b;
  const requests = ((_b = (_a = props.builderContextSignal.content) == null ? void 0 : _a.data) == null ? void 0 : _b.httpRequests) ?? {};
  Object.entries(requests).forEach(([key, url]) => {
    if (!url)
      return;
    if (state.httpReqsPending[key])
      return;
    if (state.httpReqsData[key] && !isEditing())
      return;
    state.httpReqsPending[key] = true;
    const evaluatedUrl = url.replace(/{{([^}]+)}}/g, (_match, group) => String(evaluate({
      code: group,
      context: props.context || {},
      localState: void 0,
      rootState: props.builderContextSignal.rootState,
      rootSetState: props.builderContextSignal.rootSetState,
      enableCache: true
    })));
    fetch$1(evaluatedUrl).then((response) => response.json()).then((json) => {
      mergeNewRootState(props, state, showContentProps, elementRef, {
        [key]: json
      });
      state.httpReqsData[key] = true;
    }).catch((err) => {
      console.error("error fetching dynamic data", url, err);
    }).finally(() => {
      state.httpReqsPending[key] = false;
    });
  });
};
const emitStateUpdate = function emitStateUpdate2(props, state, showContentProps, elementRef) {
  if (isEditing())
    window.dispatchEvent(new CustomEvent("builder:component:stateChange", {
      detail: {
        state: fastClone(props.builderContextSignal.rootState),
        ref: {
          name: props.model
        }
      }
    }));
};
const EnableEditor = /* @__PURE__ */ qwik.componentQrl(/* @__PURE__ */ qwik.inlinedQrl((props) => {
  var _a, _b;
  qwik._jsxBranch();
  const showContentProps = qwik.useComputedQrl(/* @__PURE__ */ qwik.inlinedQrl(() => {
    const [props2] = qwik.useLexicalScope();
    return props2.showContent ? {} : {
      hidden: true,
      "aria-hidden": true
    };
  }, "EnableEditor_component_showContentProps_useComputed_aHr3V0Y8sNs", [
    props
  ]));
  const elementRef = qwik.useSignal();
  const state = qwik.useStore({
    ContentWrapper: props.contentWrapper || "div",
    clicked: false,
    httpReqsData: {},
    httpReqsPending: {}
  }, {
    deep: true
  });
  qwik.useOn("initeditingbldr", /* @__PURE__ */ qwik.inlinedQrl((event, element) => {
    const [elementRef2, props2, showContentProps2, state2] = qwik.useLexicalScope();
    window.addEventListener("message", processMessage.bind(null, props2, state2, showContentProps2, elementRef2));
    registerInsertMenu();
    setupBrowserForEditing({
      ...props2.locale ? {
        locale: props2.locale
      } : {},
      ...props2.enrich ? {
        enrich: props2.enrich
      } : {},
      ...props2.trustedHosts ? {
        trustedHosts: props2.trustedHosts
      } : {}
    });
    Object.values(props2.builderContextSignal.componentInfos).forEach((registeredComponent) => {
      var _a2;
      const message = createRegisterComponentMessage(registeredComponent);
      (_a2 = window.parent) == null ? void 0 : _a2.postMessage(message, "*");
    });
    window.addEventListener("builder:component:stateChangeListenerActivated", emitStateUpdate.bind(null, props2, state2, showContentProps2, elementRef2));
  }, "EnableEditor_component_useOn_Qs8c0yql2i0", [
    elementRef,
    props,
    showContentProps,
    state
  ]));
  qwik.useOn("initpreviewingbldr", /* @__PURE__ */ qwik.inlinedQrl((event, element) => {
    const [elementRef2, props2, showContentProps2, state2] = qwik.useLexicalScope();
    const searchParams = new URL(location.href).searchParams;
    const searchParamPreviewModel = searchParams.get("builder.preview");
    const searchParamPreviewId = searchParams.get(`builder.overrides.${searchParamPreviewModel}`);
    const previewApiKey = searchParams.get("apiKey") || searchParams.get("builder.space");
    if (searchParamPreviewModel === props2.model && previewApiKey === props2.apiKey && (!props2.content || searchParamPreviewId === props2.content.id))
      fetchOneEntry({
        model: props2.model,
        apiKey: props2.apiKey,
        apiVersion: props2.builderContextSignal.apiVersion
      }).then((content) => {
        if (content)
          mergeNewContent(props2, state2, showContentProps2, elementRef2, content);
      });
  }, "EnableEditor_component_useOn_1_F94YipmknvI", [
    elementRef,
    props,
    showContentProps,
    state
  ]));
  qwik.useOn("qvisible", /* @__PURE__ */ qwik.inlinedQrl((event, element) => {
    var _a2, _b2, _c, _d;
    if (isBrowser()) {
      if (isEditing()) {
        if (element)
          element.dispatchEvent(new CustomEvent("initeditingbldr"));
      }
      const shouldTrackImpression = ((_a2 = element.attributes.getNamedItem("shouldTrack")) == null ? void 0 : _a2.value) === "true";
      if (shouldTrackImpression) {
        const variationId = (_b2 = element.attributes.getNamedItem("variationId")) == null ? void 0 : _b2.value;
        const contentId = (_c = element.attributes.getNamedItem("contentId")) == null ? void 0 : _c.value;
        const apiKeyProp = (_d = element.attributes.getNamedItem("apiKey")) == null ? void 0 : _d.value;
        _track({
          type: "impression",
          canTrack: true,
          contentId,
          apiKey: apiKeyProp,
          variationId: variationId !== contentId ? variationId : void 0
        });
      }
      if (isPreviewing() && !isEditing()) {
        if (element)
          element.dispatchEvent(new CustomEvent("initpreviewingbldr"));
      }
    }
  }, "EnableEditor_component_useOn_2_FyR0YPSlJlw"));
  qwik.useContextProvider(builderContext, props.builderContextSignal);
  qwik.useTaskQrl(/* @__PURE__ */ qwik.inlinedQrl(() => {
    const [elementRef2, props2, showContentProps2, state2] = qwik.useLexicalScope();
    if (!props2.apiKey)
      logger.error("No API key provided to `Content` component. This can cause issues. Please provide an API key using the `apiKey` prop.");
    evaluateJsCode(props2);
    runHttpRequests(props2, state2, showContentProps2, elementRef2);
    emitStateUpdate(props2);
  }, "EnableEditor_component_useTask_Nb2VI04qp0M", [
    elementRef,
    props,
    showContentProps,
    state
  ]));
  qwik.useTaskQrl(/* @__PURE__ */ qwik.inlinedQrl(({ track: track2 }) => {
    const [elementRef2, props2, showContentProps2, state2] = qwik.useLexicalScope();
    track2(() => props2.content);
    if (props2.content)
      mergeNewContent(props2, state2, showContentProps2, elementRef2, props2.content);
  }, "EnableEditor_component_useTask_1_m0y1Z9vk4eQ", [
    elementRef,
    props,
    showContentProps,
    state
  ]));
  qwik.useTaskQrl(/* @__PURE__ */ qwik.inlinedQrl(({ track: track2 }) => {
    const [elementRef2, props2, showContentProps2, state2] = qwik.useLexicalScope();
    track2(() => {
      var _a2, _b2;
      return (_b2 = (_a2 = props2.builderContextSignal.content) == null ? void 0 : _a2.data) == null ? void 0 : _b2.jsCode;
    });
    evaluateJsCode(props2);
  }, "EnableEditor_component_useTask_2_xVyv0tDqZLs", [
    elementRef,
    props,
    showContentProps,
    state
  ]));
  qwik.useTaskQrl(/* @__PURE__ */ qwik.inlinedQrl(({ track: track2 }) => {
    const [elementRef2, props2, showContentProps2, state2] = qwik.useLexicalScope();
    track2(() => {
      var _a2, _b2;
      return (_b2 = (_a2 = props2.builderContextSignal.content) == null ? void 0 : _a2.data) == null ? void 0 : _b2.httpRequests;
    });
    runHttpRequests(props2, state2, showContentProps2, elementRef2);
  }, "EnableEditor_component_useTask_3_bQ0e5LHZwWE", [
    elementRef,
    props,
    showContentProps,
    state
  ]));
  qwik.useTaskQrl(/* @__PURE__ */ qwik.inlinedQrl(({ track: track2 }) => {
    const [elementRef2, props2, showContentProps2, state2] = qwik.useLexicalScope();
    track2(() => props2.builderContextSignal.rootState);
    emitStateUpdate(props2);
  }, "EnableEditor_component_useTask_4_moHYZG8uNVU", [
    elementRef,
    props,
    showContentProps,
    state
  ]));
  qwik.useTaskQrl(/* @__PURE__ */ qwik.inlinedQrl(({ track: track2 }) => {
    const [elementRef2, props2, showContentProps2, state2] = qwik.useLexicalScope();
    track2(() => props2.data);
    if (props2.data)
      mergeNewRootState(props2, state2, showContentProps2, elementRef2, props2.data);
  }, "EnableEditor_component_useTask_5_24QxS0r0KF8", [
    elementRef,
    props,
    showContentProps,
    state
  ]));
  qwik.useTaskQrl(/* @__PURE__ */ qwik.inlinedQrl(({ track: track2 }) => {
    const [elementRef2, props2, showContentProps2, state2] = qwik.useLexicalScope();
    track2(() => props2.locale);
    if (props2.locale)
      mergeNewRootState(props2, state2, showContentProps2, elementRef2, {
        locale: props2.locale
      });
  }, "EnableEditor_component_useTask_6_0CaFTUOgv08", [
    elementRef,
    props,
    showContentProps,
    state
  ]));
  return /* @__PURE__ */ qwik._jsxC(jsxRuntime.Fragment, {
    children: props.builderContextSignal.content ? /* @__PURE__ */ qwik._jsxC(state.ContentWrapper, {
      get apiKey() {
        return props.apiKey;
      },
      get contentId() {
        var _a2;
        return (_a2 = props.builderContextSignal.content) == null ? void 0 : _a2.id;
      },
      get variationId() {
        var _a2;
        return (_a2 = props.builderContextSignal.content) == null ? void 0 : _a2.testVariationId;
      },
      onClick$: /* @__PURE__ */ qwik.inlinedQrl((event) => {
        const [elementRef2, props2, showContentProps2, state2] = qwik.useLexicalScope();
        return onClick(props2, state2, showContentProps2, elementRef2, event);
      }, "EnableEditor_component__Fragment_onClick_b4nYT3DrjEk", [
        elementRef,
        props,
        showContentProps,
        state
      ]),
      ref: elementRef,
      shouldTrack: String(props.builderContextSignal.content && getDefaultCanTrack(props.canTrack)),
      get "builder-content-id"() {
        var _a2;
        return (_a2 = props.builderContextSignal.content) == null ? void 0 : _a2.id;
      },
      get "builder-model"() {
        return props.model;
      },
      ...showContentProps.value,
      ...props.contentWrapperProps,
      children: /* @__PURE__ */ qwik._jsxC(qwik.Slot, null, 3, "06_0"),
      class: getWrapperClassName(((_a = props.content) == null ? void 0 : _a.testVariationId) || ((_b = props.content) == null ? void 0 : _b.id)),
      [qwik._IMMUTABLE]: {
        apiKey: qwik._fnSignal((p0) => p0.apiKey, [
          props
        ], "p0.apiKey"),
        "builder-content-id": qwik._fnSignal((p0) => {
          var _a2;
          return (_a2 = p0.builderContextSignal.content) == null ? void 0 : _a2.id;
        }, [
          props
        ], "p0.builderContextSignal.content?.id"),
        "builder-model": qwik._fnSignal((p0) => p0.model, [
          props
        ], "p0.model"),
        contentId: qwik._fnSignal((p0) => {
          var _a2;
          return (_a2 = p0.builderContextSignal.content) == null ? void 0 : _a2.id;
        }, [
          props
        ], "p0.builderContextSignal.content?.id"),
        ref: qwik._IMMUTABLE,
        variationId: qwik._fnSignal((p0) => {
          var _a2;
          return (_a2 = p0.builderContextSignal.content) == null ? void 0 : _a2.testVariationId;
        }, [
          props
        ], "p0.builderContextSignal.content?.testVariationId")
      }
    }, 0, "06_1") : null
  }, 1, "06_2");
}, "EnableEditor_component_ko1mO8oaj8k"));
const ContentStyles = /* @__PURE__ */ qwik.componentQrl(/* @__PURE__ */ qwik.inlinedQrl((props) => {
  const state = qwik.useStore({
    injectedStyles: `
${getCss({
      cssCode: props.cssCode,
      contentId: props.contentId
    })}
${getFontCss({
      customFonts: props.customFonts
    })}
${getDefaultStyles(props.isNestedRender)}
`.trim()
  });
  return /* @__PURE__ */ qwik._jsxC(InlinedStyles, {
    id: "builderio-content",
    get styles() {
      return state.injectedStyles;
    },
    [qwik._IMMUTABLE]: {
      id: qwik._IMMUTABLE,
      styles: qwik._fnSignal((p0) => p0.injectedStyles, [
        state
      ], "p0.injectedStyles")
    }
  }, 3, "8O_0");
}, "ContentStyles_component_Qbhu1myPWm0"));
const getRootStateInitialValue = ({ content, data, locale }) => {
  var _a, _b, _c;
  const defaultValues = {};
  const initialState = ((_a = content == null ? void 0 : content.data) == null ? void 0 : _a.state) || {};
  (_c = (_b = content == null ? void 0 : content.data) == null ? void 0 : _b.inputs) == null ? void 0 : _c.forEach((input) => {
    if (input.name && input.defaultValue !== void 0)
      defaultValues[input.name] = input.defaultValue;
  });
  return {
    ...defaultValues,
    ...initialState,
    ...data,
    ...locale ? {
      locale
    } : {}
  };
};
const getContentInitialValue = ({ content, data }) => {
  return !content ? void 0 : {
    ...content,
    data: {
      ...content == null ? void 0 : content.data,
      ...data
    },
    meta: content == null ? void 0 : content.meta
  };
};
const ContentComponent = /* @__PURE__ */ qwik.componentQrl(/* @__PURE__ */ qwik.inlinedQrl((props) => {
  var _a, _b;
  qwik._jsxBranch();
  const state = qwik.useStore({
    builderContextSignal: {
      content: getContentInitialValue({
        content: JSON.parse(JSON.stringify(props.content || {})),
        data: props.data
      }),
      localState: void 0,
      rootState: getRootStateInitialValue({
        content: props.content,
        data: props.data,
        locale: props.locale
      }),
      rootSetState: void 0,
      context: props.context || {},
      apiKey: props.apiKey,
      apiVersion: props.apiVersion,
      componentInfos: [
        ...getDefaultRegisteredComponents(),
        ...props.customComponents || []
      ].reduce((acc, { component: _, ...info }) => ({
        ...acc,
        [info.name]: serializeComponentInfo(info)
      }), {}),
      inheritedStyles: {},
      BlocksWrapper: props.blocksWrapper || "div",
      BlocksWrapperProps: props.blocksWrapperProps || {}
    },
    registeredComponents: [
      ...getDefaultRegisteredComponents(),
      ...props.customComponents || []
    ].reduce((acc, { component, ...info }) => ({
      ...acc,
      [info.name]: {
        component,
        ...serializeComponentInfo(info)
      }
    }), {}),
    scriptStr: getUpdateVariantVisibilityScript({
      // eslint-disable-next-line @typescript-eslint/no-non-null-assertion, @typescript-eslint/no-non-null-asserted-optional-chain
      variationId: (_a = props.content) == null ? void 0 : _a.testVariationId,
      // eslint-disable-next-line @typescript-eslint/no-non-null-assertion, @typescript-eslint/no-non-null-asserted-optional-chain
      contentId: (_b = props.content) == null ? void 0 : _b.id
    })
  }, {
    deep: true
  });
  qwik.useContextProvider(ComponentsContext, qwik.useStore({
    registeredComponents: state.registeredComponents
  }));
  return /* @__PURE__ */ qwik._jsxC(EnableEditor, {
    get content() {
      return props.content;
    },
    get data() {
      return props.data;
    },
    get model() {
      return props.model;
    },
    get context() {
      return props.context;
    },
    get apiKey() {
      return props.apiKey;
    },
    get canTrack() {
      return props.canTrack;
    },
    get locale() {
      return props.locale;
    },
    get enrich() {
      return props.enrich;
    },
    get showContent() {
      return props.showContent;
    },
    get builderContextSignal() {
      return state.builderContextSignal;
    },
    get contentWrapper() {
      return props.contentWrapper;
    },
    get contentWrapperProps() {
      return props.contentWrapperProps;
    },
    get linkComponent() {
      return props.linkComponent;
    },
    get trustedHosts() {
      return props.trustedHosts;
    },
    children: [
      props.isSsrAbTest ? /* @__PURE__ */ qwik._jsxC(InlinedScript, {
        id: "builderio-variant-visibility",
        get scriptStr() {
          return state.scriptStr;
        },
        [qwik._IMMUTABLE]: {
          id: qwik._IMMUTABLE,
          scriptStr: qwik._fnSignal((p0) => p0.scriptStr, [
            state
          ], "p0.scriptStr")
        }
      }, 3, "LQ_0") : null,
      /* @__PURE__ */ qwik._jsxC(ContentStyles, {
        get isNestedRender() {
          return props.isNestedRender;
        },
        get contentId() {
          var _a2;
          return (_a2 = state.builderContextSignal.content) == null ? void 0 : _a2.id;
        },
        get cssCode() {
          var _a2, _b2;
          return (_b2 = (_a2 = state.builderContextSignal.content) == null ? void 0 : _a2.data) == null ? void 0 : _b2.cssCode;
        },
        get customFonts() {
          var _a2, _b2;
          return (_b2 = (_a2 = state.builderContextSignal.content) == null ? void 0 : _a2.data) == null ? void 0 : _b2.customFonts;
        },
        [qwik._IMMUTABLE]: {
          contentId: qwik._fnSignal((p0) => {
            var _a2;
            return (_a2 = p0.builderContextSignal.content) == null ? void 0 : _a2.id;
          }, [
            state
          ], "p0.builderContextSignal.content?.id"),
          cssCode: qwik._fnSignal((p0) => {
            var _a2, _b2;
            return (_b2 = (_a2 = p0.builderContextSignal.content) == null ? void 0 : _a2.data) == null ? void 0 : _b2.cssCode;
          }, [
            state
          ], "p0.builderContextSignal.content?.data?.cssCode"),
          customFonts: qwik._fnSignal((p0) => {
            var _a2, _b2;
            return (_b2 = (_a2 = p0.builderContextSignal.content) == null ? void 0 : _a2.data) == null ? void 0 : _b2.customFonts;
          }, [
            state
          ], "p0.builderContextSignal.content?.data?.customFonts"),
          isNestedRender: qwik._fnSignal((p0) => p0.isNestedRender, [
            props
          ], "p0.isNestedRender")
        }
      }, 3, "LQ_1"),
      /* @__PURE__ */ qwik._jsxC(Blocks, {
        get blocks() {
          var _a2, _b2;
          return (_b2 = (_a2 = state.builderContextSignal.content) == null ? void 0 : _a2.data) == null ? void 0 : _b2.blocks;
        },
        get context() {
          return state.builderContextSignal;
        },
        get registeredComponents() {
          return state.registeredComponents;
        },
        get linkComponent() {
          return props.linkComponent;
        },
        [qwik._IMMUTABLE]: {
          blocks: qwik._fnSignal((p0) => {
            var _a2, _b2;
            return (_b2 = (_a2 = p0.builderContextSignal.content) == null ? void 0 : _a2.data) == null ? void 0 : _b2.blocks;
          }, [
            state
          ], "p0.builderContextSignal.content?.data?.blocks"),
          context: qwik._fnSignal((p0) => p0.builderContextSignal, [
            state
          ], "p0.builderContextSignal"),
          linkComponent: qwik._fnSignal((p0) => p0.linkComponent, [
            props
          ], "p0.linkComponent"),
          registeredComponents: qwik._fnSignal((p0) => p0.registeredComponents, [
            state
          ], "p0.registeredComponents")
        }
      }, 3, "LQ_2")
    ],
    [qwik._IMMUTABLE]: {
      apiKey: qwik._fnSignal((p0) => p0.apiKey, [
        props
      ], "p0.apiKey"),
      builderContextSignal: qwik._fnSignal((p0) => p0.builderContextSignal, [
        state
      ], "p0.builderContextSignal"),
      canTrack: qwik._fnSignal((p0) => p0.canTrack, [
        props
      ], "p0.canTrack"),
      content: qwik._fnSignal((p0) => p0.content, [
        props
      ], "p0.content"),
      contentWrapper: qwik._fnSignal((p0) => p0.contentWrapper, [
        props
      ], "p0.contentWrapper"),
      contentWrapperProps: qwik._fnSignal((p0) => p0.contentWrapperProps, [
        props
      ], "p0.contentWrapperProps"),
      context: qwik._fnSignal((p0) => p0.context, [
        props
      ], "p0.context"),
      data: qwik._fnSignal((p0) => p0.data, [
        props
      ], "p0.data"),
      enrich: qwik._fnSignal((p0) => p0.enrich, [
        props
      ], "p0.enrich"),
      linkComponent: qwik._fnSignal((p0) => p0.linkComponent, [
        props
      ], "p0.linkComponent"),
      locale: qwik._fnSignal((p0) => p0.locale, [
        props
      ], "p0.locale"),
      model: qwik._fnSignal((p0) => p0.model, [
        props
      ], "p0.model"),
      showContent: qwik._fnSignal((p0) => p0.showContent, [
        props
      ], "p0.showContent"),
      trustedHosts: qwik._fnSignal((p0) => p0.trustedHosts, [
        props
      ], "p0.trustedHosts")
    }
  }, 1, "LQ_3");
}, "ContentComponent_component_HIsczUcxjCE"));
const ContentVariants = /* @__PURE__ */ qwik.componentQrl(/* @__PURE__ */ qwik.inlinedQrl((props) => {
  qwik._jsxBranch();
  const state = qwik.useStore({
    shouldRenderVariants: checkShouldRenderVariants({
      canTrack: getDefaultCanTrack(props.canTrack),
      content: props.content
    })
  });
  const updateCookieAndStylesScriptStr = qwik.useComputedQrl(/* @__PURE__ */ qwik.inlinedQrl(() => {
    var _a;
    const [props2] = qwik.useLexicalScope();
    return getUpdateCookieAndStylesScript(getVariants(props2.content).map((value) => ({
      id: value.testVariationId,
      testRatio: value.testRatio
    })), ((_a = props2.content) == null ? void 0 : _a.id) || "");
  }, "ContentVariants_component_updateCookieAndStylesScriptStr_useComputed_FtJXWpnoDYg", [
    props
  ]));
  const hideVariantsStyleString = qwik.useComputedQrl(/* @__PURE__ */ qwik.inlinedQrl(() => {
    const [props2] = qwik.useLexicalScope();
    return getVariants(props2.content).map((value) => `.variant-${value.testVariationId} { display: none; } `).join("");
  }, "ContentVariants_component_hideVariantsStyleString_useComputed_fQIC0fJqAl4", [
    props
  ]));
  const defaultContent = qwik.useComputedQrl(/* @__PURE__ */ qwik.inlinedQrl(() => {
    var _a;
    const [props2, state2] = qwik.useLexicalScope();
    return state2.shouldRenderVariants ? {
      ...props2.content,
      testVariationId: (_a = props2.content) == null ? void 0 : _a.id
    } : handleABTestingSync({
      item: props2.content,
      canTrack: getDefaultCanTrack(props2.canTrack)
    });
  }, "ContentVariants_component_defaultContent_useComputed_00q2HQsQPYc", [
    props,
    state
  ]));
  return /* @__PURE__ */ qwik._jsxC(qwik.Fragment, {
    children: [
      !props.isNestedRender && TARGET !== "reactNative" ? /* @__PURE__ */ qwik._jsxC(InlinedScript, {
        id: "builderio-init-variants-fns",
        get scriptStr() {
          return getInitVariantsFnsScriptString();
        },
        [qwik._IMMUTABLE]: {
          id: qwik._IMMUTABLE,
          scriptStr: qwik._IMMUTABLE
        }
      }, 3, "XM_0") : null,
      state.shouldRenderVariants ? /* @__PURE__ */ qwik._jsxC(jsxRuntime.Fragment, {
        children: [
          /* @__PURE__ */ qwik._jsxC(InlinedStyles, {
            id: "builderio-variants",
            get styles() {
              return hideVariantsStyleString.value;
            },
            [qwik._IMMUTABLE]: {
              id: qwik._IMMUTABLE,
              styles: qwik._fnSignal((p0) => p0.value, [
                hideVariantsStyleString
              ], "p0.value")
            }
          }, 3, "XM_1"),
          /* @__PURE__ */ qwik._jsxC(InlinedScript, {
            id: "builderio-variants-visibility",
            get scriptStr() {
              return updateCookieAndStylesScriptStr.value;
            },
            [qwik._IMMUTABLE]: {
              id: qwik._IMMUTABLE,
              scriptStr: qwik._fnSignal((p0) => p0.value, [
                updateCookieAndStylesScriptStr
              ], "p0.value")
            }
          }, 3, "XM_2"),
          (getVariants(props.content) || []).map((variant) => {
            return /* @__PURE__ */ qwik._jsxC(ContentComponent, {
              get isNestedRender() {
                return props.isNestedRender;
              },
              content: variant,
              showContent: false,
              get model() {
                return props.model;
              },
              get data() {
                return props.data;
              },
              get context() {
                return props.context;
              },
              get apiKey() {
                return props.apiKey;
              },
              get apiVersion() {
                return props.apiVersion;
              },
              get customComponents() {
                return props.customComponents;
              },
              get linkComponent() {
                return props.linkComponent;
              },
              get canTrack() {
                return props.canTrack;
              },
              get locale() {
                return props.locale;
              },
              get enrich() {
                return props.enrich;
              },
              get isSsrAbTest() {
                return state.shouldRenderVariants;
              },
              get blocksWrapper() {
                return props.blocksWrapper;
              },
              get blocksWrapperProps() {
                return props.blocksWrapperProps;
              },
              get contentWrapper() {
                return props.contentWrapper;
              },
              get contentWrapperProps() {
                return props.contentWrapperProps;
              },
              get trustedHosts() {
                return props.trustedHosts;
              },
              [qwik._IMMUTABLE]: {
                apiKey: qwik._fnSignal((p0) => p0.apiKey, [
                  props
                ], "p0.apiKey"),
                apiVersion: qwik._fnSignal((p0) => p0.apiVersion, [
                  props
                ], "p0.apiVersion"),
                blocksWrapper: qwik._fnSignal((p0) => p0.blocksWrapper, [
                  props
                ], "p0.blocksWrapper"),
                blocksWrapperProps: qwik._fnSignal((p0) => p0.blocksWrapperProps, [
                  props
                ], "p0.blocksWrapperProps"),
                canTrack: qwik._fnSignal((p0) => p0.canTrack, [
                  props
                ], "p0.canTrack"),
                contentWrapper: qwik._fnSignal((p0) => p0.contentWrapper, [
                  props
                ], "p0.contentWrapper"),
                contentWrapperProps: qwik._fnSignal((p0) => p0.contentWrapperProps, [
                  props
                ], "p0.contentWrapperProps"),
                context: qwik._fnSignal((p0) => p0.context, [
                  props
                ], "p0.context"),
                customComponents: qwik._fnSignal((p0) => p0.customComponents, [
                  props
                ], "p0.customComponents"),
                data: qwik._fnSignal((p0) => p0.data, [
                  props
                ], "p0.data"),
                enrich: qwik._fnSignal((p0) => p0.enrich, [
                  props
                ], "p0.enrich"),
                isNestedRender: qwik._fnSignal((p0) => p0.isNestedRender, [
                  props
                ], "p0.isNestedRender"),
                isSsrAbTest: qwik._fnSignal((p0) => p0.shouldRenderVariants, [
                  state
                ], "p0.shouldRenderVariants"),
                linkComponent: qwik._fnSignal((p0) => p0.linkComponent, [
                  props
                ], "p0.linkComponent"),
                locale: qwik._fnSignal((p0) => p0.locale, [
                  props
                ], "p0.locale"),
                model: qwik._fnSignal((p0) => p0.model, [
                  props
                ], "p0.model"),
                showContent: qwik._IMMUTABLE,
                trustedHosts: qwik._fnSignal((p0) => p0.trustedHosts, [
                  props
                ], "p0.trustedHosts")
              }
            }, 3, variant.testVariationId);
          })
        ]
      }, 1, "XM_3") : null,
      /* @__PURE__ */ qwik._jsxC(ContentComponent, {
        get isNestedRender() {
          return props.isNestedRender;
        },
        get content() {
          return defaultContent.value;
        },
        showContent: true,
        get model() {
          return props.model;
        },
        get data() {
          return props.data;
        },
        get context() {
          return props.context;
        },
        get apiKey() {
          return props.apiKey;
        },
        get apiVersion() {
          return props.apiVersion;
        },
        get customComponents() {
          return props.customComponents;
        },
        get linkComponent() {
          return props.linkComponent;
        },
        get canTrack() {
          return props.canTrack;
        },
        get locale() {
          return props.locale;
        },
        get enrich() {
          return props.enrich;
        },
        get isSsrAbTest() {
          return state.shouldRenderVariants;
        },
        get blocksWrapper() {
          return props.blocksWrapper;
        },
        get blocksWrapperProps() {
          return props.blocksWrapperProps;
        },
        get contentWrapper() {
          return props.contentWrapper;
        },
        get contentWrapperProps() {
          return props.contentWrapperProps;
        },
        get trustedHosts() {
          return props.trustedHosts;
        },
        [qwik._IMMUTABLE]: {
          apiKey: qwik._fnSignal((p0) => p0.apiKey, [
            props
          ], "p0.apiKey"),
          apiVersion: qwik._fnSignal((p0) => p0.apiVersion, [
            props
          ], "p0.apiVersion"),
          blocksWrapper: qwik._fnSignal((p0) => p0.blocksWrapper, [
            props
          ], "p0.blocksWrapper"),
          blocksWrapperProps: qwik._fnSignal((p0) => p0.blocksWrapperProps, [
            props
          ], "p0.blocksWrapperProps"),
          canTrack: qwik._fnSignal((p0) => p0.canTrack, [
            props
          ], "p0.canTrack"),
          content: qwik._fnSignal((p0) => p0.value, [
            defaultContent
          ], "p0.value"),
          contentWrapper: qwik._fnSignal((p0) => p0.contentWrapper, [
            props
          ], "p0.contentWrapper"),
          contentWrapperProps: qwik._fnSignal((p0) => p0.contentWrapperProps, [
            props
          ], "p0.contentWrapperProps"),
          context: qwik._fnSignal((p0) => p0.context, [
            props
          ], "p0.context"),
          customComponents: qwik._fnSignal((p0) => p0.customComponents, [
            props
          ], "p0.customComponents"),
          data: qwik._fnSignal((p0) => p0.data, [
            props
          ], "p0.data"),
          enrich: qwik._fnSignal((p0) => p0.enrich, [
            props
          ], "p0.enrich"),
          isNestedRender: qwik._fnSignal((p0) => p0.isNestedRender, [
            props
          ], "p0.isNestedRender"),
          isSsrAbTest: qwik._fnSignal((p0) => p0.shouldRenderVariants, [
            state
          ], "p0.shouldRenderVariants"),
          linkComponent: qwik._fnSignal((p0) => p0.linkComponent, [
            props
          ], "p0.linkComponent"),
          locale: qwik._fnSignal((p0) => p0.locale, [
            props
          ], "p0.locale"),
          model: qwik._fnSignal((p0) => p0.model, [
            props
          ], "p0.model"),
          showContent: qwik._IMMUTABLE,
          trustedHosts: qwik._fnSignal((p0) => p0.trustedHosts, [
            props
          ], "p0.trustedHosts")
        }
      }, 3, "XM_4")
    ]
  }, 1, "XM_5");
}, "ContentVariants_component_4tFRiQMMEfM"));
const fetchSymbolContent = async ({ builderContextValue, symbol }) => {
  if ((symbol == null ? void 0 : symbol.model) && // This is a hack, we should not need to check for this, but it is needed for Svelte.
  (builderContextValue == null ? void 0 : builderContextValue.apiKey))
    return fetchOneEntry({
      model: symbol.model,
      apiKey: builderContextValue.apiKey,
      apiVersion: builderContextValue.apiVersion,
      ...(symbol == null ? void 0 : symbol.entry) && {
        query: {
          id: symbol.entry
        }
      }
    }).catch((err) => {
      logger.error("Could not fetch symbol content: ", err);
      return void 0;
    });
  return void 0;
};
const setContent = function setContent2(props, state, blocksWrapper, contentWrapper, className) {
  if (state.contentToUse)
    return;
  fetchSymbolContent({
    symbol: props.symbol,
    builderContextValue: props.builderContext
  }).then((newContent) => {
    if (newContent)
      state.contentToUse = newContent;
  });
};
const Symbol$1 = /* @__PURE__ */ qwik.componentQrl(/* @__PURE__ */ qwik.inlinedQrl((props) => {
  var _a;
  const blocksWrapper = qwik.useComputedQrl(/* @__PURE__ */ qwik.inlinedQrl(() => {
    return "div";
  }, "Symbol_component_blocksWrapper_useComputed_B5dlF985gMM"));
  const contentWrapper = qwik.useComputedQrl(/* @__PURE__ */ qwik.inlinedQrl(() => {
    return "div";
  }, "Symbol_component_contentWrapper_useComputed_EvmPpPj8JTo"));
  const className = qwik.useComputedQrl(/* @__PURE__ */ qwik.inlinedQrl(() => {
    var _a2, _b;
    const [props2] = qwik.useLexicalScope();
    return [
      props2.attributes[getClassPropName()],
      "builder-symbol",
      ((_a2 = props2.symbol) == null ? void 0 : _a2.inline) ? "builder-inline-symbol" : void 0,
      ((_b = props2.symbol) == null ? void 0 : _b.dynamic) || props2.dynamic ? "builder-dynamic-symbol" : void 0
    ].filter(Boolean).join(" ");
  }, "Symbol_component_className_useComputed_Wb6GqgtDHpE", [
    props
  ]));
  const state = qwik.useStore({
    contentToUse: (_a = props.symbol) == null ? void 0 : _a.content
  });
  qwik.useTaskQrl(/* @__PURE__ */ qwik.inlinedQrl(({ track: track2 }) => {
    const [blocksWrapper2, className2, contentWrapper2, props2, state2] = qwik.useLexicalScope();
    track2(() => props2.symbol);
    setContent(props2, state2);
  }, "Symbol_component_useTask_NIAWAC1bMBo", [
    blocksWrapper,
    className,
    contentWrapper,
    props,
    state
  ]));
  return /* @__PURE__ */ qwik._jsxS("div", {
    ...props.attributes,
    children: /* @__PURE__ */ qwik._jsxC(ContentVariants, {
      isNestedRender: true,
      get apiVersion() {
        return props.builderContext.apiVersion;
      },
      get apiKey() {
        return props.builderContext.apiKey;
      },
      get context() {
        var _a2;
        return {
          ...props.builderContext.context,
          symbolId: (_a2 = props.builderBlock) == null ? void 0 : _a2.id
        };
      },
      get customComponents() {
        return Object.values(props.builderComponents);
      },
      get data() {
        var _a2, _b, _c;
        return {
          ...(_a2 = props.symbol) == null ? void 0 : _a2.data,
          ...props.builderContext.localState,
          ...(_c = (_b = state.contentToUse) == null ? void 0 : _b.data) == null ? void 0 : _c.state
        };
      },
      get model() {
        var _a2;
        return (_a2 = props.symbol) == null ? void 0 : _a2.model;
      },
      get content() {
        return state.contentToUse;
      },
      get linkComponent() {
        return props.builderLinkComponent;
      },
      get blocksWrapper() {
        return blocksWrapper.value;
      },
      get contentWrapper() {
        return contentWrapper.value;
      },
      [qwik._IMMUTABLE]: {
        apiKey: qwik._fnSignal((p0) => p0.builderContext.apiKey, [
          props
        ], "p0.builderContext.apiKey"),
        apiVersion: qwik._fnSignal((p0) => p0.builderContext.apiVersion, [
          props
        ], "p0.builderContext.apiVersion"),
        blocksWrapper: qwik._fnSignal((p0) => p0.value, [
          blocksWrapper
        ], "p0.value"),
        content: qwik._fnSignal((p0) => p0.contentToUse, [
          state
        ], "p0.contentToUse"),
        contentWrapper: qwik._fnSignal((p0) => p0.value, [
          contentWrapper
        ], "p0.value"),
        context: qwik._fnSignal((p0) => {
          var _a2;
          return {
            ...p0.builderContext.context,
            symbolId: (_a2 = p0.builderBlock) == null ? void 0 : _a2.id
          };
        }, [
          props
        ], "{...p0.builderContext.context,symbolId:p0.builderBlock?.id}"),
        customComponents: qwik._fnSignal((p0) => Object.values(p0.builderComponents), [
          props
        ], "Object.values(p0.builderComponents)"),
        data: qwik._fnSignal((p0, p1) => {
          var _a2, _b, _c;
          return {
            ...(_a2 = p0.symbol) == null ? void 0 : _a2.data,
            ...p0.builderContext.localState,
            ...(_c = (_b = p1.contentToUse) == null ? void 0 : _b.data) == null ? void 0 : _c.state
          };
        }, [
          props,
          state
        ], "{...p0.symbol?.data,...p0.builderContext.localState,...p1.contentToUse?.data?.state}"),
        isNestedRender: qwik._IMMUTABLE,
        linkComponent: qwik._fnSignal((p0) => p0.builderLinkComponent, [
          props
        ], "p0.builderLinkComponent"),
        model: qwik._fnSignal((p0) => {
          var _a2;
          return (_a2 = p0.symbol) == null ? void 0 : _a2.model;
        }, [
          props
        ], "p0.symbol?.model")
      }
    }, 3, "Wt_0")
  }, {
    class: qwik._fnSignal((p0) => p0.value, [
      className
    ], "p0.value")
  }, 0, "Wt_1");
}, "Symbol_component_WVvggdkUPdk"));
const settings = {};
function setEditorSettings(newSettings) {
  if (isBrowser()) {
    Object.assign(settings, newSettings);
    const message = {
      type: "builder.settingsChange",
      data: settings
    };
    parent.postMessage(message, "*");
  }
}
const fetchBuilderProps = async (_args) => {
  var _a, _b, _c;
  const urlPath = _args.path || ((_a = _args.url) == null ? void 0 : _a.pathname) || ((_b = _args.userAttributes) == null ? void 0 : _b.urlPath);
  const getContentArgs = {
    ..._args,
    apiKey: _args.apiKey,
    model: _args.model || "page",
    userAttributes: {
      ..._args.userAttributes,
      ...urlPath ? {
        urlPath
      } : {}
    },
    options: getBuilderSearchParams(_args.searchParams || ((_c = _args.url) == null ? void 0 : _c.searchParams) || _args.options)
  };
  return {
    apiKey: getContentArgs.apiKey,
    model: getContentArgs.model,
    content: await fetchOneEntry(getContentArgs)
  };
};
exports.Blocks = Blocks;
exports.BuilderContext = builderContext;
exports.Button = Button;
exports.Columns = Columns;
exports.Content = ContentVariants;
exports.Fragment = FragmentComponent;
exports.Image = Image;
exports.Section = SectionComponent;
exports.Symbol = Symbol$1;
exports.Text = Text;
exports.Video = Video;
exports._processContentResult = _processContentResult;
exports.createRegisterComponentMessage = createRegisterComponentMessage;
exports.fetchBuilderProps = fetchBuilderProps;
exports.fetchEntries = fetchEntries;
exports.fetchOneEntry = fetchOneEntry;
exports.getBuilderSearchParams = getBuilderSearchParams;
exports.isEditing = isEditing;
exports.isPreviewing = isPreviewing;
exports.register = register;
exports.setEditorSettings = setEditorSettings;
exports.subscribeToEditor = subscribeToEditor;
exports.track = track;
